/* DateTime.c generated by valac 0.56.13, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 * Copyright 2012-2017 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <glib-object.h>
#include <gio/gio.h>

#define GRANITE_GETTEXT_PACKAGE "granite"

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GRANITE_PORTAL_TYPE_SETTINGS (granite_portal_settings_get_type ())
#define GRANITE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettings))
#define GRANITE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_PORTAL_TYPE_SETTINGS))
#define GRANITE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettingsIface))

typedef struct _GranitePortalSettings GranitePortalSettings;
typedef struct _GranitePortalSettingsIface GranitePortalSettingsIface;

#define GRANITE_PORTAL_TYPE_SETTINGS_PROXY (granite_portal_settings_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GranitePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (GranitePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (GranitePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

 G_GNUC_INTERNAL gboolean granite_date_time_is_clock_format_12h (void);
VALA_EXTERN GType granite_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
 G_GNUC_INTERNAL guint granite_portal_settings_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
 G_GNUC_INTERNAL GType granite_portal_settings_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL GranitePortalSettings* granite_portal_settings_get (GError** error);
 G_GNUC_INTERNAL GVariant* granite_portal_settings_read (GranitePortalSettings* self,
                                        const gchar* namespace,
                                        const gchar* key,
                                        GError** error);

/**
     * Gets a default translated time format.
     * The function constructs a new string interpreting the //is_12h// and //with_second// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * The returned string is formatted and translated. This function is mostly used to display
     * the time in various user interfaces like the time displayed in the top panel.
     *
     * @param is_12h if the returned string should be formatted in 12h format
     * @param with_second if the returned string should include seconds
     *
     * @return the formatted and located time string.
     */
gchar*
granite_date_time_get_default_time_format (gboolean is_12h,
                                           gboolean with_second)
{
	gchar* result;
#line 25 "../lib/DateTime.vala"
	if (is_12h == TRUE) {
#line 26 "../lib/DateTime.vala"
		if (with_second == TRUE) {
#line 79 "DateTime.c"
			gchar* _tmp0_;
#line 28 "../lib/DateTime.vala"
			_tmp0_ = g_strdup (_ ("%-l:%M:%S %p"));
#line 28 "../lib/DateTime.vala"
			result = _tmp0_;
#line 28 "../lib/DateTime.vala"
			return result;
#line 87 "DateTime.c"
		} else {
			gchar* _tmp1_;
#line 31 "../lib/DateTime.vala"
			_tmp1_ = g_strdup (_ ("%-l:%M %p"));
#line 31 "../lib/DateTime.vala"
			result = _tmp1_;
#line 31 "../lib/DateTime.vala"
			return result;
#line 96 "DateTime.c"
		}
	} else {
#line 34 "../lib/DateTime.vala"
		if (with_second == TRUE) {
#line 101 "DateTime.c"
			gchar* _tmp2_;
#line 36 "../lib/DateTime.vala"
			_tmp2_ = g_strdup (_ ("%H:%M:%S"));
#line 36 "../lib/DateTime.vala"
			result = _tmp2_;
#line 36 "../lib/DateTime.vala"
			return result;
#line 109 "DateTime.c"
		} else {
			gchar* _tmp3_;
#line 39 "../lib/DateTime.vala"
			_tmp3_ = g_strdup (_ ("%H:%M"));
#line 39 "../lib/DateTime.vala"
			result = _tmp3_;
#line 39 "../lib/DateTime.vala"
			return result;
#line 118 "DateTime.c"
		}
	}
}

/**
     * Compares a {@link GLib.DateTime} to {@link GLib.DateTime.now_local} and returns a location, relative date and
     * time string. Results appear as natural-language strings like "Now", "5m ago", "Yesterday"
     *
     * @param date_time a {@link GLib.DateTime} to compare against {@link GLib.DateTime.now_local}
     *
     * @return a localized, relative date and time string
     */
gchar*
granite_date_time_get_relative_datetime (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* result;
#line 52 "../lib/DateTime.vala"
	g_return_val_if_fail (date_time != NULL, NULL);
#line 53 "../lib/DateTime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 53 "../lib/DateTime.vala"
	now = _tmp0_;
#line 54 "../lib/DateTime.vala"
	_tmp1_ = now;
#line 54 "../lib/DateTime.vala"
	diff = g_date_time_difference (_tmp1_, date_time);
#line 56 "../lib/DateTime.vala"
	_tmp2_ = now;
#line 56 "../lib/DateTime.vala"
	if (granite_date_time_is_same_day (date_time, _tmp2_)) {
#line 154 "DateTime.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 57 "../lib/DateTime.vala"
		if (diff > ((GTimeSpan) 0)) {
#line 58 "../lib/DateTime.vala"
			if (diff < G_TIME_SPAN_MINUTE) {
#line 163 "DateTime.c"
				gchar* _tmp3_;
#line 59 "../lib/DateTime.vala"
				_tmp3_ = g_strdup (_ ("Now"));
#line 59 "../lib/DateTime.vala"
				result = _tmp3_;
#line 59 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 59 "../lib/DateTime.vala"
				return result;
#line 173 "DateTime.c"
			} else {
#line 60 "../lib/DateTime.vala"
				if (diff < G_TIME_SPAN_HOUR) {
#line 177 "DateTime.c"
					GTimeSpan minutes = 0LL;
					gchar* _tmp4_;
#line 61 "../lib/DateTime.vala"
					minutes = diff / G_TIME_SPAN_MINUTE;
#line 62 "../lib/DateTime.vala"
					_tmp4_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "%dm ago", "%dm ago", (gulong) minutes), (gint) minutes);
#line 62 "../lib/DateTime.vala"
					result = _tmp4_;
#line 62 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 62 "../lib/DateTime.vala"
					return result;
#line 190 "DateTime.c"
				} else {
#line 63 "../lib/DateTime.vala"
					if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 194 "DateTime.c"
						gint rounded = 0;
						gchar* _tmp5_;
#line 64 "../lib/DateTime.vala"
						rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 65 "../lib/DateTime.vala"
						_tmp5_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "%dh ago", "%dh ago", (gulong) rounded), rounded);
#line 65 "../lib/DateTime.vala"
						result = _tmp5_;
#line 65 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 65 "../lib/DateTime.vala"
						return result;
#line 207 "DateTime.c"
					}
				}
			}
		} else {
#line 68 "../lib/DateTime.vala"
			diff = -1 * diff;
#line 69 "../lib/DateTime.vala"
			if (diff < G_TIME_SPAN_HOUR) {
#line 216 "DateTime.c"
				GTimeSpan minutes = 0LL;
				gchar* _tmp6_;
#line 70 "../lib/DateTime.vala"
				minutes = diff / G_TIME_SPAN_MINUTE;
#line 71 "../lib/DateTime.vala"
				_tmp6_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "in %dm", "in %dm", (gulong) minutes), (gint) minutes);
#line 71 "../lib/DateTime.vala"
				result = _tmp6_;
#line 71 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 71 "../lib/DateTime.vala"
				return result;
#line 229 "DateTime.c"
			} else {
#line 72 "../lib/DateTime.vala"
				if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 233 "DateTime.c"
					gint rounded = 0;
					gchar* _tmp7_;
#line 73 "../lib/DateTime.vala"
					rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 74 "../lib/DateTime.vala"
					_tmp7_ = g_strdup_printf (g_dngettext (GRANITE_GETTEXT_PACKAGE, "in %dh", "in %dh", (gulong) rounded), rounded);
#line 74 "../lib/DateTime.vala"
					result = _tmp7_;
#line 74 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 74 "../lib/DateTime.vala"
					return result;
#line 246 "DateTime.c"
				}
			}
		}
#line 78 "../lib/DateTime.vala"
		_tmp8_ = granite_date_time_get_default_time_format (granite_date_time_is_clock_format_12h (), FALSE);
#line 78 "../lib/DateTime.vala"
		_tmp9_ = _tmp8_;
#line 78 "../lib/DateTime.vala"
		_tmp10_ = g_date_time_format (date_time, _tmp9_);
#line 78 "../lib/DateTime.vala"
		_tmp11_ = _tmp10_;
#line 78 "../lib/DateTime.vala"
		_g_free0 (_tmp9_);
#line 78 "../lib/DateTime.vala"
		result = _tmp11_;
#line 78 "../lib/DateTime.vala"
		_g_date_time_unref0 (now);
#line 78 "../lib/DateTime.vala"
		return result;
#line 266 "DateTime.c"
	} else {
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		gboolean _tmp15_;
#line 79 "../lib/DateTime.vala"
		_tmp12_ = g_date_time_add_days (date_time, 1);
#line 79 "../lib/DateTime.vala"
		_tmp13_ = _tmp12_;
#line 79 "../lib/DateTime.vala"
		_tmp14_ = now;
#line 79 "../lib/DateTime.vala"
		_tmp15_ = granite_date_time_is_same_day (_tmp13_, _tmp14_);
#line 79 "../lib/DateTime.vala"
		_g_date_time_unref0 (_tmp13_);
#line 79 "../lib/DateTime.vala"
		if (_tmp15_) {
#line 284 "DateTime.c"
			gchar* _tmp16_;
#line 80 "../lib/DateTime.vala"
			_tmp16_ = g_strdup (_ ("Yesterday"));
#line 80 "../lib/DateTime.vala"
			result = _tmp16_;
#line 80 "../lib/DateTime.vala"
			_g_date_time_unref0 (now);
#line 80 "../lib/DateTime.vala"
			return result;
#line 294 "DateTime.c"
		} else {
			GDateTime* _tmp17_;
			GDateTime* _tmp18_;
			GDateTime* _tmp19_;
			gboolean _tmp20_;
#line 81 "../lib/DateTime.vala"
			_tmp17_ = g_date_time_add_days (date_time, -1);
#line 81 "../lib/DateTime.vala"
			_tmp18_ = _tmp17_;
#line 81 "../lib/DateTime.vala"
			_tmp19_ = now;
#line 81 "../lib/DateTime.vala"
			_tmp20_ = granite_date_time_is_same_day (_tmp18_, _tmp19_);
#line 81 "../lib/DateTime.vala"
			_g_date_time_unref0 (_tmp18_);
#line 81 "../lib/DateTime.vala"
			if (_tmp20_) {
#line 312 "DateTime.c"
				gchar* _tmp21_;
#line 82 "../lib/DateTime.vala"
				_tmp21_ = g_strdup (_ ("Tomorrow"));
#line 82 "../lib/DateTime.vala"
				result = _tmp21_;
#line 82 "../lib/DateTime.vala"
				_g_date_time_unref0 (now);
#line 82 "../lib/DateTime.vala"
				return result;
#line 322 "DateTime.c"
			} else {
				gboolean _tmp22_ = FALSE;
#line 83 "../lib/DateTime.vala"
				if (diff < (6 * G_TIME_SPAN_DAY)) {
#line 83 "../lib/DateTime.vala"
					_tmp22_ = diff > (-6 * G_TIME_SPAN_DAY);
#line 329 "DateTime.c"
				} else {
#line 83 "../lib/DateTime.vala"
					_tmp22_ = FALSE;
#line 333 "DateTime.c"
				}
#line 83 "../lib/DateTime.vala"
				if (_tmp22_) {
#line 337 "DateTime.c"
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 84 "../lib/DateTime.vala"
					_tmp23_ = granite_date_time_get_default_date_format (TRUE, FALSE, FALSE);
#line 84 "../lib/DateTime.vala"
					_tmp24_ = _tmp23_;
#line 84 "../lib/DateTime.vala"
					_tmp25_ = g_date_time_format (date_time, _tmp24_);
#line 84 "../lib/DateTime.vala"
					_tmp26_ = _tmp25_;
#line 84 "../lib/DateTime.vala"
					_g_free0 (_tmp24_);
#line 84 "../lib/DateTime.vala"
					result = _tmp26_;
#line 84 "../lib/DateTime.vala"
					_g_date_time_unref0 (now);
#line 84 "../lib/DateTime.vala"
					return result;
#line 358 "DateTime.c"
				} else {
					GDateTime* _tmp27_;
#line 85 "../lib/DateTime.vala"
					_tmp27_ = now;
#line 85 "../lib/DateTime.vala"
					if (g_date_time_get_year (date_time) == g_date_time_get_year (_tmp27_)) {
#line 365 "DateTime.c"
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 86 "../lib/DateTime.vala"
						_tmp28_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
#line 86 "../lib/DateTime.vala"
						_tmp29_ = _tmp28_;
#line 86 "../lib/DateTime.vala"
						_tmp30_ = g_date_time_format (date_time, _tmp29_);
#line 86 "../lib/DateTime.vala"
						_tmp31_ = _tmp30_;
#line 86 "../lib/DateTime.vala"
						_g_free0 (_tmp29_);
#line 86 "../lib/DateTime.vala"
						result = _tmp31_;
#line 86 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 86 "../lib/DateTime.vala"
						return result;
#line 386 "DateTime.c"
					} else {
						gchar* _tmp32_;
#line 88 "../lib/DateTime.vala"
						_tmp32_ = g_date_time_format (date_time, "%x");
#line 88 "../lib/DateTime.vala"
						result = _tmp32_;
#line 88 "../lib/DateTime.vala"
						_g_date_time_unref0 (now);
#line 88 "../lib/DateTime.vala"
						return result;
#line 397 "DateTime.c"
					}
				}
			}
		}
	}
}

/**
     * Gets the //clock-format// key from //org.gnome.desktop.interface// schema
     * and determines if the clock format is 12h based
     *
     * @return true if the clock format is 12h based, false otherwise.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 427 "DateTime.c"
}

 G_GNUC_INTERNAL gboolean
granite_date_time_is_clock_format_12h (void)
{
	gchar* format = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp15_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 99 "../lib/DateTime.vala"
	format = NULL;
#line 440 "DateTime.c"
	{
		GranitePortalSettings* portal = NULL;
		GranitePortalSettings* _tmp0_;
		GVariant* _tmp1_ = NULL;
		GranitePortalSettings* _tmp2_;
		GVariant* _tmp3_;
		GVariant* variant = NULL;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 101 "../lib/DateTime.vala"
		_tmp0_ = granite_portal_settings_get (&_inner_error0_);
#line 101 "../lib/DateTime.vala"
		portal = _tmp0_;
#line 101 "../lib/DateTime.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 458 "DateTime.c"
			goto __catch0_g_error;
		}
#line 102 "../lib/DateTime.vala"
		_tmp2_ = portal;
#line 102 "../lib/DateTime.vala"
		_tmp3_ = granite_portal_settings_read (_tmp2_, "org.gnome.desktop.interface", "clock-format", &_inner_error0_);
#line 102 "../lib/DateTime.vala"
		_tmp1_ = _tmp3_;
#line 102 "../lib/DateTime.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../lib/DateTime.vala"
			_g_object_unref0 (portal);
#line 471 "DateTime.c"
			goto __catch0_g_error;
		}
#line 102 "../lib/DateTime.vala"
		_tmp4_ = g_variant_get_variant (_tmp1_);
#line 102 "../lib/DateTime.vala"
		variant = _tmp4_;
#line 103 "../lib/DateTime.vala"
		_tmp5_ = variant;
#line 103 "../lib/DateTime.vala"
		_tmp6_ = g_variant_get_string (_tmp5_, NULL);
#line 103 "../lib/DateTime.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 103 "../lib/DateTime.vala"
		_g_free0 (format);
#line 103 "../lib/DateTime.vala"
		format = _tmp7_;
#line 100 "../lib/DateTime.vala"
		_g_variant_unref0 (variant);
#line 100 "../lib/DateTime.vala"
		_g_variant_unref0 (_tmp1_);
#line 100 "../lib/DateTime.vala"
		_g_object_unref0 (portal);
#line 494 "DateTime.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 100 "../lib/DateTime.vala"
		e = _inner_error0_;
#line 100 "../lib/DateTime.vala"
		_inner_error0_ = NULL;
#line 105 "../lib/DateTime.vala"
		_tmp8_ = e;
#line 105 "../lib/DateTime.vala"
		_tmp9_ = _tmp8_->message;
#line 105 "../lib/DateTime.vala"
		g_debug ("DateTime.vala:105: cannot use portal, using GSettings: %s", _tmp9_);
#line 100 "../lib/DateTime.vala"
		_g_error_free0 (e);
#line 514 "DateTime.c"
	}
	__finally0:
#line 100 "../lib/DateTime.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 519 "DateTime.c"
		gboolean _tmp10_ = FALSE;
#line 100 "../lib/DateTime.vala"
		_g_free0 (format);
#line 100 "../lib/DateTime.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../lib/DateTime.vala"
		g_clear_error (&_inner_error0_);
#line 100 "../lib/DateTime.vala"
		return _tmp10_;
#line 529 "DateTime.c"
	}
#line 108 "../lib/DateTime.vala"
	_tmp11_ = format;
#line 108 "../lib/DateTime.vala"
	if (_tmp11_ == NULL) {
#line 535 "DateTime.c"
		GSettings* h24_settings = NULL;
		GSettings* _tmp12_;
		GSettings* _tmp13_;
		gchar* _tmp14_;
#line 109 "../lib/DateTime.vala"
		_tmp12_ = g_settings_new ("org.gnome.desktop.interface");
#line 109 "../lib/DateTime.vala"
		h24_settings = _tmp12_;
#line 110 "../lib/DateTime.vala"
		_tmp13_ = h24_settings;
#line 110 "../lib/DateTime.vala"
		_tmp14_ = g_settings_get_string (_tmp13_, "clock-format");
#line 110 "../lib/DateTime.vala"
		_g_free0 (format);
#line 110 "../lib/DateTime.vala"
		format = _tmp14_;
#line 108 "../lib/DateTime.vala"
		_g_object_unref0 (h24_settings);
#line 554 "DateTime.c"
	}
#line 113 "../lib/DateTime.vala"
	_tmp15_ = format;
#line 113 "../lib/DateTime.vala"
	result = string_contains (_tmp15_, "12h");
#line 113 "../lib/DateTime.vala"
	_g_free0 (format);
#line 113 "../lib/DateTime.vala"
	return result;
#line 564 "DateTime.c"
}

/**
     * Compare two {@link GLib.DateTime} and return true if they occur on the same day of the same year
     *
     * @param day1 a {@link GLib.DateTime} to compare against day2
     * @param day2 a {@link GLib.DateTime} to compare against day1
     *
     * @return true if day1 and day2 occur on the same day of the same year. False otherwise
     */
gboolean
granite_date_time_is_same_day (GDateTime* day1,
                               GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 124 "../lib/DateTime.vala"
	g_return_val_if_fail (day1 != NULL, FALSE);
#line 124 "../lib/DateTime.vala"
	g_return_val_if_fail (day2 != NULL, FALSE);
#line 125 "../lib/DateTime.vala"
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
#line 125 "../lib/DateTime.vala"
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
#line 589 "DateTime.c"
	} else {
#line 125 "../lib/DateTime.vala"
		_tmp0_ = FALSE;
#line 593 "DateTime.c"
	}
#line 125 "../lib/DateTime.vala"
	result = _tmp0_;
#line 125 "../lib/DateTime.vala"
	return result;
#line 599 "DateTime.c"
}

/**
     * Gets the default translated date format.
     * The function constructs a new string interpreting the //with_weekday//, //with_day// and //with_year// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * As the {@link Granite.DateTime.get_default_time_format}, the returned string is formatted, translated and is also mostly used to display
     * the date in various user interfaces like the date displayed in the top panel.
     *
     * @param with_weekday if the returned string should contain the abbreviated weekday name
     * @param with_day if the returned string should contain contain the day of the month as a decimal number (range 1 to 31)
     * @param with_year if the returned string should contain the year as a decimal number including the century
     *
     * @return returns the formatted and located date string. If for some reason, the function could not determine the format to use,
     *         an empty string will be returned.
     */
gchar*
granite_date_time_get_default_date_format (gboolean with_weekday,
                                           gboolean with_day,
                                           gboolean with_year)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp24_;
	gchar* result;
#line 144 "../lib/DateTime.vala"
	if (with_weekday == TRUE) {
#line 144 "../lib/DateTime.vala"
		_tmp1_ = with_day == TRUE;
#line 630 "DateTime.c"
	} else {
#line 144 "../lib/DateTime.vala"
		_tmp1_ = FALSE;
#line 634 "DateTime.c"
	}
#line 144 "../lib/DateTime.vala"
	if (_tmp1_) {
#line 144 "../lib/DateTime.vala"
		_tmp0_ = with_year == TRUE;
#line 640 "DateTime.c"
	} else {
#line 144 "../lib/DateTime.vala"
		_tmp0_ = FALSE;
#line 644 "DateTime.c"
	}
#line 144 "../lib/DateTime.vala"
	if (_tmp0_) {
#line 648 "DateTime.c"
		gchar* _tmp2_;
#line 146 "../lib/DateTime.vala"
		_tmp2_ = g_strdup (_ ("%a, %b %e, %Y"));
#line 146 "../lib/DateTime.vala"
		result = _tmp2_;
#line 146 "../lib/DateTime.vala"
		return result;
#line 656 "DateTime.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 147 "../lib/DateTime.vala"
		if (with_weekday == FALSE) {
#line 147 "../lib/DateTime.vala"
			_tmp4_ = with_day == TRUE;
#line 664 "DateTime.c"
		} else {
#line 147 "../lib/DateTime.vala"
			_tmp4_ = FALSE;
#line 668 "DateTime.c"
		}
#line 147 "../lib/DateTime.vala"
		if (_tmp4_) {
#line 147 "../lib/DateTime.vala"
			_tmp3_ = with_year == TRUE;
#line 674 "DateTime.c"
		} else {
#line 147 "../lib/DateTime.vala"
			_tmp3_ = FALSE;
#line 678 "DateTime.c"
		}
#line 147 "../lib/DateTime.vala"
		if (_tmp3_) {
#line 682 "DateTime.c"
			gchar* _tmp5_;
#line 149 "../lib/DateTime.vala"
			_tmp5_ = g_strdup (_ ("%b %e %Y"));
#line 149 "../lib/DateTime.vala"
			result = _tmp5_;
#line 149 "../lib/DateTime.vala"
			return result;
#line 690 "DateTime.c"
		} else {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 150 "../lib/DateTime.vala"
			if (with_weekday == FALSE) {
#line 150 "../lib/DateTime.vala"
				_tmp7_ = with_day == FALSE;
#line 698 "DateTime.c"
			} else {
#line 150 "../lib/DateTime.vala"
				_tmp7_ = FALSE;
#line 702 "DateTime.c"
			}
#line 150 "../lib/DateTime.vala"
			if (_tmp7_) {
#line 150 "../lib/DateTime.vala"
				_tmp6_ = with_year == TRUE;
#line 708 "DateTime.c"
			} else {
#line 150 "../lib/DateTime.vala"
				_tmp6_ = FALSE;
#line 712 "DateTime.c"
			}
#line 150 "../lib/DateTime.vala"
			if (_tmp6_) {
#line 716 "DateTime.c"
				gchar* _tmp8_;
#line 152 "../lib/DateTime.vala"
				_tmp8_ = g_strdup (_ ("%Y"));
#line 152 "../lib/DateTime.vala"
				result = _tmp8_;
#line 152 "../lib/DateTime.vala"
				return result;
#line 724 "DateTime.c"
			} else {
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 153 "../lib/DateTime.vala"
				if (with_weekday == FALSE) {
#line 153 "../lib/DateTime.vala"
					_tmp10_ = with_day == TRUE;
#line 732 "DateTime.c"
				} else {
#line 153 "../lib/DateTime.vala"
					_tmp10_ = FALSE;
#line 736 "DateTime.c"
				}
#line 153 "../lib/DateTime.vala"
				if (_tmp10_) {
#line 153 "../lib/DateTime.vala"
					_tmp9_ = with_year == FALSE;
#line 742 "DateTime.c"
				} else {
#line 153 "../lib/DateTime.vala"
					_tmp9_ = FALSE;
#line 746 "DateTime.c"
				}
#line 153 "../lib/DateTime.vala"
				if (_tmp9_) {
#line 750 "DateTime.c"
					gchar* _tmp11_;
#line 155 "../lib/DateTime.vala"
					_tmp11_ = g_strdup (_ ("%b %e"));
#line 155 "../lib/DateTime.vala"
					result = _tmp11_;
#line 155 "../lib/DateTime.vala"
					return result;
#line 758 "DateTime.c"
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
#line 156 "../lib/DateTime.vala"
					if (with_weekday == TRUE) {
#line 156 "../lib/DateTime.vala"
						_tmp13_ = with_day == FALSE;
#line 766 "DateTime.c"
					} else {
#line 156 "../lib/DateTime.vala"
						_tmp13_ = FALSE;
#line 770 "DateTime.c"
					}
#line 156 "../lib/DateTime.vala"
					if (_tmp13_) {
#line 156 "../lib/DateTime.vala"
						_tmp12_ = with_year == TRUE;
#line 776 "DateTime.c"
					} else {
#line 156 "../lib/DateTime.vala"
						_tmp12_ = FALSE;
#line 780 "DateTime.c"
					}
#line 156 "../lib/DateTime.vala"
					if (_tmp12_) {
#line 784 "DateTime.c"
						gchar* _tmp14_;
#line 158 "../lib/DateTime.vala"
						_tmp14_ = g_strdup (_ ("%a %Y"));
#line 158 "../lib/DateTime.vala"
						result = _tmp14_;
#line 158 "../lib/DateTime.vala"
						return result;
#line 792 "DateTime.c"
					} else {
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
#line 159 "../lib/DateTime.vala"
						if (with_weekday == TRUE) {
#line 159 "../lib/DateTime.vala"
							_tmp16_ = with_day == FALSE;
#line 800 "DateTime.c"
						} else {
#line 159 "../lib/DateTime.vala"
							_tmp16_ = FALSE;
#line 804 "DateTime.c"
						}
#line 159 "../lib/DateTime.vala"
						if (_tmp16_) {
#line 159 "../lib/DateTime.vala"
							_tmp15_ = with_year == FALSE;
#line 810 "DateTime.c"
						} else {
#line 159 "../lib/DateTime.vala"
							_tmp15_ = FALSE;
#line 814 "DateTime.c"
						}
#line 159 "../lib/DateTime.vala"
						if (_tmp15_) {
#line 818 "DateTime.c"
							gchar* _tmp17_;
#line 161 "../lib/DateTime.vala"
							_tmp17_ = g_strdup (_ ("%a"));
#line 161 "../lib/DateTime.vala"
							result = _tmp17_;
#line 161 "../lib/DateTime.vala"
							return result;
#line 826 "DateTime.c"
						} else {
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
#line 162 "../lib/DateTime.vala"
							if (with_weekday == TRUE) {
#line 162 "../lib/DateTime.vala"
								_tmp19_ = with_day == TRUE;
#line 834 "DateTime.c"
							} else {
#line 162 "../lib/DateTime.vala"
								_tmp19_ = FALSE;
#line 838 "DateTime.c"
							}
#line 162 "../lib/DateTime.vala"
							if (_tmp19_) {
#line 162 "../lib/DateTime.vala"
								_tmp18_ = with_year == FALSE;
#line 844 "DateTime.c"
							} else {
#line 162 "../lib/DateTime.vala"
								_tmp18_ = FALSE;
#line 848 "DateTime.c"
							}
#line 162 "../lib/DateTime.vala"
							if (_tmp18_) {
#line 852 "DateTime.c"
								gchar* _tmp20_;
#line 164 "../lib/DateTime.vala"
								_tmp20_ = g_strdup (_ ("%a, %b %e"));
#line 164 "../lib/DateTime.vala"
								result = _tmp20_;
#line 164 "../lib/DateTime.vala"
								return result;
#line 860 "DateTime.c"
							} else {
								gboolean _tmp21_ = FALSE;
								gboolean _tmp22_ = FALSE;
#line 165 "../lib/DateTime.vala"
								if (with_weekday == FALSE) {
#line 165 "../lib/DateTime.vala"
									_tmp22_ = with_day == FALSE;
#line 868 "DateTime.c"
								} else {
#line 165 "../lib/DateTime.vala"
									_tmp22_ = FALSE;
#line 872 "DateTime.c"
								}
#line 165 "../lib/DateTime.vala"
								if (_tmp22_) {
#line 165 "../lib/DateTime.vala"
									_tmp21_ = with_year == FALSE;
#line 878 "DateTime.c"
								} else {
#line 165 "../lib/DateTime.vala"
									_tmp21_ = FALSE;
#line 882 "DateTime.c"
								}
#line 165 "../lib/DateTime.vala"
								if (_tmp21_) {
#line 886 "DateTime.c"
									gchar* _tmp23_;
#line 167 "../lib/DateTime.vala"
									_tmp23_ = g_strdup (_ ("%b"));
#line 167 "../lib/DateTime.vala"
									result = _tmp23_;
#line 167 "../lib/DateTime.vala"
									return result;
#line 894 "DateTime.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 170 "../lib/DateTime.vala"
	_tmp24_ = g_strdup ("");
#line 170 "../lib/DateTime.vala"
	result = _tmp24_;
#line 170 "../lib/DateTime.vala"
	return result;
#line 909 "DateTime.c"
}

/**
     * Converts seconds into the ISO 8601 standard date format for minutes (e.g. 100s to 01:40).
     * Output of negative seconds is prepended with minus character.
     *
     * @param seconds the number of seconds to convert into ISO 8601
     *
     * @return returns an ISO 8601 formatted string
     */
gchar*
granite_date_time_seconds_to_time (gint seconds)
{
	gint sign = 0;
	gint hours = 0;
	gint min = 0;
	gint sec = 0;
	gchar* result;
#line 182 "../lib/DateTime.vala"
	sign = 1;
#line 183 "../lib/DateTime.vala"
	if (seconds < 0) {
#line 184 "../lib/DateTime.vala"
		seconds = -seconds;
#line 185 "../lib/DateTime.vala"
		sign = -1;
#line 936 "DateTime.c"
	}
#line 188 "../lib/DateTime.vala"
	hours = seconds / 3600;
#line 189 "../lib/DateTime.vala"
	min = (seconds % 3600) / 60;
#line 190 "../lib/DateTime.vala"
	sec = seconds % 60;
#line 192 "../lib/DateTime.vala"
	if (hours > 0) {
#line 946 "DateTime.c"
		gchar* _tmp0_;
#line 193 "../lib/DateTime.vala"
		_tmp0_ = g_strdup_printf ("%d:%02d:%02d", sign * hours, min, sec);
#line 193 "../lib/DateTime.vala"
		result = _tmp0_;
#line 193 "../lib/DateTime.vala"
		return result;
#line 954 "DateTime.c"
	} else {
		gchar* _tmp1_;
#line 195 "../lib/DateTime.vala"
		_tmp1_ = g_strdup_printf ("%02d:%02d", sign * min, sec);
#line 195 "../lib/DateTime.vala"
		result = _tmp1_;
#line 195 "../lib/DateTime.vala"
		return result;
#line 963 "DateTime.c"
	}
}

