/* BufferSurface.c generated by valac 0.56.13, the Vala compiler
 * generated from BufferSurface.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 * Copyright 2011-2013 Robert Dyer
 * Copyright 2011-2013 Rico Tzschichholz <ricotz@ubuntu.com>
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite.h"
#include <cairo-gobject.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>

#define GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION 16
#define GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION 7

enum  {
	GRANITE_DRAWING_BUFFER_SURFACE_0_PROPERTY,
	GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY,
	GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY,
	GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY,
	GRANITE_DRAWING_BUFFER_SURFACE_CONTEXT_PROPERTY,
	GRANITE_DRAWING_BUFFER_SURFACE_NUM_PROPERTIES
};
static GParamSpec* granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteDrawingBufferSurfacePrivate {
	cairo_surface_t* _surface;
	gint _width;
	gint _height;
	cairo_t* _context;
};

struct _Block1Data {
	int _ref_count_;
	GraniteDrawingBufferSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block2Data {
	int _ref_count_;
	GraniteDrawingBufferSurface* self;
	gint gauss_width;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* buffer_a;
	gint buffer_a_length1;
	gint _buffer_a_size_;
	gdouble* buffer_b;
	gint buffer_b_length1;
	gint _buffer_b_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};

static gint GraniteDrawingBufferSurface_private_offset;
static gpointer granite_drawing_buffer_surface_parent_class = NULL;

static void granite_drawing_buffer_surface_set_surface (GraniteDrawingBufferSurface* self,
                                                 cairo_surface_t* value);
static void granite_drawing_buffer_surface_set_width (GraniteDrawingBufferSurface* self,
                                               gint value);
static void granite_drawing_buffer_surface_set_height (GraniteDrawingBufferSurface* self,
                                                gint value);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void* ___lambda4_ (Block1Data* _data1_);
static void granite_drawing_buffer_surface_exponential_blur_rows (GraniteDrawingBufferSurface* self,
                                                           guint8* pixels,
                                                           gint width,
                                                           gint height,
                                                           gint start_row,
                                                           gint end_row,
                                                           gint start_x,
                                                           gint end_x,
                                                           gint alpha);
static gpointer ____lambda4__gthread_func (gpointer self);
static void* ___lambda5_ (Block1Data* _data1_);
static void granite_drawing_buffer_surface_exponential_blur_columns (GraniteDrawingBufferSurface* self,
                                                              guint8* pixels,
                                                              gint width,
                                                              gint height,
                                                              gint start_col,
                                                              gint end_col,
                                                              gint start_y,
                                                              gint end_y,
                                                              gint alpha);
static gpointer ____lambda5__gthread_func (gpointer self);
static inline void granite_drawing_buffer_surface_exponential_blur_inner (guint8* pixel,
                                                            gint* z_alpha,
                                                            gint* z_red,
                                                            gint* z_green,
                                                            gint* z_blue,
                                                            gint alpha);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gdouble* granite_drawing_buffer_surface_build_gaussian_kernel (gint gauss_width,
                                                               gint* result_length1);
static void* ___lambda6_ (Block2Data* _data2_);
static void granite_drawing_buffer_surface_gaussian_blur_horizontal (GraniteDrawingBufferSurface* self,
                                                              gdouble* src,
                                                              gdouble* dest,
                                                              gdouble* kernel,
                                                              gint gauss_width,
                                                              gint width,
                                                              gint height,
                                                              gint start_row,
                                                              gint end_row,
                                                              gint* shift,
                                                              gint shift_length1,
                                                              gint shift_length2);
static gpointer ____lambda6__gthread_func (gpointer self);
static void* ___lambda7_ (Block2Data* _data2_);
static void granite_drawing_buffer_surface_gaussian_blur_vertical (GraniteDrawingBufferSurface* self,
                                                            gdouble* src,
                                                            gdouble* dest,
                                                            gdouble* kernel,
                                                            gint gauss_width,
                                                            gint width,
                                                            gint height,
                                                            gint start_col,
                                                            gint end_col,
                                                            gint* shift,
                                                            gint shift_length1,
                                                            gint shift_length2);
static gpointer ____lambda7__gthread_func (gpointer self);
static void granite_drawing_buffer_surface_finalize (GObject * obj);
static GType granite_drawing_buffer_surface_get_type_once (void);
static void _vala_granite_drawing_buffer_surface_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_granite_drawing_buffer_surface_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
granite_drawing_buffer_surface_get_instance_private (GraniteDrawingBufferSurface* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteDrawingBufferSurface_private_offset);
}

cairo_surface_t*
granite_drawing_buffer_surface_get_surface (GraniteDrawingBufferSurface* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp4_;
#line 23 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = self->priv->_surface;
#line 24 "../lib/Drawing/BufferSurface.vala"
	if (_tmp0_ == NULL) {
#line 183 "BufferSurface.c"
		gint _tmp1_;
		gint _tmp2_;
		cairo_surface_t* _tmp3_;
#line 25 "../lib/Drawing/BufferSurface.vala"
		_tmp1_ = self->priv->_width;
#line 25 "../lib/Drawing/BufferSurface.vala"
		_tmp2_ = self->priv->_height;
#line 25 "../lib/Drawing/BufferSurface.vala"
		_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp1_, _tmp2_);
#line 25 "../lib/Drawing/BufferSurface.vala"
		_cairo_surface_destroy0 (self->priv->_surface);
#line 25 "../lib/Drawing/BufferSurface.vala"
		self->priv->_surface = _tmp3_;
#line 197 "BufferSurface.c"
	}
#line 28 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = self->priv->_surface;
#line 28 "../lib/Drawing/BufferSurface.vala"
	result = _tmp4_;
#line 28 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 205 "BufferSurface.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 30 "../lib/Drawing/BufferSurface.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 213 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_set_surface (GraniteDrawingBufferSurface* self,
                                            cairo_surface_t* value)
{
	cairo_surface_t* _tmp0_;
#line 30 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 30 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = _cairo_surface_reference0 (value);
#line 30 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (self->priv->_surface);
#line 30 "../lib/Drawing/BufferSurface.vala"
	self->priv->_surface = _tmp0_;
#line 30 "../lib/Drawing/BufferSurface.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY]);
#line 231 "BufferSurface.c"
}

gint
granite_drawing_buffer_surface_get_width (GraniteDrawingBufferSurface* self)
{
	gint result;
#line 36 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../lib/Drawing/BufferSurface.vala"
	result = self->priv->_width;
#line 36 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 244 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_set_width (GraniteDrawingBufferSurface* self,
                                          gint value)
{
	gint old_value;
#line 36 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 36 "../lib/Drawing/BufferSurface.vala"
	old_value = granite_drawing_buffer_surface_get_width (self);
#line 36 "../lib/Drawing/BufferSurface.vala"
	if (old_value != value) {
#line 36 "../lib/Drawing/BufferSurface.vala"
		self->priv->_width = value;
#line 36 "../lib/Drawing/BufferSurface.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY]);
#line 262 "BufferSurface.c"
	}
}

gint
granite_drawing_buffer_surface_get_height (GraniteDrawingBufferSurface* self)
{
	gint result;
#line 40 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../lib/Drawing/BufferSurface.vala"
	result = self->priv->_height;
#line 40 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 276 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_set_height (GraniteDrawingBufferSurface* self,
                                           gint value)
{
	gint old_value;
#line 40 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/Drawing/BufferSurface.vala"
	old_value = granite_drawing_buffer_surface_get_height (self);
#line 40 "../lib/Drawing/BufferSurface.vala"
	if (old_value != value) {
#line 40 "../lib/Drawing/BufferSurface.vala"
		self->priv->_height = value;
#line 40 "../lib/Drawing/BufferSurface.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY]);
#line 294 "BufferSurface.c"
	}
}

cairo_t*
granite_drawing_buffer_surface_get_context (GraniteDrawingBufferSurface* self)
{
	cairo_t* result;
	cairo_t* _tmp0_;
	cairo_t* _tmp4_;
#line 48 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = self->priv->_context;
#line 49 "../lib/Drawing/BufferSurface.vala"
	if (_tmp0_ == NULL) {
#line 310 "BufferSurface.c"
		cairo_surface_t* _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_t* _tmp3_;
#line 50 "../lib/Drawing/BufferSurface.vala"
		_tmp1_ = granite_drawing_buffer_surface_get_surface (self);
#line 50 "../lib/Drawing/BufferSurface.vala"
		_tmp2_ = _tmp1_;
#line 50 "../lib/Drawing/BufferSurface.vala"
		_tmp3_ = cairo_create (_tmp2_);
#line 50 "../lib/Drawing/BufferSurface.vala"
		_cairo_destroy0 (self->priv->_context);
#line 50 "../lib/Drawing/BufferSurface.vala"
		self->priv->_context = _tmp3_;
#line 324 "BufferSurface.c"
	}
#line 53 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = self->priv->_context;
#line 53 "../lib/Drawing/BufferSurface.vala"
	result = _tmp4_;
#line 53 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 332 "BufferSurface.c"
}

/**
         * Constructs a new, empty {@link Granite.Drawing.BufferSurface} with the supplied dimensions.
         *
         * @param width the width of {@link Granite.Drawing.BufferSurface}, in pixels
         * @param height the height of the {@link Granite.Drawing.BufferSurface}, in pixels
         */
GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_construct (GType object_type,
                                          gint width,
                                          gint height)
{
	GraniteDrawingBufferSurface * self = NULL;
#line 63 "../lib/Drawing/BufferSurface.vala"
	_vala_return_val_if_fail ((width >= 0) && (height >= 0), "width >= 0 && height >= 0", NULL);
#line 63 "../lib/Drawing/BufferSurface.vala"
	self = (GraniteDrawingBufferSurface*) g_object_new (object_type, NULL);
#line 64 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_set_width (self, width);
#line 65 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_set_height (self, height);
#line 63 "../lib/Drawing/BufferSurface.vala"
	return self;
#line 357 "BufferSurface.c"
}

GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_new (gint width,
                                    gint height)
{
#line 63 "../lib/Drawing/BufferSurface.vala"
	return granite_drawing_buffer_surface_construct (GRANITE_DRAWING_TYPE_BUFFER_SURFACE, width, height);
#line 366 "BufferSurface.c"
}

/**
         * Constructs a new, empty {@link Granite.Drawing.BufferSurface} with the supplied dimensions, using
         * the supplied {@link Cairo.Surface} as a model.
         *
         * @param width the width of the new {@link Granite.Drawing.BufferSurface}, in pixels
         * @param height the height of the new {@link Granite.Drawing.BufferSurface}, in pixels
         * @param model the {@link Cairo.Surface} to use as a model for the internal {@link Cairo.Surface}
         */
GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_construct_with_surface (GType object_type,
                                                       gint width,
                                                       gint height,
                                                       cairo_surface_t* model)
{
	GraniteDrawingBufferSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
#line 76 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 76 "../lib/Drawing/BufferSurface.vala"
	_vala_return_val_if_fail (model != NULL, "model != null", NULL);
#line 77 "../lib/Drawing/BufferSurface.vala"
	self = (GraniteDrawingBufferSurface*) granite_drawing_buffer_surface_construct (object_type, width, height);
#line 78 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = cairo_surface_create_similar (model, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 78 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = _tmp0_;
#line 78 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_set_surface (self, _tmp1_);
#line 78 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (_tmp1_);
#line 76 "../lib/Drawing/BufferSurface.vala"
	return self;
#line 402 "BufferSurface.c"
}

GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_new_with_surface (gint width,
                                                 gint height,
                                                 cairo_surface_t* model)
{
#line 76 "../lib/Drawing/BufferSurface.vala"
	return granite_drawing_buffer_surface_construct_with_surface (GRANITE_DRAWING_TYPE_BUFFER_SURFACE, width, height, model);
#line 412 "BufferSurface.c"
}

/**
         * Constructs a new, empty {@link Granite.Drawing.BufferSurface} with the supplied dimensions, using
         * the supplied {@link Granite.Drawing.BufferSurface} as a model.
         *
         * @param width the width of the new {@link Granite.Drawing.BufferSurface}, in pixels
         * @param height the height of the new {@link Granite.Drawing.BufferSurface}, in pixels
         * @param model the {@link Granite.Drawing.BufferSurface} to use as a model for the internal {@link Cairo.Surface}
         */
GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_construct_with_buffer_surface (GType object_type,
                                                              gint width,
                                                              gint height,
                                                              GraniteDrawingBufferSurface* model)
{
	GraniteDrawingBufferSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_surface_t* _tmp3_;
#line 89 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 89 "../lib/Drawing/BufferSurface.vala"
	_vala_return_val_if_fail (model != NULL, "model != null", NULL);
#line 90 "../lib/Drawing/BufferSurface.vala"
	self = (GraniteDrawingBufferSurface*) granite_drawing_buffer_surface_construct (object_type, width, height);
#line 91 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = granite_drawing_buffer_surface_get_surface (model);
#line 91 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = _tmp0_;
#line 91 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = cairo_surface_create_similar (_tmp1_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 91 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = _tmp2_;
#line 91 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_set_surface (self, _tmp3_);
#line 91 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (_tmp3_);
#line 89 "../lib/Drawing/BufferSurface.vala"
	return self;
#line 454 "BufferSurface.c"
}

GraniteDrawingBufferSurface*
granite_drawing_buffer_surface_new_with_buffer_surface (gint width,
                                                        gint height,
                                                        GraniteDrawingBufferSurface* model)
{
#line 89 "../lib/Drawing/BufferSurface.vala"
	return granite_drawing_buffer_surface_construct_with_buffer_surface (GRANITE_DRAWING_TYPE_BUFFER_SURFACE, width, height, model);
#line 464 "BufferSurface.c"
}

/**
         * Clears the internal {@link Cairo.Surface}, making all pixels fully transparent.
         */
void
granite_drawing_buffer_surface_clear (GraniteDrawingBufferSurface* self)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
#line 97 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = granite_drawing_buffer_surface_get_context (self);
#line 98 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = _tmp0_;
#line 98 "../lib/Drawing/BufferSurface.vala"
	cairo_save (_tmp1_);
#line 100 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = self->priv->_context;
#line 100 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_rgba (_tmp2_, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 101 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = self->priv->_context;
#line 101 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp3_, CAIRO_OPERATOR_SOURCE);
#line 102 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = self->priv->_context;
#line 102 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp4_);
#line 104 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = self->priv->_context;
#line 104 "../lib/Drawing/BufferSurface.vala"
	cairo_restore (_tmp5_);
#line 503 "BufferSurface.c"
}

/**
         * Creates a {@link Gdk.Pixbuf} from internal {@link Cairo.Surface}.
         *
         * @return the {@link Gdk.Pixbuf}
         */
GdkPixbuf*
granite_drawing_buffer_surface_load_to_pixbuf (GraniteDrawingBufferSurface* self)
{
	cairo_surface_t* image_surface = NULL;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	gint width = 0;
	cairo_surface_t* _tmp10_;
	gint height = 0;
	cairo_surface_t* _tmp11_;
	GdkPixbuf* pb = NULL;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* _tmp13_;
	guint8* data = NULL;
	cairo_surface_t* _tmp14_;
	guchar* _tmp15_;
	guint8* pixels = NULL;
	GdkPixbuf* _tmp16_;
	guint8* _tmp17_;
	gint length = 0;
	cairo_surface_t* _tmp18_;
	GdkPixbuf* result;
#line 112 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = self->priv->_width;
#line 113 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = self->priv->_height;
#line 113 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp0_, _tmp1_);
#line 113 "../lib/Drawing/BufferSurface.vala"
	image_surface = _tmp2_;
#line 114 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = image_surface;
#line 114 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 114 "../lib/Drawing/BufferSurface.vala"
	cr = _tmp4_;
#line 116 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = cr;
#line 116 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
#line 117 "../lib/Drawing/BufferSurface.vala"
	_tmp6_ = cr;
#line 117 "../lib/Drawing/BufferSurface.vala"
	_tmp7_ = granite_drawing_buffer_surface_get_surface (self);
#line 117 "../lib/Drawing/BufferSurface.vala"
	_tmp8_ = _tmp7_;
#line 117 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp6_, _tmp8_, (gdouble) 0, (gdouble) 0);
#line 118 "../lib/Drawing/BufferSurface.vala"
	_tmp9_ = cr;
#line 118 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp9_);
#line 120 "../lib/Drawing/BufferSurface.vala"
	_tmp10_ = image_surface;
#line 120 "../lib/Drawing/BufferSurface.vala"
	width = cairo_image_surface_get_width (_tmp10_);
#line 121 "../lib/Drawing/BufferSurface.vala"
	_tmp11_ = image_surface;
#line 121 "../lib/Drawing/BufferSurface.vala"
	height = cairo_image_surface_get_height (_tmp11_);
#line 123 "../lib/Drawing/BufferSurface.vala"
	_tmp12_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, width, height);
#line 123 "../lib/Drawing/BufferSurface.vala"
	pb = _tmp12_;
#line 124 "../lib/Drawing/BufferSurface.vala"
	_tmp13_ = pb;
#line 124 "../lib/Drawing/BufferSurface.vala"
	gdk_pixbuf_fill (_tmp13_, (guint32) 0x00000000);
#line 126 "../lib/Drawing/BufferSurface.vala"
	_tmp14_ = image_surface;
#line 126 "../lib/Drawing/BufferSurface.vala"
	_tmp15_ = cairo_image_surface_get_data (_tmp14_);
#line 126 "../lib/Drawing/BufferSurface.vala"
	data = _tmp15_;
#line 127 "../lib/Drawing/BufferSurface.vala"
	_tmp16_ = pb;
#line 127 "../lib/Drawing/BufferSurface.vala"
	_tmp17_ = gdk_pixbuf_get_pixels (_tmp16_);
#line 127 "../lib/Drawing/BufferSurface.vala"
	pixels = _tmp17_;
#line 128 "../lib/Drawing/BufferSurface.vala"
	length = width * height;
#line 130 "../lib/Drawing/BufferSurface.vala"
	_tmp18_ = image_surface;
#line 130 "../lib/Drawing/BufferSurface.vala"
	if (cairo_image_surface_get_format (_tmp18_) == CAIRO_FORMAT_ARGB32) {
#line 608 "BufferSurface.c"
		{
			gint i = 0;
#line 131 "../lib/Drawing/BufferSurface.vala"
			i = 0;
#line 613 "BufferSurface.c"
			{
				gboolean _tmp19_ = FALSE;
#line 131 "../lib/Drawing/BufferSurface.vala"
				_tmp19_ = TRUE;
#line 131 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 620 "BufferSurface.c"
					guint8* _tmp21_;
					guint8 _tmp22_;
					guint8* _tmp41_;
					guint8* _tmp42_;
#line 131 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp19_) {
#line 627 "BufferSurface.c"
						gint _tmp20_;
#line 131 "../lib/Drawing/BufferSurface.vala"
						_tmp20_ = i;
#line 131 "../lib/Drawing/BufferSurface.vala"
						i = _tmp20_ + 1;
#line 633 "BufferSurface.c"
					}
#line 131 "../lib/Drawing/BufferSurface.vala"
					_tmp19_ = FALSE;
#line 131 "../lib/Drawing/BufferSurface.vala"
					if (!(i < length)) {
#line 131 "../lib/Drawing/BufferSurface.vala"
						break;
#line 641 "BufferSurface.c"
					}
#line 133 "../lib/Drawing/BufferSurface.vala"
					_tmp21_ = data;
#line 133 "../lib/Drawing/BufferSurface.vala"
					_tmp22_ = _tmp21_[3];
#line 133 "../lib/Drawing/BufferSurface.vala"
					if (((gint) _tmp22_) > 0) {
#line 649 "BufferSurface.c"
						guint8* _tmp23_;
						guint8* _tmp24_;
						guint8 _tmp25_;
						guint8* _tmp26_;
						guint8 _tmp27_;
						guint8* _tmp28_;
						guint8* _tmp29_;
						guint8 _tmp30_;
						guint8* _tmp31_;
						guint8 _tmp32_;
						guint8* _tmp33_;
						guint8* _tmp34_;
						guint8 _tmp35_;
						guint8* _tmp36_;
						guint8 _tmp37_;
						guint8* _tmp38_;
						guint8* _tmp39_;
						guint8 _tmp40_;
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp23_ = pixels;
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp24_ = data;
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp25_ = _tmp24_[2];
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp26_ = data;
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp27_ = _tmp26_[3];
#line 134 "../lib/Drawing/BufferSurface.vala"
						_tmp23_[0] = (guint8) ((_tmp25_ * 255) / _tmp27_);
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp28_ = pixels;
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp29_ = data;
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp30_ = _tmp29_[1];
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp31_ = data;
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp32_ = _tmp31_[3];
#line 135 "../lib/Drawing/BufferSurface.vala"
						_tmp28_[1] = (guint8) ((_tmp30_ * 255) / _tmp32_);
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp33_ = pixels;
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp34_ = data;
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp35_ = _tmp34_[0];
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp36_ = data;
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp37_ = _tmp36_[3];
#line 136 "../lib/Drawing/BufferSurface.vala"
						_tmp33_[2] = (guint8) ((_tmp35_ * 255) / _tmp37_);
#line 137 "../lib/Drawing/BufferSurface.vala"
						_tmp38_ = pixels;
#line 137 "../lib/Drawing/BufferSurface.vala"
						_tmp39_ = data;
#line 137 "../lib/Drawing/BufferSurface.vala"
						_tmp40_ = _tmp39_[3];
#line 137 "../lib/Drawing/BufferSurface.vala"
						_tmp38_[3] = _tmp40_;
#line 712 "BufferSurface.c"
					}
#line 140 "../lib/Drawing/BufferSurface.vala"
					_tmp41_ = pixels;
#line 140 "../lib/Drawing/BufferSurface.vala"
					pixels = _tmp41_ + 4;
#line 141 "../lib/Drawing/BufferSurface.vala"
					_tmp42_ = data;
#line 141 "../lib/Drawing/BufferSurface.vala"
					data = _tmp42_ + 4;
#line 722 "BufferSurface.c"
				}
			}
		}
	} else {
		cairo_surface_t* _tmp43_;
#line 143 "../lib/Drawing/BufferSurface.vala"
		_tmp43_ = image_surface;
#line 143 "../lib/Drawing/BufferSurface.vala"
		if (cairo_image_surface_get_format (_tmp43_) == CAIRO_FORMAT_RGB24) {
#line 732 "BufferSurface.c"
			{
				gint i = 0;
#line 144 "../lib/Drawing/BufferSurface.vala"
				i = 0;
#line 737 "BufferSurface.c"
				{
					gboolean _tmp44_ = FALSE;
#line 144 "../lib/Drawing/BufferSurface.vala"
					_tmp44_ = TRUE;
#line 144 "../lib/Drawing/BufferSurface.vala"
					while (TRUE) {
#line 744 "BufferSurface.c"
						guint8* _tmp46_;
						guint8* _tmp47_;
						guint8 _tmp48_;
						guint8* _tmp49_;
						guint8* _tmp50_;
						guint8 _tmp51_;
						guint8* _tmp52_;
						guint8* _tmp53_;
						guint8 _tmp54_;
						guint8* _tmp55_;
						guint8* _tmp56_;
						guint8 _tmp57_;
						guint8* _tmp58_;
						guint8* _tmp59_;
#line 144 "../lib/Drawing/BufferSurface.vala"
						if (!_tmp44_) {
#line 761 "BufferSurface.c"
							gint _tmp45_;
#line 144 "../lib/Drawing/BufferSurface.vala"
							_tmp45_ = i;
#line 144 "../lib/Drawing/BufferSurface.vala"
							i = _tmp45_ + 1;
#line 767 "BufferSurface.c"
						}
#line 144 "../lib/Drawing/BufferSurface.vala"
						_tmp44_ = FALSE;
#line 144 "../lib/Drawing/BufferSurface.vala"
						if (!(i < length)) {
#line 144 "../lib/Drawing/BufferSurface.vala"
							break;
#line 775 "BufferSurface.c"
						}
#line 145 "../lib/Drawing/BufferSurface.vala"
						_tmp46_ = pixels;
#line 145 "../lib/Drawing/BufferSurface.vala"
						_tmp47_ = data;
#line 145 "../lib/Drawing/BufferSurface.vala"
						_tmp48_ = _tmp47_[2];
#line 145 "../lib/Drawing/BufferSurface.vala"
						_tmp46_[0] = _tmp48_;
#line 146 "../lib/Drawing/BufferSurface.vala"
						_tmp49_ = pixels;
#line 146 "../lib/Drawing/BufferSurface.vala"
						_tmp50_ = data;
#line 146 "../lib/Drawing/BufferSurface.vala"
						_tmp51_ = _tmp50_[1];
#line 146 "../lib/Drawing/BufferSurface.vala"
						_tmp49_[1] = _tmp51_;
#line 147 "../lib/Drawing/BufferSurface.vala"
						_tmp52_ = pixels;
#line 147 "../lib/Drawing/BufferSurface.vala"
						_tmp53_ = data;
#line 147 "../lib/Drawing/BufferSurface.vala"
						_tmp54_ = _tmp53_[0];
#line 147 "../lib/Drawing/BufferSurface.vala"
						_tmp52_[2] = _tmp54_;
#line 148 "../lib/Drawing/BufferSurface.vala"
						_tmp55_ = pixels;
#line 148 "../lib/Drawing/BufferSurface.vala"
						_tmp56_ = data;
#line 148 "../lib/Drawing/BufferSurface.vala"
						_tmp57_ = _tmp56_[3];
#line 148 "../lib/Drawing/BufferSurface.vala"
						_tmp55_[3] = _tmp57_;
#line 150 "../lib/Drawing/BufferSurface.vala"
						_tmp58_ = pixels;
#line 150 "../lib/Drawing/BufferSurface.vala"
						pixels = _tmp58_ + 4;
#line 151 "../lib/Drawing/BufferSurface.vala"
						_tmp59_ = data;
#line 151 "../lib/Drawing/BufferSurface.vala"
						data = _tmp59_ + 4;
#line 817 "BufferSurface.c"
					}
				}
			}
		}
	}
#line 155 "../lib/Drawing/BufferSurface.vala"
	result = pb;
#line 155 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (cr);
#line 155 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (image_surface);
#line 155 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 831 "BufferSurface.c"
}

/**
         * Averages all the colors in the internal {@link Cairo.Surface}.
         *
         * @return the {@link Granite.Drawing.Color} with the averaged color
         */
GraniteDrawingColor*
granite_drawing_buffer_surface_average_color (GraniteDrawingBufferSurface* self)
{
	gdouble b_total = 0.0;
	gdouble g_total = 0.0;
	gdouble r_total = 0.0;
	gint w = 0;
	gint _tmp0_;
	gint h = 0;
	gint _tmp1_;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	guint8* data = NULL;
	cairo_surface_t* _tmp10_;
	guchar* _tmp11_;
	gint length = 0;
	GraniteDrawingColor* _tmp22_;
	GraniteDrawingColor* _tmp23_;
	GraniteDrawingColor* _tmp24_;
	GraniteDrawingColor* _tmp25_;
	GraniteDrawingColor* _tmp26_;
	GraniteDrawingColor* _tmp27_;
	GraniteDrawingColor* result;
#line 163 "../lib/Drawing/BufferSurface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../lib/Drawing/BufferSurface.vala"
	b_total = 0.0;
#line 165 "../lib/Drawing/BufferSurface.vala"
	g_total = 0.0;
#line 166 "../lib/Drawing/BufferSurface.vala"
	r_total = 0.0;
#line 168 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = self->priv->_width;
#line 168 "../lib/Drawing/BufferSurface.vala"
	w = _tmp0_;
#line 169 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = self->priv->_height;
#line 169 "../lib/Drawing/BufferSurface.vala"
	h = _tmp1_;
#line 171 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, w, h);
#line 171 "../lib/Drawing/BufferSurface.vala"
	original = _tmp2_;
#line 172 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = original;
#line 172 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 172 "../lib/Drawing/BufferSurface.vala"
	cr = _tmp4_;
#line 174 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = cr;
#line 174 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
#line 175 "../lib/Drawing/BufferSurface.vala"
	_tmp6_ = cr;
#line 175 "../lib/Drawing/BufferSurface.vala"
	_tmp7_ = granite_drawing_buffer_surface_get_surface (self);
#line 175 "../lib/Drawing/BufferSurface.vala"
	_tmp8_ = _tmp7_;
#line 175 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp6_, _tmp8_, (gdouble) 0, (gdouble) 0);
#line 176 "../lib/Drawing/BufferSurface.vala"
	_tmp9_ = cr;
#line 176 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp9_);
#line 178 "../lib/Drawing/BufferSurface.vala"
	_tmp10_ = original;
#line 178 "../lib/Drawing/BufferSurface.vala"
	_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 178 "../lib/Drawing/BufferSurface.vala"
	data = _tmp11_;
#line 179 "../lib/Drawing/BufferSurface.vala"
	length = w * h;
#line 920 "BufferSurface.c"
	{
		gint i = 0;
#line 181 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 925 "BufferSurface.c"
		{
			gboolean _tmp12_ = FALSE;
#line 181 "../lib/Drawing/BufferSurface.vala"
			_tmp12_ = TRUE;
#line 181 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 932 "BufferSurface.c"
				guint8 b = 0U;
				guint8* _tmp14_;
				guint8 _tmp15_;
				guint8 g = 0U;
				guint8* _tmp16_;
				guint8 _tmp17_;
				guint8 r = 0U;
				guint8* _tmp18_;
				guint8 _tmp19_;
				guint8 max = 0U;
				guint8 min = 0U;
				gdouble delta = 0.0;
				gdouble _tmp20_ = 0.0;
				gdouble sat = 0.0;
				gdouble score = 0.0;
				guint8* _tmp21_;
#line 181 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp12_) {
#line 951 "BufferSurface.c"
					gint _tmp13_;
#line 181 "../lib/Drawing/BufferSurface.vala"
					_tmp13_ = i;
#line 181 "../lib/Drawing/BufferSurface.vala"
					i = _tmp13_ + 1;
#line 957 "BufferSurface.c"
				}
#line 181 "../lib/Drawing/BufferSurface.vala"
				_tmp12_ = FALSE;
#line 181 "../lib/Drawing/BufferSurface.vala"
				if (!(i < length)) {
#line 181 "../lib/Drawing/BufferSurface.vala"
					break;
#line 965 "BufferSurface.c"
				}
#line 182 "../lib/Drawing/BufferSurface.vala"
				_tmp14_ = data;
#line 182 "../lib/Drawing/BufferSurface.vala"
				_tmp15_ = _tmp14_[0];
#line 182 "../lib/Drawing/BufferSurface.vala"
				b = _tmp15_;
#line 183 "../lib/Drawing/BufferSurface.vala"
				_tmp16_ = data;
#line 183 "../lib/Drawing/BufferSurface.vala"
				_tmp17_ = _tmp16_[1];
#line 183 "../lib/Drawing/BufferSurface.vala"
				g = _tmp17_;
#line 184 "../lib/Drawing/BufferSurface.vala"
				_tmp18_ = data;
#line 184 "../lib/Drawing/BufferSurface.vala"
				_tmp19_ = _tmp18_[2];
#line 184 "../lib/Drawing/BufferSurface.vala"
				r = _tmp19_;
#line 186 "../lib/Drawing/BufferSurface.vala"
				max = (guint8) MAX ((gdouble) r, MAX ((gdouble) g, (gdouble) b));
#line 187 "../lib/Drawing/BufferSurface.vala"
				min = (guint8) MIN ((gdouble) r, MIN ((gdouble) g, (gdouble) b));
#line 188 "../lib/Drawing/BufferSurface.vala"
				delta = (gdouble) (max - min);
#line 190 "../lib/Drawing/BufferSurface.vala"
				if (delta == ((gdouble) 0)) {
#line 190 "../lib/Drawing/BufferSurface.vala"
					_tmp20_ = 0.0;
#line 995 "BufferSurface.c"
				} else {
#line 190 "../lib/Drawing/BufferSurface.vala"
					_tmp20_ = delta / max;
#line 999 "BufferSurface.c"
				}
#line 190 "../lib/Drawing/BufferSurface.vala"
				sat = _tmp20_;
#line 191 "../lib/Drawing/BufferSurface.vala"
				score = 0.2 + (0.8 * sat);
#line 193 "../lib/Drawing/BufferSurface.vala"
				b_total += b * score;
#line 194 "../lib/Drawing/BufferSurface.vala"
				g_total += g * score;
#line 195 "../lib/Drawing/BufferSurface.vala"
				r_total += r * score;
#line 197 "../lib/Drawing/BufferSurface.vala"
				_tmp21_ = data;
#line 197 "../lib/Drawing/BufferSurface.vala"
				data = _tmp21_ + 4;
#line 1015 "BufferSurface.c"
			}
		}
	}
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp22_ = granite_drawing_color_new ((r_total / G_MAXUINT8) / length, (g_total / G_MAXUINT8) / length, (b_total / G_MAXUINT8) / length, (gdouble) 1);
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp23_ = _tmp22_;
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp24_ = granite_drawing_color_set_val (_tmp23_, 0.8);
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp25_ = _tmp24_;
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp26_ = granite_drawing_color_multiply_sat (_tmp25_, 1.15);
#line 200 "../lib/Drawing/BufferSurface.vala"
	_tmp27_ = _tmp26_;
#line 200 "../lib/Drawing/BufferSurface.vala"
	_g_object_unref0 (_tmp25_);
#line 200 "../lib/Drawing/BufferSurface.vala"
	_g_object_unref0 (_tmp23_);
#line 200 "../lib/Drawing/BufferSurface.vala"
	result = _tmp27_;
#line 200 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (cr);
#line 200 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (original);
#line 200 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 1043 "BufferSurface.c"
}

/**
         * Performs a blur operation on the internal {@link Cairo.Surface}, using the
         * fast-blur algorithm found here [[http://incubator.quasimondo.com/processing/superfastblur.pde]].
         *
         * @param radius the blur radius
         * @param process_count the number of times to perform the operation
         */
void
granite_drawing_buffer_surface_fast_blur (GraniteDrawingBufferSurface* self,
                                          gint radius,
                                          gint process_count)
{
	gboolean _tmp0_ = FALSE;
	gint w = 0;
	gint _tmp1_;
	gint h = 0;
	gint _tmp2_;
	gint channels = 0;
	gboolean _tmp3_ = FALSE;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	cairo_t* _tmp11_;
	guint8* pixels = NULL;
	cairo_surface_t* _tmp12_;
	guchar* _tmp13_;
	guint8* buffer = NULL;
	guint8* _tmp14_;
	gint buffer_length1;
	gint _buffer_size_;
	gint* v_min = NULL;
	gint* _tmp15_;
	gint v_min_length1;
	gint _v_min_size_;
	gint* v_max = NULL;
	gint* _tmp16_;
	gint v_max_length1;
	gint _v_max_size_;
	gint div = 0;
	guint8* dv = NULL;
	guint8* _tmp17_;
	gint dv_length1;
	gint _dv_size_;
	cairo_surface_t* _tmp139_;
	cairo_t* _tmp140_;
	cairo_t* _tmp141_;
	cairo_t* _tmp142_;
	cairo_t* _tmp143_;
	cairo_surface_t* _tmp144_;
	cairo_t* _tmp145_;
	cairo_t* _tmp146_;
	cairo_t* _tmp147_;
	cairo_t* _tmp148_;
#line 215 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 216 "../lib/Drawing/BufferSurface.vala"
	if (radius < 1) {
#line 216 "../lib/Drawing/BufferSurface.vala"
		_tmp0_ = TRUE;
#line 1111 "BufferSurface.c"
	} else {
#line 216 "../lib/Drawing/BufferSurface.vala"
		_tmp0_ = process_count < 1;
#line 1115 "BufferSurface.c"
	}
#line 216 "../lib/Drawing/BufferSurface.vala"
	if (_tmp0_) {
#line 217 "../lib/Drawing/BufferSurface.vala"
		return;
#line 1121 "BufferSurface.c"
	}
#line 220 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = self->priv->_width;
#line 220 "../lib/Drawing/BufferSurface.vala"
	w = _tmp1_;
#line 221 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = self->priv->_height;
#line 221 "../lib/Drawing/BufferSurface.vala"
	h = _tmp2_;
#line 222 "../lib/Drawing/BufferSurface.vala"
	channels = 4;
#line 224 "../lib/Drawing/BufferSurface.vala"
	if (radius > (w - 1)) {
#line 224 "../lib/Drawing/BufferSurface.vala"
		_tmp3_ = TRUE;
#line 1137 "BufferSurface.c"
	} else {
#line 224 "../lib/Drawing/BufferSurface.vala"
		_tmp3_ = radius > (h - 1);
#line 1141 "BufferSurface.c"
	}
#line 224 "../lib/Drawing/BufferSurface.vala"
	if (_tmp3_) {
#line 225 "../lib/Drawing/BufferSurface.vala"
		return;
#line 1147 "BufferSurface.c"
	}
#line 228 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, w, h);
#line 228 "../lib/Drawing/BufferSurface.vala"
	original = _tmp4_;
#line 229 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = original;
#line 229 "../lib/Drawing/BufferSurface.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 229 "../lib/Drawing/BufferSurface.vala"
	cr = _tmp6_;
#line 231 "../lib/Drawing/BufferSurface.vala"
	_tmp7_ = cr;
#line 231 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
#line 232 "../lib/Drawing/BufferSurface.vala"
	_tmp8_ = cr;
#line 232 "../lib/Drawing/BufferSurface.vala"
	_tmp9_ = granite_drawing_buffer_surface_get_surface (self);
#line 232 "../lib/Drawing/BufferSurface.vala"
	_tmp10_ = _tmp9_;
#line 232 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp8_, _tmp10_, (gdouble) 0, (gdouble) 0);
#line 233 "../lib/Drawing/BufferSurface.vala"
	_tmp11_ = cr;
#line 233 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp11_);
#line 235 "../lib/Drawing/BufferSurface.vala"
	_tmp12_ = original;
#line 235 "../lib/Drawing/BufferSurface.vala"
	_tmp13_ = cairo_image_surface_get_data (_tmp12_);
#line 235 "../lib/Drawing/BufferSurface.vala"
	pixels = _tmp13_;
#line 236 "../lib/Drawing/BufferSurface.vala"
	_tmp14_ = g_new0 (guint8, (w * h) * channels);
#line 236 "../lib/Drawing/BufferSurface.vala"
	buffer = _tmp14_;
#line 236 "../lib/Drawing/BufferSurface.vala"
	buffer_length1 = (w * h) * channels;
#line 236 "../lib/Drawing/BufferSurface.vala"
	_buffer_size_ = buffer_length1;
#line 238 "../lib/Drawing/BufferSurface.vala"
	_tmp15_ = g_new0 (gint, MAX (w, h));
#line 238 "../lib/Drawing/BufferSurface.vala"
	v_min = _tmp15_;
#line 238 "../lib/Drawing/BufferSurface.vala"
	v_min_length1 = MAX (w, h);
#line 238 "../lib/Drawing/BufferSurface.vala"
	_v_min_size_ = v_min_length1;
#line 239 "../lib/Drawing/BufferSurface.vala"
	_tmp16_ = g_new0 (gint, MAX (w, h));
#line 239 "../lib/Drawing/BufferSurface.vala"
	v_max = _tmp16_;
#line 239 "../lib/Drawing/BufferSurface.vala"
	v_max_length1 = MAX (w, h);
#line 239 "../lib/Drawing/BufferSurface.vala"
	_v_max_size_ = v_max_length1;
#line 241 "../lib/Drawing/BufferSurface.vala"
	div = (2 * radius) + 1;
#line 242 "../lib/Drawing/BufferSurface.vala"
	_tmp17_ = g_new0 (guint8, 256 * div);
#line 242 "../lib/Drawing/BufferSurface.vala"
	dv = _tmp17_;
#line 242 "../lib/Drawing/BufferSurface.vala"
	dv_length1 = 256 * div;
#line 242 "../lib/Drawing/BufferSurface.vala"
	_dv_size_ = dv_length1;
#line 1215 "BufferSurface.c"
	{
		gint i = 0;
#line 244 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 1220 "BufferSurface.c"
		{
			gboolean _tmp18_ = FALSE;
#line 244 "../lib/Drawing/BufferSurface.vala"
			_tmp18_ = TRUE;
#line 244 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 1227 "BufferSurface.c"
				guint8* _tmp20_;
				gint _tmp20__length1;
				guint8* _tmp21_;
				gint _tmp21__length1;
#line 244 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp18_) {
#line 1234 "BufferSurface.c"
					gint _tmp19_;
#line 244 "../lib/Drawing/BufferSurface.vala"
					_tmp19_ = i;
#line 244 "../lib/Drawing/BufferSurface.vala"
					i = _tmp19_ + 1;
#line 1240 "BufferSurface.c"
				}
#line 244 "../lib/Drawing/BufferSurface.vala"
				_tmp18_ = FALSE;
#line 244 "../lib/Drawing/BufferSurface.vala"
				_tmp20_ = dv;
#line 244 "../lib/Drawing/BufferSurface.vala"
				_tmp20__length1 = dv_length1;
#line 244 "../lib/Drawing/BufferSurface.vala"
				if (!(i < _tmp20__length1)) {
#line 244 "../lib/Drawing/BufferSurface.vala"
					break;
#line 1252 "BufferSurface.c"
				}
#line 245 "../lib/Drawing/BufferSurface.vala"
				_tmp21_ = dv;
#line 245 "../lib/Drawing/BufferSurface.vala"
				_tmp21__length1 = dv_length1;
#line 245 "../lib/Drawing/BufferSurface.vala"
				_tmp21_[i] = (guint8) (i / div);
#line 1260 "BufferSurface.c"
			}
		}
	}
#line 248 "../lib/Drawing/BufferSurface.vala"
	while (TRUE) {
#line 1266 "BufferSurface.c"
		gint _tmp22_;
#line 248 "../lib/Drawing/BufferSurface.vala"
		_tmp22_ = process_count;
#line 248 "../lib/Drawing/BufferSurface.vala"
		process_count = _tmp22_ - 1;
#line 248 "../lib/Drawing/BufferSurface.vala"
		if (!(_tmp22_ > 0)) {
#line 248 "../lib/Drawing/BufferSurface.vala"
			break;
#line 1276 "BufferSurface.c"
		}
		{
			gint x = 0;
#line 249 "../lib/Drawing/BufferSurface.vala"
			x = 0;
#line 1282 "BufferSurface.c"
			{
				gboolean _tmp23_ = FALSE;
#line 249 "../lib/Drawing/BufferSurface.vala"
				_tmp23_ = TRUE;
#line 249 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 1289 "BufferSurface.c"
					gint* _tmp25_;
					gint _tmp25__length1;
					gint* _tmp26_;
					gint _tmp26__length1;
#line 249 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp23_) {
#line 1296 "BufferSurface.c"
						gint _tmp24_;
#line 249 "../lib/Drawing/BufferSurface.vala"
						_tmp24_ = x;
#line 249 "../lib/Drawing/BufferSurface.vala"
						x = _tmp24_ + 1;
#line 1302 "BufferSurface.c"
					}
#line 249 "../lib/Drawing/BufferSurface.vala"
					_tmp23_ = FALSE;
#line 249 "../lib/Drawing/BufferSurface.vala"
					if (!(x < w)) {
#line 249 "../lib/Drawing/BufferSurface.vala"
						break;
#line 1310 "BufferSurface.c"
					}
#line 250 "../lib/Drawing/BufferSurface.vala"
					_tmp25_ = v_min;
#line 250 "../lib/Drawing/BufferSurface.vala"
					_tmp25__length1 = v_min_length1;
#line 250 "../lib/Drawing/BufferSurface.vala"
					_tmp25_[x] = MIN ((x + radius) + 1, w - 1);
#line 251 "../lib/Drawing/BufferSurface.vala"
					_tmp26_ = v_max;
#line 251 "../lib/Drawing/BufferSurface.vala"
					_tmp26__length1 = v_max_length1;
#line 251 "../lib/Drawing/BufferSurface.vala"
					_tmp26_[x] = MAX (x - radius, 0);
#line 1324 "BufferSurface.c"
				}
			}
		}
		{
			gint y = 0;
#line 254 "../lib/Drawing/BufferSurface.vala"
			y = 0;
#line 1332 "BufferSurface.c"
			{
				gboolean _tmp27_ = FALSE;
#line 254 "../lib/Drawing/BufferSurface.vala"
				_tmp27_ = TRUE;
#line 254 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 1339 "BufferSurface.c"
					gint a_sum = 0;
					gint r_sum = 0;
					gint g_sum = 0;
					gint b_sum = 0;
					guint32 cur_pixel = 0U;
					guint8* _tmp29_;
					guint8 _tmp30_;
					guint8* _tmp31_;
					guint8 _tmp32_;
					guint8* _tmp33_;
					guint8 _tmp34_;
					guint8* _tmp35_;
					guint8 _tmp36_;
#line 254 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp27_) {
#line 1355 "BufferSurface.c"
						gint _tmp28_;
#line 254 "../lib/Drawing/BufferSurface.vala"
						_tmp28_ = y;
#line 254 "../lib/Drawing/BufferSurface.vala"
						y = _tmp28_ + 1;
#line 1361 "BufferSurface.c"
					}
#line 254 "../lib/Drawing/BufferSurface.vala"
					_tmp27_ = FALSE;
#line 254 "../lib/Drawing/BufferSurface.vala"
					if (!(y < h)) {
#line 254 "../lib/Drawing/BufferSurface.vala"
						break;
#line 1369 "BufferSurface.c"
					}
#line 255 "../lib/Drawing/BufferSurface.vala"
					a_sum = 0;
#line 255 "../lib/Drawing/BufferSurface.vala"
					r_sum = 0;
#line 255 "../lib/Drawing/BufferSurface.vala"
					g_sum = 0;
#line 255 "../lib/Drawing/BufferSurface.vala"
					b_sum = 0;
#line 257 "../lib/Drawing/BufferSurface.vala"
					cur_pixel = (guint32) ((y * w) * channels);
#line 259 "../lib/Drawing/BufferSurface.vala"
					_tmp29_ = pixels;
#line 259 "../lib/Drawing/BufferSurface.vala"
					_tmp30_ = _tmp29_[cur_pixel + 0];
#line 259 "../lib/Drawing/BufferSurface.vala"
					a_sum += radius * _tmp30_;
#line 260 "../lib/Drawing/BufferSurface.vala"
					_tmp31_ = pixels;
#line 260 "../lib/Drawing/BufferSurface.vala"
					_tmp32_ = _tmp31_[cur_pixel + 1];
#line 260 "../lib/Drawing/BufferSurface.vala"
					r_sum += radius * _tmp32_;
#line 261 "../lib/Drawing/BufferSurface.vala"
					_tmp33_ = pixels;
#line 261 "../lib/Drawing/BufferSurface.vala"
					_tmp34_ = _tmp33_[cur_pixel + 2];
#line 261 "../lib/Drawing/BufferSurface.vala"
					g_sum += radius * _tmp34_;
#line 262 "../lib/Drawing/BufferSurface.vala"
					_tmp35_ = pixels;
#line 262 "../lib/Drawing/BufferSurface.vala"
					_tmp36_ = _tmp35_[cur_pixel + 3];
#line 262 "../lib/Drawing/BufferSurface.vala"
					b_sum += radius * _tmp36_;
#line 1405 "BufferSurface.c"
					{
						gint i = 0;
#line 264 "../lib/Drawing/BufferSurface.vala"
						i = 0;
#line 1410 "BufferSurface.c"
						{
							gboolean _tmp37_ = FALSE;
#line 264 "../lib/Drawing/BufferSurface.vala"
							_tmp37_ = TRUE;
#line 264 "../lib/Drawing/BufferSurface.vala"
							while (TRUE) {
#line 1417 "BufferSurface.c"
								guint8* _tmp39_;
								guint8 _tmp40_;
								guint8* _tmp41_;
								guint8 _tmp42_;
								guint8* _tmp43_;
								guint8 _tmp44_;
								guint8* _tmp45_;
								guint8 _tmp46_;
#line 264 "../lib/Drawing/BufferSurface.vala"
								if (!_tmp37_) {
#line 1428 "BufferSurface.c"
									gint _tmp38_;
#line 264 "../lib/Drawing/BufferSurface.vala"
									_tmp38_ = i;
#line 264 "../lib/Drawing/BufferSurface.vala"
									i = _tmp38_ + 1;
#line 1434 "BufferSurface.c"
								}
#line 264 "../lib/Drawing/BufferSurface.vala"
								_tmp37_ = FALSE;
#line 264 "../lib/Drawing/BufferSurface.vala"
								if (!(i <= radius)) {
#line 264 "../lib/Drawing/BufferSurface.vala"
									break;
#line 1442 "BufferSurface.c"
								}
#line 265 "../lib/Drawing/BufferSurface.vala"
								_tmp39_ = pixels;
#line 265 "../lib/Drawing/BufferSurface.vala"
								_tmp40_ = _tmp39_[cur_pixel + 0];
#line 265 "../lib/Drawing/BufferSurface.vala"
								a_sum += (gint) _tmp40_;
#line 266 "../lib/Drawing/BufferSurface.vala"
								_tmp41_ = pixels;
#line 266 "../lib/Drawing/BufferSurface.vala"
								_tmp42_ = _tmp41_[cur_pixel + 1];
#line 266 "../lib/Drawing/BufferSurface.vala"
								r_sum += (gint) _tmp42_;
#line 267 "../lib/Drawing/BufferSurface.vala"
								_tmp43_ = pixels;
#line 267 "../lib/Drawing/BufferSurface.vala"
								_tmp44_ = _tmp43_[cur_pixel + 2];
#line 267 "../lib/Drawing/BufferSurface.vala"
								g_sum += (gint) _tmp44_;
#line 268 "../lib/Drawing/BufferSurface.vala"
								_tmp45_ = pixels;
#line 268 "../lib/Drawing/BufferSurface.vala"
								_tmp46_ = _tmp45_[cur_pixel + 3];
#line 268 "../lib/Drawing/BufferSurface.vala"
								b_sum += (gint) _tmp46_;
#line 270 "../lib/Drawing/BufferSurface.vala"
								cur_pixel += (guint32) channels;
#line 1470 "BufferSurface.c"
							}
						}
					}
#line 273 "../lib/Drawing/BufferSurface.vala"
					cur_pixel = (guint32) ((y * w) * channels);
#line 1476 "BufferSurface.c"
					{
						gint x = 0;
#line 275 "../lib/Drawing/BufferSurface.vala"
						x = 0;
#line 1481 "BufferSurface.c"
						{
							gboolean _tmp47_ = FALSE;
#line 275 "../lib/Drawing/BufferSurface.vala"
							_tmp47_ = TRUE;
#line 275 "../lib/Drawing/BufferSurface.vala"
							while (TRUE) {
#line 1488 "BufferSurface.c"
								guint32 p1 = 0U;
								gint* _tmp49_;
								gint _tmp49__length1;
								gint _tmp50_;
								guint32 p2 = 0U;
								gint* _tmp51_;
								gint _tmp51__length1;
								gint _tmp52_;
								guint8* _tmp53_;
								gint _tmp53__length1;
								guint8* _tmp54_;
								gint _tmp54__length1;
								guint8 _tmp55_;
								guint8* _tmp56_;
								gint _tmp56__length1;
								guint8* _tmp57_;
								gint _tmp57__length1;
								guint8 _tmp58_;
								guint8* _tmp59_;
								gint _tmp59__length1;
								guint8* _tmp60_;
								gint _tmp60__length1;
								guint8 _tmp61_;
								guint8* _tmp62_;
								gint _tmp62__length1;
								guint8* _tmp63_;
								gint _tmp63__length1;
								guint8 _tmp64_;
								guint8* _tmp65_;
								guint8 _tmp66_;
								guint8* _tmp67_;
								guint8 _tmp68_;
								guint8* _tmp69_;
								guint8 _tmp70_;
								guint8* _tmp71_;
								guint8 _tmp72_;
								guint8* _tmp73_;
								guint8 _tmp74_;
								guint8* _tmp75_;
								guint8 _tmp76_;
								guint8* _tmp77_;
								guint8 _tmp78_;
								guint8* _tmp79_;
								guint8 _tmp80_;
#line 275 "../lib/Drawing/BufferSurface.vala"
								if (!_tmp47_) {
#line 1535 "BufferSurface.c"
									gint _tmp48_;
#line 275 "../lib/Drawing/BufferSurface.vala"
									_tmp48_ = x;
#line 275 "../lib/Drawing/BufferSurface.vala"
									x = _tmp48_ + 1;
#line 1541 "BufferSurface.c"
								}
#line 275 "../lib/Drawing/BufferSurface.vala"
								_tmp47_ = FALSE;
#line 275 "../lib/Drawing/BufferSurface.vala"
								if (!(x < w)) {
#line 275 "../lib/Drawing/BufferSurface.vala"
									break;
#line 1549 "BufferSurface.c"
								}
#line 276 "../lib/Drawing/BufferSurface.vala"
								_tmp49_ = v_min;
#line 276 "../lib/Drawing/BufferSurface.vala"
								_tmp49__length1 = v_min_length1;
#line 276 "../lib/Drawing/BufferSurface.vala"
								_tmp50_ = _tmp49_[x];
#line 276 "../lib/Drawing/BufferSurface.vala"
								p1 = (guint32) (((y * w) + _tmp50_) * channels);
#line 277 "../lib/Drawing/BufferSurface.vala"
								_tmp51_ = v_max;
#line 277 "../lib/Drawing/BufferSurface.vala"
								_tmp51__length1 = v_max_length1;
#line 277 "../lib/Drawing/BufferSurface.vala"
								_tmp52_ = _tmp51_[x];
#line 277 "../lib/Drawing/BufferSurface.vala"
								p2 = (guint32) (((y * w) + _tmp52_) * channels);
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp53_ = buffer;
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp53__length1 = buffer_length1;
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp54_ = dv;
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp54__length1 = dv_length1;
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp55_ = _tmp54_[a_sum];
#line 279 "../lib/Drawing/BufferSurface.vala"
								_tmp53_[cur_pixel + 0] = _tmp55_;
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp56_ = buffer;
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp56__length1 = buffer_length1;
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp57_ = dv;
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp57__length1 = dv_length1;
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp58_ = _tmp57_[r_sum];
#line 280 "../lib/Drawing/BufferSurface.vala"
								_tmp56_[cur_pixel + 1] = _tmp58_;
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp59_ = buffer;
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp59__length1 = buffer_length1;
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp60_ = dv;
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp60__length1 = dv_length1;
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp61_ = _tmp60_[g_sum];
#line 281 "../lib/Drawing/BufferSurface.vala"
								_tmp59_[cur_pixel + 2] = _tmp61_;
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp62_ = buffer;
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp62__length1 = buffer_length1;
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp63_ = dv;
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp63__length1 = dv_length1;
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp64_ = _tmp63_[b_sum];
#line 282 "../lib/Drawing/BufferSurface.vala"
								_tmp62_[cur_pixel + 3] = _tmp64_;
#line 284 "../lib/Drawing/BufferSurface.vala"
								_tmp65_ = pixels;
#line 284 "../lib/Drawing/BufferSurface.vala"
								_tmp66_ = _tmp65_[p1 + 0];
#line 284 "../lib/Drawing/BufferSurface.vala"
								_tmp67_ = pixels;
#line 284 "../lib/Drawing/BufferSurface.vala"
								_tmp68_ = _tmp67_[p2 + 0];
#line 284 "../lib/Drawing/BufferSurface.vala"
								a_sum += (gint) (_tmp66_ - _tmp68_);
#line 285 "../lib/Drawing/BufferSurface.vala"
								_tmp69_ = pixels;
#line 285 "../lib/Drawing/BufferSurface.vala"
								_tmp70_ = _tmp69_[p1 + 1];
#line 285 "../lib/Drawing/BufferSurface.vala"
								_tmp71_ = pixels;
#line 285 "../lib/Drawing/BufferSurface.vala"
								_tmp72_ = _tmp71_[p2 + 1];
#line 285 "../lib/Drawing/BufferSurface.vala"
								r_sum += (gint) (_tmp70_ - _tmp72_);
#line 286 "../lib/Drawing/BufferSurface.vala"
								_tmp73_ = pixels;
#line 286 "../lib/Drawing/BufferSurface.vala"
								_tmp74_ = _tmp73_[p1 + 2];
#line 286 "../lib/Drawing/BufferSurface.vala"
								_tmp75_ = pixels;
#line 286 "../lib/Drawing/BufferSurface.vala"
								_tmp76_ = _tmp75_[p2 + 2];
#line 286 "../lib/Drawing/BufferSurface.vala"
								g_sum += (gint) (_tmp74_ - _tmp76_);
#line 287 "../lib/Drawing/BufferSurface.vala"
								_tmp77_ = pixels;
#line 287 "../lib/Drawing/BufferSurface.vala"
								_tmp78_ = _tmp77_[p1 + 3];
#line 287 "../lib/Drawing/BufferSurface.vala"
								_tmp79_ = pixels;
#line 287 "../lib/Drawing/BufferSurface.vala"
								_tmp80_ = _tmp79_[p2 + 3];
#line 287 "../lib/Drawing/BufferSurface.vala"
								b_sum += (gint) (_tmp78_ - _tmp80_);
#line 289 "../lib/Drawing/BufferSurface.vala"
								cur_pixel += (guint32) channels;
#line 1657 "BufferSurface.c"
							}
						}
					}
				}
			}
		}
		{
			gint y = 0;
#line 293 "../lib/Drawing/BufferSurface.vala"
			y = 0;
#line 1668 "BufferSurface.c"
			{
				gboolean _tmp81_ = FALSE;
#line 293 "../lib/Drawing/BufferSurface.vala"
				_tmp81_ = TRUE;
#line 293 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 1675 "BufferSurface.c"
					gint* _tmp83_;
					gint _tmp83__length1;
					gint* _tmp84_;
					gint _tmp84__length1;
#line 293 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp81_) {
#line 1682 "BufferSurface.c"
						gint _tmp82_;
#line 293 "../lib/Drawing/BufferSurface.vala"
						_tmp82_ = y;
#line 293 "../lib/Drawing/BufferSurface.vala"
						y = _tmp82_ + 1;
#line 1688 "BufferSurface.c"
					}
#line 293 "../lib/Drawing/BufferSurface.vala"
					_tmp81_ = FALSE;
#line 293 "../lib/Drawing/BufferSurface.vala"
					if (!(y < h)) {
#line 293 "../lib/Drawing/BufferSurface.vala"
						break;
#line 1696 "BufferSurface.c"
					}
#line 294 "../lib/Drawing/BufferSurface.vala"
					_tmp83_ = v_min;
#line 294 "../lib/Drawing/BufferSurface.vala"
					_tmp83__length1 = v_min_length1;
#line 294 "../lib/Drawing/BufferSurface.vala"
					_tmp83_[y] = MIN ((y + radius) + 1, h - 1) * w;
#line 295 "../lib/Drawing/BufferSurface.vala"
					_tmp84_ = v_max;
#line 295 "../lib/Drawing/BufferSurface.vala"
					_tmp84__length1 = v_max_length1;
#line 295 "../lib/Drawing/BufferSurface.vala"
					_tmp84_[y] = MAX (y - radius, 0) * w;
#line 1710 "BufferSurface.c"
				}
			}
		}
		{
			gint x = 0;
#line 298 "../lib/Drawing/BufferSurface.vala"
			x = 0;
#line 1718 "BufferSurface.c"
			{
				gboolean _tmp85_ = FALSE;
#line 298 "../lib/Drawing/BufferSurface.vala"
				_tmp85_ = TRUE;
#line 298 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 1725 "BufferSurface.c"
					gint a_sum = 0;
					gint r_sum = 0;
					gint g_sum = 0;
					gint b_sum = 0;
					guint32 cur_pixel = 0U;
					guint8* _tmp87_;
					gint _tmp87__length1;
					guint8 _tmp88_;
					guint8* _tmp89_;
					gint _tmp89__length1;
					guint8 _tmp90_;
					guint8* _tmp91_;
					gint _tmp91__length1;
					guint8 _tmp92_;
					guint8* _tmp93_;
					gint _tmp93__length1;
					guint8 _tmp94_;
#line 298 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp85_) {
#line 1745 "BufferSurface.c"
						gint _tmp86_;
#line 298 "../lib/Drawing/BufferSurface.vala"
						_tmp86_ = x;
#line 298 "../lib/Drawing/BufferSurface.vala"
						x = _tmp86_ + 1;
#line 1751 "BufferSurface.c"
					}
#line 298 "../lib/Drawing/BufferSurface.vala"
					_tmp85_ = FALSE;
#line 298 "../lib/Drawing/BufferSurface.vala"
					if (!(x < w)) {
#line 298 "../lib/Drawing/BufferSurface.vala"
						break;
#line 1759 "BufferSurface.c"
					}
#line 299 "../lib/Drawing/BufferSurface.vala"
					a_sum = 0;
#line 299 "../lib/Drawing/BufferSurface.vala"
					r_sum = 0;
#line 299 "../lib/Drawing/BufferSurface.vala"
					g_sum = 0;
#line 299 "../lib/Drawing/BufferSurface.vala"
					b_sum = 0;
#line 301 "../lib/Drawing/BufferSurface.vala"
					cur_pixel = (guint32) (x * channels);
#line 303 "../lib/Drawing/BufferSurface.vala"
					_tmp87_ = buffer;
#line 303 "../lib/Drawing/BufferSurface.vala"
					_tmp87__length1 = buffer_length1;
#line 303 "../lib/Drawing/BufferSurface.vala"
					_tmp88_ = _tmp87_[cur_pixel + 0];
#line 303 "../lib/Drawing/BufferSurface.vala"
					a_sum += radius * _tmp88_;
#line 304 "../lib/Drawing/BufferSurface.vala"
					_tmp89_ = buffer;
#line 304 "../lib/Drawing/BufferSurface.vala"
					_tmp89__length1 = buffer_length1;
#line 304 "../lib/Drawing/BufferSurface.vala"
					_tmp90_ = _tmp89_[cur_pixel + 1];
#line 304 "../lib/Drawing/BufferSurface.vala"
					r_sum += radius * _tmp90_;
#line 305 "../lib/Drawing/BufferSurface.vala"
					_tmp91_ = buffer;
#line 305 "../lib/Drawing/BufferSurface.vala"
					_tmp91__length1 = buffer_length1;
#line 305 "../lib/Drawing/BufferSurface.vala"
					_tmp92_ = _tmp91_[cur_pixel + 2];
#line 305 "../lib/Drawing/BufferSurface.vala"
					g_sum += radius * _tmp92_;
#line 306 "../lib/Drawing/BufferSurface.vala"
					_tmp93_ = buffer;
#line 306 "../lib/Drawing/BufferSurface.vala"
					_tmp93__length1 = buffer_length1;
#line 306 "../lib/Drawing/BufferSurface.vala"
					_tmp94_ = _tmp93_[cur_pixel + 3];
#line 306 "../lib/Drawing/BufferSurface.vala"
					b_sum += radius * _tmp94_;
#line 1803 "BufferSurface.c"
					{
						gint i = 0;
#line 308 "../lib/Drawing/BufferSurface.vala"
						i = 0;
#line 1808 "BufferSurface.c"
						{
							gboolean _tmp95_ = FALSE;
#line 308 "../lib/Drawing/BufferSurface.vala"
							_tmp95_ = TRUE;
#line 308 "../lib/Drawing/BufferSurface.vala"
							while (TRUE) {
#line 1815 "BufferSurface.c"
								guint8* _tmp97_;
								gint _tmp97__length1;
								guint8 _tmp98_;
								guint8* _tmp99_;
								gint _tmp99__length1;
								guint8 _tmp100_;
								guint8* _tmp101_;
								gint _tmp101__length1;
								guint8 _tmp102_;
								guint8* _tmp103_;
								gint _tmp103__length1;
								guint8 _tmp104_;
#line 308 "../lib/Drawing/BufferSurface.vala"
								if (!_tmp95_) {
#line 1830 "BufferSurface.c"
									gint _tmp96_;
#line 308 "../lib/Drawing/BufferSurface.vala"
									_tmp96_ = i;
#line 308 "../lib/Drawing/BufferSurface.vala"
									i = _tmp96_ + 1;
#line 1836 "BufferSurface.c"
								}
#line 308 "../lib/Drawing/BufferSurface.vala"
								_tmp95_ = FALSE;
#line 308 "../lib/Drawing/BufferSurface.vala"
								if (!(i <= radius)) {
#line 308 "../lib/Drawing/BufferSurface.vala"
									break;
#line 1844 "BufferSurface.c"
								}
#line 309 "../lib/Drawing/BufferSurface.vala"
								_tmp97_ = buffer;
#line 309 "../lib/Drawing/BufferSurface.vala"
								_tmp97__length1 = buffer_length1;
#line 309 "../lib/Drawing/BufferSurface.vala"
								_tmp98_ = _tmp97_[cur_pixel + 0];
#line 309 "../lib/Drawing/BufferSurface.vala"
								a_sum += (gint) _tmp98_;
#line 310 "../lib/Drawing/BufferSurface.vala"
								_tmp99_ = buffer;
#line 310 "../lib/Drawing/BufferSurface.vala"
								_tmp99__length1 = buffer_length1;
#line 310 "../lib/Drawing/BufferSurface.vala"
								_tmp100_ = _tmp99_[cur_pixel + 1];
#line 310 "../lib/Drawing/BufferSurface.vala"
								r_sum += (gint) _tmp100_;
#line 311 "../lib/Drawing/BufferSurface.vala"
								_tmp101_ = buffer;
#line 311 "../lib/Drawing/BufferSurface.vala"
								_tmp101__length1 = buffer_length1;
#line 311 "../lib/Drawing/BufferSurface.vala"
								_tmp102_ = _tmp101_[cur_pixel + 2];
#line 311 "../lib/Drawing/BufferSurface.vala"
								g_sum += (gint) _tmp102_;
#line 312 "../lib/Drawing/BufferSurface.vala"
								_tmp103_ = buffer;
#line 312 "../lib/Drawing/BufferSurface.vala"
								_tmp103__length1 = buffer_length1;
#line 312 "../lib/Drawing/BufferSurface.vala"
								_tmp104_ = _tmp103_[cur_pixel + 3];
#line 312 "../lib/Drawing/BufferSurface.vala"
								b_sum += (gint) _tmp104_;
#line 314 "../lib/Drawing/BufferSurface.vala"
								cur_pixel += (guint32) (w * channels);
#line 1880 "BufferSurface.c"
							}
						}
					}
#line 317 "../lib/Drawing/BufferSurface.vala"
					cur_pixel = (guint32) (x * channels);
#line 1886 "BufferSurface.c"
					{
						gint y = 0;
#line 319 "../lib/Drawing/BufferSurface.vala"
						y = 0;
#line 1891 "BufferSurface.c"
						{
							gboolean _tmp105_ = FALSE;
#line 319 "../lib/Drawing/BufferSurface.vala"
							_tmp105_ = TRUE;
#line 319 "../lib/Drawing/BufferSurface.vala"
							while (TRUE) {
#line 1898 "BufferSurface.c"
								guint32 p1 = 0U;
								gint* _tmp107_;
								gint _tmp107__length1;
								gint _tmp108_;
								guint32 p2 = 0U;
								gint* _tmp109_;
								gint _tmp109__length1;
								gint _tmp110_;
								guint8* _tmp111_;
								guint8* _tmp112_;
								gint _tmp112__length1;
								guint8 _tmp113_;
								guint8* _tmp114_;
								guint8* _tmp115_;
								gint _tmp115__length1;
								guint8 _tmp116_;
								guint8* _tmp117_;
								guint8* _tmp118_;
								gint _tmp118__length1;
								guint8 _tmp119_;
								guint8* _tmp120_;
								guint8* _tmp121_;
								gint _tmp121__length1;
								guint8 _tmp122_;
								guint8* _tmp123_;
								gint _tmp123__length1;
								guint8 _tmp124_;
								guint8* _tmp125_;
								gint _tmp125__length1;
								guint8 _tmp126_;
								guint8* _tmp127_;
								gint _tmp127__length1;
								guint8 _tmp128_;
								guint8* _tmp129_;
								gint _tmp129__length1;
								guint8 _tmp130_;
								guint8* _tmp131_;
								gint _tmp131__length1;
								guint8 _tmp132_;
								guint8* _tmp133_;
								gint _tmp133__length1;
								guint8 _tmp134_;
								guint8* _tmp135_;
								gint _tmp135__length1;
								guint8 _tmp136_;
								guint8* _tmp137_;
								gint _tmp137__length1;
								guint8 _tmp138_;
#line 319 "../lib/Drawing/BufferSurface.vala"
								if (!_tmp105_) {
#line 1949 "BufferSurface.c"
									gint _tmp106_;
#line 319 "../lib/Drawing/BufferSurface.vala"
									_tmp106_ = y;
#line 319 "../lib/Drawing/BufferSurface.vala"
									y = _tmp106_ + 1;
#line 1955 "BufferSurface.c"
								}
#line 319 "../lib/Drawing/BufferSurface.vala"
								_tmp105_ = FALSE;
#line 319 "../lib/Drawing/BufferSurface.vala"
								if (!(y < h)) {
#line 319 "../lib/Drawing/BufferSurface.vala"
									break;
#line 1963 "BufferSurface.c"
								}
#line 320 "../lib/Drawing/BufferSurface.vala"
								_tmp107_ = v_min;
#line 320 "../lib/Drawing/BufferSurface.vala"
								_tmp107__length1 = v_min_length1;
#line 320 "../lib/Drawing/BufferSurface.vala"
								_tmp108_ = _tmp107_[y];
#line 320 "../lib/Drawing/BufferSurface.vala"
								p1 = (guint32) ((x + _tmp108_) * channels);
#line 321 "../lib/Drawing/BufferSurface.vala"
								_tmp109_ = v_max;
#line 321 "../lib/Drawing/BufferSurface.vala"
								_tmp109__length1 = v_max_length1;
#line 321 "../lib/Drawing/BufferSurface.vala"
								_tmp110_ = _tmp109_[y];
#line 321 "../lib/Drawing/BufferSurface.vala"
								p2 = (guint32) ((x + _tmp110_) * channels);
#line 323 "../lib/Drawing/BufferSurface.vala"
								_tmp111_ = pixels;
#line 323 "../lib/Drawing/BufferSurface.vala"
								_tmp112_ = dv;
#line 323 "../lib/Drawing/BufferSurface.vala"
								_tmp112__length1 = dv_length1;
#line 323 "../lib/Drawing/BufferSurface.vala"
								_tmp113_ = _tmp112_[a_sum];
#line 323 "../lib/Drawing/BufferSurface.vala"
								_tmp111_[cur_pixel + 0] = _tmp113_;
#line 324 "../lib/Drawing/BufferSurface.vala"
								_tmp114_ = pixels;
#line 324 "../lib/Drawing/BufferSurface.vala"
								_tmp115_ = dv;
#line 324 "../lib/Drawing/BufferSurface.vala"
								_tmp115__length1 = dv_length1;
#line 324 "../lib/Drawing/BufferSurface.vala"
								_tmp116_ = _tmp115_[r_sum];
#line 324 "../lib/Drawing/BufferSurface.vala"
								_tmp114_[cur_pixel + 1] = _tmp116_;
#line 325 "../lib/Drawing/BufferSurface.vala"
								_tmp117_ = pixels;
#line 325 "../lib/Drawing/BufferSurface.vala"
								_tmp118_ = dv;
#line 325 "../lib/Drawing/BufferSurface.vala"
								_tmp118__length1 = dv_length1;
#line 325 "../lib/Drawing/BufferSurface.vala"
								_tmp119_ = _tmp118_[g_sum];
#line 325 "../lib/Drawing/BufferSurface.vala"
								_tmp117_[cur_pixel + 2] = _tmp119_;
#line 326 "../lib/Drawing/BufferSurface.vala"
								_tmp120_ = pixels;
#line 326 "../lib/Drawing/BufferSurface.vala"
								_tmp121_ = dv;
#line 326 "../lib/Drawing/BufferSurface.vala"
								_tmp121__length1 = dv_length1;
#line 326 "../lib/Drawing/BufferSurface.vala"
								_tmp122_ = _tmp121_[b_sum];
#line 326 "../lib/Drawing/BufferSurface.vala"
								_tmp120_[cur_pixel + 3] = _tmp122_;
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp123_ = buffer;
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp123__length1 = buffer_length1;
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp124_ = _tmp123_[p1 + 0];
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp125_ = buffer;
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp125__length1 = buffer_length1;
#line 328 "../lib/Drawing/BufferSurface.vala"
								_tmp126_ = _tmp125_[p2 + 0];
#line 328 "../lib/Drawing/BufferSurface.vala"
								a_sum += (gint) (_tmp124_ - _tmp126_);
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp127_ = buffer;
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp127__length1 = buffer_length1;
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp128_ = _tmp127_[p1 + 1];
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp129_ = buffer;
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp129__length1 = buffer_length1;
#line 329 "../lib/Drawing/BufferSurface.vala"
								_tmp130_ = _tmp129_[p2 + 1];
#line 329 "../lib/Drawing/BufferSurface.vala"
								r_sum += (gint) (_tmp128_ - _tmp130_);
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp131_ = buffer;
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp131__length1 = buffer_length1;
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp132_ = _tmp131_[p1 + 2];
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp133_ = buffer;
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp133__length1 = buffer_length1;
#line 330 "../lib/Drawing/BufferSurface.vala"
								_tmp134_ = _tmp133_[p2 + 2];
#line 330 "../lib/Drawing/BufferSurface.vala"
								g_sum += (gint) (_tmp132_ - _tmp134_);
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp135_ = buffer;
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp135__length1 = buffer_length1;
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp136_ = _tmp135_[p1 + 3];
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp137_ = buffer;
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp137__length1 = buffer_length1;
#line 331 "../lib/Drawing/BufferSurface.vala"
								_tmp138_ = _tmp137_[p2 + 3];
#line 331 "../lib/Drawing/BufferSurface.vala"
								b_sum += (gint) (_tmp136_ - _tmp138_);
#line 333 "../lib/Drawing/BufferSurface.vala"
								cur_pixel += (guint32) (w * channels);
#line 2079 "BufferSurface.c"
							}
						}
					}
				}
			}
		}
	}
#line 338 "../lib/Drawing/BufferSurface.vala"
	_tmp139_ = original;
#line 338 "../lib/Drawing/BufferSurface.vala"
	cairo_surface_mark_dirty (_tmp139_);
#line 340 "../lib/Drawing/BufferSurface.vala"
	_tmp140_ = granite_drawing_buffer_surface_get_context (self);
#line 340 "../lib/Drawing/BufferSurface.vala"
	_tmp141_ = _tmp140_;
#line 340 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp141_, CAIRO_OPERATOR_SOURCE);
#line 341 "../lib/Drawing/BufferSurface.vala"
	_tmp142_ = granite_drawing_buffer_surface_get_context (self);
#line 341 "../lib/Drawing/BufferSurface.vala"
	_tmp143_ = _tmp142_;
#line 341 "../lib/Drawing/BufferSurface.vala"
	_tmp144_ = original;
#line 341 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp143_, _tmp144_, (gdouble) 0, (gdouble) 0);
#line 342 "../lib/Drawing/BufferSurface.vala"
	_tmp145_ = granite_drawing_buffer_surface_get_context (self);
#line 342 "../lib/Drawing/BufferSurface.vala"
	_tmp146_ = _tmp145_;
#line 342 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp146_);
#line 343 "../lib/Drawing/BufferSurface.vala"
	_tmp147_ = granite_drawing_buffer_surface_get_context (self);
#line 343 "../lib/Drawing/BufferSurface.vala"
	_tmp148_ = _tmp147_;
#line 343 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp148_, CAIRO_OPERATOR_OVER);
#line 215 "../lib/Drawing/BufferSurface.vala"
	dv = (g_free (dv), NULL);
#line 215 "../lib/Drawing/BufferSurface.vala"
	v_max = (g_free (v_max), NULL);
#line 215 "../lib/Drawing/BufferSurface.vala"
	v_min = (g_free (v_min), NULL);
#line 215 "../lib/Drawing/BufferSurface.vala"
	buffer = (g_free (buffer), NULL);
#line 215 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (cr);
#line 215 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (original);
#line 2129 "BufferSurface.c"
}

/**
         * Performs a blur operation on the internal {@link Cairo.Surface}, using an
         * exponential blurring algorithm. This method is usually the fastest
         * and produces good-looking results (though not quite as good as gaussian's).
         *
         * @param radius the blur radius
         */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 356 "../lib/Drawing/BufferSurface.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 356 "../lib/Drawing/BufferSurface.vala"
	return _data1_;
#line 2146 "BufferSurface.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 356 "../lib/Drawing/BufferSurface.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 2156 "BufferSurface.c"
		GraniteDrawingBufferSurface* self;
#line 356 "../lib/Drawing/BufferSurface.vala"
		self = _data1_->self;
#line 356 "../lib/Drawing/BufferSurface.vala"
		_g_object_unref0 (self);
#line 356 "../lib/Drawing/BufferSurface.vala"
		g_slice_free (Block1Data, _data1_);
#line 2164 "BufferSurface.c"
	}
}

static void*
___lambda4_ (Block1Data* _data1_)
{
	GraniteDrawingBufferSurface* self;
	guint8* _tmp0_;
	void* result;
#line 376 "../lib/Drawing/BufferSurface.vala"
	self = _data1_->self;
#line 377 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = _data1_->pixels;
#line 377 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_exponential_blur_rows (self, _tmp0_, _data1_->width, _data1_->height, 0, _data1_->height / 2, 0, _data1_->width, _data1_->alpha);
#line 378 "../lib/Drawing/BufferSurface.vala"
	result = NULL;
#line 378 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2184 "BufferSurface.c"
}

static gpointer
____lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda4_ (self);
#line 376 "../lib/Drawing/BufferSurface.vala"
	block1_data_unref (self);
#line 376 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2196 "BufferSurface.c"
}

static void*
___lambda5_ (Block1Data* _data1_)
{
	GraniteDrawingBufferSurface* self;
	guint8* _tmp0_;
	void* result;
#line 385 "../lib/Drawing/BufferSurface.vala"
	self = _data1_->self;
#line 386 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = _data1_->pixels;
#line 386 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_exponential_blur_columns (self, _tmp0_, _data1_->width, _data1_->height, 0, _data1_->width / 2, 0, _data1_->height, _data1_->alpha);
#line 387 "../lib/Drawing/BufferSurface.vala"
	result = NULL;
#line 387 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2215 "BufferSurface.c"
}

static gpointer
____lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda5_ (self);
#line 385 "../lib/Drawing/BufferSurface.vala"
	block1_data_unref (self);
#line 385 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2227 "BufferSurface.c"
}

void
granite_drawing_buffer_surface_exponential_blur (GraniteDrawingBufferSurface* self,
                                                 gint radius)
{
	Block1Data* _data1_;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	guchar* _tmp11_;
	cairo_surface_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_surface_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 356 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 356 "../lib/Drawing/BufferSurface.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 356 "../lib/Drawing/BufferSurface.vala"
	_data1_->_ref_count_ = 1;
#line 356 "../lib/Drawing/BufferSurface.vala"
	_data1_->self = g_object_ref (self);
#line 357 "../lib/Drawing/BufferSurface.vala"
	if (radius < 1) {
#line 358 "../lib/Drawing/BufferSurface.vala"
		block1_data_unref (_data1_);
#line 358 "../lib/Drawing/BufferSurface.vala"
		_data1_ = NULL;
#line 358 "../lib/Drawing/BufferSurface.vala"
		return;
#line 2276 "BufferSurface.c"
	}
#line 361 "../lib/Drawing/BufferSurface.vala"
	_data1_->alpha = (gint) ((1 << GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION) * (1.0 - exp ((-2.3) / (radius + 1.0))));
#line 362 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = self->priv->_height;
#line 362 "../lib/Drawing/BufferSurface.vala"
	_data1_->height = _tmp0_;
#line 363 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = self->priv->_width;
#line 363 "../lib/Drawing/BufferSurface.vala"
	_data1_->width = _tmp1_;
#line 365 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _data1_->width, _data1_->height);
#line 365 "../lib/Drawing/BufferSurface.vala"
	original = _tmp2_;
#line 366 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = original;
#line 366 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 366 "../lib/Drawing/BufferSurface.vala"
	cr = _tmp4_;
#line 368 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = cr;
#line 368 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
#line 369 "../lib/Drawing/BufferSurface.vala"
	_tmp6_ = cr;
#line 369 "../lib/Drawing/BufferSurface.vala"
	_tmp7_ = granite_drawing_buffer_surface_get_surface (self);
#line 369 "../lib/Drawing/BufferSurface.vala"
	_tmp8_ = _tmp7_;
#line 369 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp6_, _tmp8_, (gdouble) 0, (gdouble) 0);
#line 370 "../lib/Drawing/BufferSurface.vala"
	_tmp9_ = cr;
#line 370 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp9_);
#line 372 "../lib/Drawing/BufferSurface.vala"
	_tmp10_ = original;
#line 372 "../lib/Drawing/BufferSurface.vala"
	_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 372 "../lib/Drawing/BufferSurface.vala"
	_data1_->pixels = _tmp11_;
#line 2320 "BufferSurface.c"
	{
		GThread* th = NULL;
		GThread* _tmp12_;
		guint8* _tmp13_;
		GThread* _tmp14_;
		GThread* th2 = NULL;
		GThread* _tmp15_;
		guint8* _tmp16_;
		GThread* _tmp17_;
#line 376 "../lib/Drawing/BufferSurface.vala"
		_tmp12_ = g_thread_try_new (NULL, ____lambda4__gthread_func, block1_data_ref (_data1_), &_inner_error0_);
#line 376 "../lib/Drawing/BufferSurface.vala"
		th = _tmp12_;
#line 376 "../lib/Drawing/BufferSurface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2336 "BufferSurface.c"
			goto __catch0_g_error;
		}
#line 381 "../lib/Drawing/BufferSurface.vala"
		_tmp13_ = _data1_->pixels;
#line 381 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_exponential_blur_rows (self, _tmp13_, _data1_->width, _data1_->height, _data1_->height / 2, _data1_->height, 0, _data1_->width, _data1_->alpha);
#line 382 "../lib/Drawing/BufferSurface.vala"
		_tmp14_ = th;
#line 382 "../lib/Drawing/BufferSurface.vala"
		th = NULL;
#line 382 "../lib/Drawing/BufferSurface.vala"
		g_thread_join (_tmp14_);
#line 385 "../lib/Drawing/BufferSurface.vala"
		_tmp15_ = g_thread_try_new (NULL, ____lambda5__gthread_func, block1_data_ref (_data1_), &_inner_error0_);
#line 385 "../lib/Drawing/BufferSurface.vala"
		th2 = _tmp15_;
#line 385 "../lib/Drawing/BufferSurface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../lib/Drawing/BufferSurface.vala"
			_g_thread_unref0 (th);
#line 2357 "BufferSurface.c"
			goto __catch0_g_error;
		}
#line 390 "../lib/Drawing/BufferSurface.vala"
		_tmp16_ = _data1_->pixels;
#line 390 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_exponential_blur_columns (self, _tmp16_, _data1_->width, _data1_->height, _data1_->width / 2, _data1_->width, 0, _data1_->height, _data1_->alpha);
#line 391 "../lib/Drawing/BufferSurface.vala"
		_tmp17_ = th2;
#line 391 "../lib/Drawing/BufferSurface.vala"
		th2 = NULL;
#line 391 "../lib/Drawing/BufferSurface.vala"
		g_thread_join (_tmp17_);
#line 374 "../lib/Drawing/BufferSurface.vala"
		_g_thread_unref0 (th2);
#line 374 "../lib/Drawing/BufferSurface.vala"
		_g_thread_unref0 (th);
#line 2374 "BufferSurface.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 374 "../lib/Drawing/BufferSurface.vala"
		err = _inner_error0_;
#line 374 "../lib/Drawing/BufferSurface.vala"
		_inner_error0_ = NULL;
#line 393 "../lib/Drawing/BufferSurface.vala"
		_tmp18_ = err;
#line 393 "../lib/Drawing/BufferSurface.vala"
		_tmp19_ = _tmp18_->message;
#line 393 "../lib/Drawing/BufferSurface.vala"
		g_warning ("BufferSurface.vala:393: %s", _tmp19_);
#line 374 "../lib/Drawing/BufferSurface.vala"
		_g_error_free0 (err);
#line 2394 "BufferSurface.c"
	}
	__finally0:
#line 374 "../lib/Drawing/BufferSurface.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 374 "../lib/Drawing/BufferSurface.vala"
		_cairo_destroy0 (cr);
#line 374 "../lib/Drawing/BufferSurface.vala"
		_cairo_surface_destroy0 (original);
#line 374 "../lib/Drawing/BufferSurface.vala"
		block1_data_unref (_data1_);
#line 374 "../lib/Drawing/BufferSurface.vala"
		_data1_ = NULL;
#line 374 "../lib/Drawing/BufferSurface.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 374 "../lib/Drawing/BufferSurface.vala"
		g_clear_error (&_inner_error0_);
#line 374 "../lib/Drawing/BufferSurface.vala"
		return;
#line 2413 "BufferSurface.c"
	}
#line 396 "../lib/Drawing/BufferSurface.vala"
	_tmp20_ = original;
#line 396 "../lib/Drawing/BufferSurface.vala"
	cairo_surface_mark_dirty (_tmp20_);
#line 398 "../lib/Drawing/BufferSurface.vala"
	_tmp21_ = granite_drawing_buffer_surface_get_context (self);
#line 398 "../lib/Drawing/BufferSurface.vala"
	_tmp22_ = _tmp21_;
#line 398 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp22_, CAIRO_OPERATOR_SOURCE);
#line 399 "../lib/Drawing/BufferSurface.vala"
	_tmp23_ = granite_drawing_buffer_surface_get_context (self);
#line 399 "../lib/Drawing/BufferSurface.vala"
	_tmp24_ = _tmp23_;
#line 399 "../lib/Drawing/BufferSurface.vala"
	_tmp25_ = original;
#line 399 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp24_, _tmp25_, (gdouble) 0, (gdouble) 0);
#line 400 "../lib/Drawing/BufferSurface.vala"
	_tmp26_ = granite_drawing_buffer_surface_get_context (self);
#line 400 "../lib/Drawing/BufferSurface.vala"
	_tmp27_ = _tmp26_;
#line 400 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp27_);
#line 401 "../lib/Drawing/BufferSurface.vala"
	_tmp28_ = granite_drawing_buffer_surface_get_context (self);
#line 401 "../lib/Drawing/BufferSurface.vala"
	_tmp29_ = _tmp28_;
#line 401 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp29_, CAIRO_OPERATOR_OVER);
#line 356 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (cr);
#line 356 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (original);
#line 356 "../lib/Drawing/BufferSurface.vala"
	block1_data_unref (_data1_);
#line 356 "../lib/Drawing/BufferSurface.vala"
	_data1_ = NULL;
#line 2453 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_exponential_blur_columns (GraniteDrawingBufferSurface* self,
                                                         guint8* pixels,
                                                         gint width,
                                                         gint height,
                                                         gint start_col,
                                                         gint end_col,
                                                         gint start_y,
                                                         gint end_y,
                                                         gint alpha)
{
#line 404 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 2469 "BufferSurface.c"
	{
		gint column_index = 0;
#line 414 "../lib/Drawing/BufferSurface.vala"
		column_index = start_col;
#line 2474 "BufferSurface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 414 "../lib/Drawing/BufferSurface.vala"
			_tmp0_ = TRUE;
#line 414 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 2481 "BufferSurface.c"
				guint8* column = NULL;
				gint z_alpha = 0;
				guint8* _tmp2_;
				guint8 _tmp3_;
				gint z_red = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint z_green = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint z_blue = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
#line 414 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp0_) {
#line 2497 "BufferSurface.c"
					gint _tmp1_;
#line 414 "../lib/Drawing/BufferSurface.vala"
					_tmp1_ = column_index;
#line 414 "../lib/Drawing/BufferSurface.vala"
					column_index = _tmp1_ + 1;
#line 2503 "BufferSurface.c"
				}
#line 414 "../lib/Drawing/BufferSurface.vala"
				_tmp0_ = FALSE;
#line 414 "../lib/Drawing/BufferSurface.vala"
				if (!(column_index < end_col)) {
#line 414 "../lib/Drawing/BufferSurface.vala"
					break;
#line 2511 "BufferSurface.c"
				}
#line 416 "../lib/Drawing/BufferSurface.vala"
				column = pixels + (column_index * 4);
#line 418 "../lib/Drawing/BufferSurface.vala"
				_tmp2_ = column;
#line 418 "../lib/Drawing/BufferSurface.vala"
				_tmp3_ = _tmp2_[0];
#line 418 "../lib/Drawing/BufferSurface.vala"
				z_alpha = _tmp3_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 419 "../lib/Drawing/BufferSurface.vala"
				_tmp4_ = column;
#line 419 "../lib/Drawing/BufferSurface.vala"
				_tmp5_ = _tmp4_[1];
#line 419 "../lib/Drawing/BufferSurface.vala"
				z_red = _tmp5_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 420 "../lib/Drawing/BufferSurface.vala"
				_tmp6_ = column;
#line 420 "../lib/Drawing/BufferSurface.vala"
				_tmp7_ = _tmp6_[2];
#line 420 "../lib/Drawing/BufferSurface.vala"
				z_green = _tmp7_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 421 "../lib/Drawing/BufferSurface.vala"
				_tmp8_ = column;
#line 421 "../lib/Drawing/BufferSurface.vala"
				_tmp9_ = _tmp8_[3];
#line 421 "../lib/Drawing/BufferSurface.vala"
				z_blue = _tmp9_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 2539 "BufferSurface.c"
				{
					gint index = 0;
#line 424 "../lib/Drawing/BufferSurface.vala"
					index = width * (start_y + 1);
#line 2544 "BufferSurface.c"
					{
						gboolean _tmp10_ = FALSE;
#line 424 "../lib/Drawing/BufferSurface.vala"
						_tmp10_ = TRUE;
#line 424 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 2551 "BufferSurface.c"
							guint8* _tmp11_;
#line 424 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp10_) {
#line 424 "../lib/Drawing/BufferSurface.vala"
								index += width;
#line 2557 "BufferSurface.c"
							}
#line 424 "../lib/Drawing/BufferSurface.vala"
							_tmp10_ = FALSE;
#line 424 "../lib/Drawing/BufferSurface.vala"
							if (!(index < ((end_y - 1) * width))) {
#line 424 "../lib/Drawing/BufferSurface.vala"
								break;
#line 2565 "BufferSurface.c"
							}
#line 425 "../lib/Drawing/BufferSurface.vala"
							_tmp11_ = column;
#line 425 "../lib/Drawing/BufferSurface.vala"
							granite_drawing_buffer_surface_exponential_blur_inner (&_tmp11_[index * 4], &z_alpha, &z_red, &z_green, &z_blue, alpha);
#line 2571 "BufferSurface.c"
						}
					}
				}
				{
					gint index = 0;
#line 429 "../lib/Drawing/BufferSurface.vala"
					index = (end_y - 2) * width;
#line 2579 "BufferSurface.c"
					{
						gboolean _tmp12_ = FALSE;
#line 429 "../lib/Drawing/BufferSurface.vala"
						_tmp12_ = TRUE;
#line 429 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 2586 "BufferSurface.c"
							guint8* _tmp13_;
#line 429 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp12_) {
#line 429 "../lib/Drawing/BufferSurface.vala"
								index -= width;
#line 2592 "BufferSurface.c"
							}
#line 429 "../lib/Drawing/BufferSurface.vala"
							_tmp12_ = FALSE;
#line 429 "../lib/Drawing/BufferSurface.vala"
							if (!(index >= start_y)) {
#line 429 "../lib/Drawing/BufferSurface.vala"
								break;
#line 2600 "BufferSurface.c"
							}
#line 430 "../lib/Drawing/BufferSurface.vala"
							_tmp13_ = column;
#line 430 "../lib/Drawing/BufferSurface.vala"
							granite_drawing_buffer_surface_exponential_blur_inner (&_tmp13_[index * 4], &z_alpha, &z_red, &z_green, &z_blue, alpha);
#line 2606 "BufferSurface.c"
						}
					}
				}
			}
		}
	}
}

static void
granite_drawing_buffer_surface_exponential_blur_rows (GraniteDrawingBufferSurface* self,
                                                      guint8* pixels,
                                                      gint width,
                                                      gint height,
                                                      gint start_row,
                                                      gint end_row,
                                                      gint start_x,
                                                      gint end_x,
                                                      gint alpha)
{
#line 435 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 2628 "BufferSurface.c"
	{
		gint row_index = 0;
#line 445 "../lib/Drawing/BufferSurface.vala"
		row_index = start_row;
#line 2633 "BufferSurface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 445 "../lib/Drawing/BufferSurface.vala"
			_tmp0_ = TRUE;
#line 445 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 2640 "BufferSurface.c"
				guint8* row = NULL;
				gint z_alpha = 0;
				guint8* _tmp2_;
				guint8 _tmp3_;
				gint z_red = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint z_green = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint z_blue = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
#line 445 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp0_) {
#line 2656 "BufferSurface.c"
					gint _tmp1_;
#line 445 "../lib/Drawing/BufferSurface.vala"
					_tmp1_ = row_index;
#line 445 "../lib/Drawing/BufferSurface.vala"
					row_index = _tmp1_ + 1;
#line 2662 "BufferSurface.c"
				}
#line 445 "../lib/Drawing/BufferSurface.vala"
				_tmp0_ = FALSE;
#line 445 "../lib/Drawing/BufferSurface.vala"
				if (!(row_index < end_row)) {
#line 445 "../lib/Drawing/BufferSurface.vala"
					break;
#line 2670 "BufferSurface.c"
				}
#line 447 "../lib/Drawing/BufferSurface.vala"
				row = pixels + ((row_index * width) * 4);
#line 449 "../lib/Drawing/BufferSurface.vala"
				_tmp2_ = row;
#line 449 "../lib/Drawing/BufferSurface.vala"
				_tmp3_ = _tmp2_[start_x + 0];
#line 449 "../lib/Drawing/BufferSurface.vala"
				z_alpha = _tmp3_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 450 "../lib/Drawing/BufferSurface.vala"
				_tmp4_ = row;
#line 450 "../lib/Drawing/BufferSurface.vala"
				_tmp5_ = _tmp4_[start_x + 1];
#line 450 "../lib/Drawing/BufferSurface.vala"
				z_red = _tmp5_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 451 "../lib/Drawing/BufferSurface.vala"
				_tmp6_ = row;
#line 451 "../lib/Drawing/BufferSurface.vala"
				_tmp7_ = _tmp6_[start_x + 2];
#line 451 "../lib/Drawing/BufferSurface.vala"
				z_green = _tmp7_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 452 "../lib/Drawing/BufferSurface.vala"
				_tmp8_ = row;
#line 452 "../lib/Drawing/BufferSurface.vala"
				_tmp9_ = _tmp8_[start_x + 3];
#line 452 "../lib/Drawing/BufferSurface.vala"
				z_blue = _tmp9_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION;
#line 2698 "BufferSurface.c"
				{
					gint index = 0;
#line 455 "../lib/Drawing/BufferSurface.vala"
					index = start_x + 1;
#line 2703 "BufferSurface.c"
					{
						gboolean _tmp10_ = FALSE;
#line 455 "../lib/Drawing/BufferSurface.vala"
						_tmp10_ = TRUE;
#line 455 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 2710 "BufferSurface.c"
							guint8* _tmp12_;
#line 455 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp10_) {
#line 2714 "BufferSurface.c"
								gint _tmp11_;
#line 455 "../lib/Drawing/BufferSurface.vala"
								_tmp11_ = index;
#line 455 "../lib/Drawing/BufferSurface.vala"
								index = _tmp11_ + 1;
#line 2720 "BufferSurface.c"
							}
#line 455 "../lib/Drawing/BufferSurface.vala"
							_tmp10_ = FALSE;
#line 455 "../lib/Drawing/BufferSurface.vala"
							if (!(index < end_x)) {
#line 455 "../lib/Drawing/BufferSurface.vala"
								break;
#line 2728 "BufferSurface.c"
							}
#line 456 "../lib/Drawing/BufferSurface.vala"
							_tmp12_ = row;
#line 456 "../lib/Drawing/BufferSurface.vala"
							granite_drawing_buffer_surface_exponential_blur_inner (&_tmp12_[index * 4], &z_alpha, &z_red, &z_green, &z_blue, alpha);
#line 2734 "BufferSurface.c"
						}
					}
				}
				{
					gint index = 0;
#line 459 "../lib/Drawing/BufferSurface.vala"
					index = end_x - 2;
#line 2742 "BufferSurface.c"
					{
						gboolean _tmp13_ = FALSE;
#line 459 "../lib/Drawing/BufferSurface.vala"
						_tmp13_ = TRUE;
#line 459 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 2749 "BufferSurface.c"
							guint8* _tmp15_;
#line 459 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp13_) {
#line 2753 "BufferSurface.c"
								gint _tmp14_;
#line 459 "../lib/Drawing/BufferSurface.vala"
								_tmp14_ = index;
#line 459 "../lib/Drawing/BufferSurface.vala"
								index = _tmp14_ - 1;
#line 2759 "BufferSurface.c"
							}
#line 459 "../lib/Drawing/BufferSurface.vala"
							_tmp13_ = FALSE;
#line 459 "../lib/Drawing/BufferSurface.vala"
							if (!(index >= start_x)) {
#line 459 "../lib/Drawing/BufferSurface.vala"
								break;
#line 2767 "BufferSurface.c"
							}
#line 460 "../lib/Drawing/BufferSurface.vala"
							_tmp15_ = row;
#line 460 "../lib/Drawing/BufferSurface.vala"
							granite_drawing_buffer_surface_exponential_blur_inner (&_tmp15_[index * 4], &z_alpha, &z_red, &z_green, &z_blue, alpha);
#line 2773 "BufferSurface.c"
						}
					}
				}
			}
		}
	}
}

static inline void
granite_drawing_buffer_surface_exponential_blur_inner (guint8* pixel,
                                                       gint* z_alpha,
                                                       gint* z_red,
                                                       gint* z_green,
                                                       gint* z_blue,
                                                       gint alpha)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
#line 472 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = pixel[0];
#line 472 "../lib/Drawing/BufferSurface.vala"
	*z_alpha = (*z_alpha) + ((alpha * ((_tmp0_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION) - (*z_alpha))) >> GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION);
#line 473 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = pixel[1];
#line 473 "../lib/Drawing/BufferSurface.vala"
	*z_red = (*z_red) + ((alpha * ((_tmp1_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION) - (*z_red))) >> GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION);
#line 474 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = pixel[2];
#line 474 "../lib/Drawing/BufferSurface.vala"
	*z_green = (*z_green) + ((alpha * ((_tmp2_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION) - (*z_green))) >> GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION);
#line 475 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = pixel[3];
#line 475 "../lib/Drawing/BufferSurface.vala"
	*z_blue = (*z_blue) + ((alpha * ((_tmp3_ << GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION) - (*z_blue))) >> GRANITE_DRAWING_BUFFER_SURFACE_ALPHA_PRECISION);
#line 477 "../lib/Drawing/BufferSurface.vala"
	pixel[0] = (guint8) ((*z_alpha) >> GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION);
#line 478 "../lib/Drawing/BufferSurface.vala"
	pixel[1] = (guint8) ((*z_red) >> GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION);
#line 479 "../lib/Drawing/BufferSurface.vala"
	pixel[2] = (guint8) ((*z_green) >> GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION);
#line 480 "../lib/Drawing/BufferSurface.vala"
	pixel[3] = (guint8) ((*z_blue) >> GRANITE_DRAWING_BUFFER_SURFACE_PARAM_PRECISION);
#line 2818 "BufferSurface.c"
}

/**
         * Performs a blur operation on the internal {@link Cairo.Surface}, using a
         * gaussian blurring algorithm. This method is very slow, albeit producing
         * debatably the best-looking results, and in most cases developers should
         * use the exponential blurring algorithm instead.
         *
         * @param radius the blur radius
         */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 491 "../lib/Drawing/BufferSurface.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 491 "../lib/Drawing/BufferSurface.vala"
	return _data2_;
#line 2836 "BufferSurface.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 491 "../lib/Drawing/BufferSurface.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2846 "BufferSurface.c"
		GraniteDrawingBufferSurface* self;
#line 491 "../lib/Drawing/BufferSurface.vala"
		self = _data2_->self;
#line 491 "../lib/Drawing/BufferSurface.vala"
		_data2_->shiftar = (g_free (_data2_->shiftar), NULL);
#line 491 "../lib/Drawing/BufferSurface.vala"
		_data2_->buffer_b = (g_free (_data2_->buffer_b), NULL);
#line 491 "../lib/Drawing/BufferSurface.vala"
		_data2_->buffer_a = (g_free (_data2_->buffer_a), NULL);
#line 491 "../lib/Drawing/BufferSurface.vala"
		_data2_->kernel = (g_free (_data2_->kernel), NULL);
#line 491 "../lib/Drawing/BufferSurface.vala"
		_g_object_unref0 (self);
#line 491 "../lib/Drawing/BufferSurface.vala"
		g_slice_free (Block2Data, _data2_);
#line 2862 "BufferSurface.c"
	}
}

static void*
___lambda6_ (Block2Data* _data2_)
{
	GraniteDrawingBufferSurface* self;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	void* result;
#line 530 "../lib/Drawing/BufferSurface.vala"
	self = _data2_->self;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = _data2_->buffer_a;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp0__length1 = _data2_->buffer_a_length1;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = _data2_->buffer_b;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp1__length1 = _data2_->buffer_b_length1;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = _data2_->kernel;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp2__length1 = _data2_->kernel_length1;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = _data2_->shiftar;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp3__length1 = _data2_->shiftar_length1;
#line 531 "../lib/Drawing/BufferSurface.vala"
	_tmp3__length2 = _data2_->shiftar_length2;
#line 531 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_gaussian_blur_horizontal (self, _tmp0_, _tmp1_, _tmp2_, _data2_->gauss_width, _data2_->width, _data2_->height, 0, _data2_->height / 2, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2);
#line 542 "../lib/Drawing/BufferSurface.vala"
	result = NULL;
#line 542 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2906 "BufferSurface.c"
}

static gpointer
____lambda6__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda6_ (self);
#line 530 "../lib/Drawing/BufferSurface.vala"
	block2_data_unref (self);
#line 530 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2918 "BufferSurface.c"
}

static void*
___lambda7_ (Block2Data* _data2_)
{
	GraniteDrawingBufferSurface* self;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	void* result;
#line 573 "../lib/Drawing/BufferSurface.vala"
	self = _data2_->self;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = _data2_->buffer_b;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp0__length1 = _data2_->buffer_b_length1;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = _data2_->buffer_a;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp1__length1 = _data2_->buffer_a_length1;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = _data2_->kernel;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp2__length1 = _data2_->kernel_length1;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = _data2_->shiftar;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp3__length1 = _data2_->shiftar_length1;
#line 574 "../lib/Drawing/BufferSurface.vala"
	_tmp3__length2 = _data2_->shiftar_length2;
#line 574 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_gaussian_blur_vertical (self, _tmp0_, _tmp1_, _tmp2_, _data2_->gauss_width, _data2_->width, _data2_->height, 0, _data2_->width / 2, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2);
#line 585 "../lib/Drawing/BufferSurface.vala"
	result = NULL;
#line 585 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2961 "BufferSurface.c"
}

static gpointer
____lambda7__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda7_ (self);
#line 573 "../lib/Drawing/BufferSurface.vala"
	block2_data_unref (self);
#line 573 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 2973 "BufferSurface.c"
}

void
granite_drawing_buffer_surface_gaussian_blur (GraniteDrawingBufferSurface* self,
                                              gint radius)
{
	Block2Data* _data2_;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	cairo_t* _tmp11_;
	guint8* src = NULL;
	cairo_surface_t* _tmp12_;
	guchar* _tmp13_;
	gint size = 0;
	cairo_surface_t* _tmp14_;
	gdouble* _tmp15_;
	gdouble* _tmp16_;
	gint* _tmp22_;
	cairo_surface_t* _tmp58_;
	cairo_t* _tmp59_;
	cairo_t* _tmp60_;
	cairo_t* _tmp61_;
	cairo_t* _tmp62_;
	cairo_surface_t* _tmp63_;
	cairo_t* _tmp64_;
	cairo_t* _tmp65_;
	cairo_t* _tmp66_;
	cairo_t* _tmp67_;
	GError* _inner_error0_ = NULL;
#line 491 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 491 "../lib/Drawing/BufferSurface.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 491 "../lib/Drawing/BufferSurface.vala"
	_data2_->_ref_count_ = 1;
#line 491 "../lib/Drawing/BufferSurface.vala"
	_data2_->self = g_object_ref (self);
#line 492 "../lib/Drawing/BufferSurface.vala"
	_data2_->gauss_width = (radius * 2) + 1;
#line 493 "../lib/Drawing/BufferSurface.vala"
	_tmp1_ = granite_drawing_buffer_surface_build_gaussian_kernel (_data2_->gauss_width, &_tmp0_);
#line 493 "../lib/Drawing/BufferSurface.vala"
	_data2_->kernel = _tmp1_;
#line 493 "../lib/Drawing/BufferSurface.vala"
	_data2_->kernel_length1 = _tmp0_;
#line 493 "../lib/Drawing/BufferSurface.vala"
	_data2_->_kernel_size_ = _data2_->kernel_length1;
#line 495 "../lib/Drawing/BufferSurface.vala"
	_tmp2_ = self->priv->_width;
#line 495 "../lib/Drawing/BufferSurface.vala"
	_data2_->width = _tmp2_;
#line 496 "../lib/Drawing/BufferSurface.vala"
	_tmp3_ = self->priv->_height;
#line 496 "../lib/Drawing/BufferSurface.vala"
	_data2_->height = _tmp3_;
#line 498 "../lib/Drawing/BufferSurface.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _data2_->width, _data2_->height);
#line 498 "../lib/Drawing/BufferSurface.vala"
	original = _tmp4_;
#line 499 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = original;
#line 499 "../lib/Drawing/BufferSurface.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 499 "../lib/Drawing/BufferSurface.vala"
	cr = _tmp6_;
#line 501 "../lib/Drawing/BufferSurface.vala"
	_tmp7_ = cr;
#line 501 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
#line 502 "../lib/Drawing/BufferSurface.vala"
	_tmp8_ = cr;
#line 502 "../lib/Drawing/BufferSurface.vala"
	_tmp9_ = granite_drawing_buffer_surface_get_surface (self);
#line 502 "../lib/Drawing/BufferSurface.vala"
	_tmp10_ = _tmp9_;
#line 502 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp8_, _tmp10_, (gdouble) 0, (gdouble) 0);
#line 503 "../lib/Drawing/BufferSurface.vala"
	_tmp11_ = cr;
#line 503 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp11_);
#line 505 "../lib/Drawing/BufferSurface.vala"
	_tmp12_ = original;
#line 505 "../lib/Drawing/BufferSurface.vala"
	_tmp13_ = cairo_image_surface_get_data (_tmp12_);
#line 505 "../lib/Drawing/BufferSurface.vala"
	src = _tmp13_;
#line 507 "../lib/Drawing/BufferSurface.vala"
	_tmp14_ = original;
#line 507 "../lib/Drawing/BufferSurface.vala"
	size = _data2_->height * cairo_image_surface_get_stride (_tmp14_);
#line 509 "../lib/Drawing/BufferSurface.vala"
	_tmp15_ = g_new0 (gdouble, size);
#line 509 "../lib/Drawing/BufferSurface.vala"
	_data2_->buffer_a = _tmp15_;
#line 509 "../lib/Drawing/BufferSurface.vala"
	_data2_->buffer_a_length1 = size;
#line 509 "../lib/Drawing/BufferSurface.vala"
	_data2_->_buffer_a_size_ = _data2_->buffer_a_length1;
#line 510 "../lib/Drawing/BufferSurface.vala"
	_tmp16_ = g_new0 (gdouble, size);
#line 510 "../lib/Drawing/BufferSurface.vala"
	_data2_->buffer_b = _tmp16_;
#line 510 "../lib/Drawing/BufferSurface.vala"
	_data2_->buffer_b_length1 = size;
#line 510 "../lib/Drawing/BufferSurface.vala"
	_data2_->_buffer_b_size_ = _data2_->buffer_b_length1;
#line 3092 "BufferSurface.c"
	{
		gint i = 0;
#line 513 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 3097 "BufferSurface.c"
		{
			gboolean _tmp17_ = FALSE;
#line 513 "../lib/Drawing/BufferSurface.vala"
			_tmp17_ = TRUE;
#line 513 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 3104 "BufferSurface.c"
				gdouble* _tmp19_;
				gint _tmp19__length1;
				guint8* _tmp20_;
				guint8 _tmp21_;
#line 513 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp17_) {
#line 3111 "BufferSurface.c"
					gint _tmp18_;
#line 513 "../lib/Drawing/BufferSurface.vala"
					_tmp18_ = i;
#line 513 "../lib/Drawing/BufferSurface.vala"
					i = _tmp18_ + 1;
#line 3117 "BufferSurface.c"
				}
#line 513 "../lib/Drawing/BufferSurface.vala"
				_tmp17_ = FALSE;
#line 513 "../lib/Drawing/BufferSurface.vala"
				if (!(i < size)) {
#line 513 "../lib/Drawing/BufferSurface.vala"
					break;
#line 3125 "BufferSurface.c"
				}
#line 514 "../lib/Drawing/BufferSurface.vala"
				_tmp19_ = _data2_->buffer_a;
#line 514 "../lib/Drawing/BufferSurface.vala"
				_tmp19__length1 = _data2_->buffer_a_length1;
#line 514 "../lib/Drawing/BufferSurface.vala"
				_tmp20_ = src;
#line 514 "../lib/Drawing/BufferSurface.vala"
				_tmp21_ = _tmp20_[i];
#line 514 "../lib/Drawing/BufferSurface.vala"
				_tmp19_[i] = (gdouble) _tmp21_;
#line 3137 "BufferSurface.c"
			}
		}
	}
#line 518 "../lib/Drawing/BufferSurface.vala"
	_tmp22_ = g_new0 (gint, MAX (_data2_->width, _data2_->height) * _data2_->gauss_width);
#line 518 "../lib/Drawing/BufferSurface.vala"
	_data2_->shiftar = _tmp22_;
#line 518 "../lib/Drawing/BufferSurface.vala"
	_data2_->shiftar_length1 = MAX (_data2_->width, _data2_->height);
#line 518 "../lib/Drawing/BufferSurface.vala"
	_data2_->shiftar_length2 = _data2_->gauss_width;
#line 3149 "BufferSurface.c"
	{
		gint x = 0;
#line 519 "../lib/Drawing/BufferSurface.vala"
		x = 0;
#line 3154 "BufferSurface.c"
		{
			gboolean _tmp23_ = FALSE;
#line 519 "../lib/Drawing/BufferSurface.vala"
			_tmp23_ = TRUE;
#line 519 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 519 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp23_) {
#line 3163 "BufferSurface.c"
					gint _tmp24_;
#line 519 "../lib/Drawing/BufferSurface.vala"
					_tmp24_ = x;
#line 519 "../lib/Drawing/BufferSurface.vala"
					x = _tmp24_ + 1;
#line 3169 "BufferSurface.c"
				}
#line 519 "../lib/Drawing/BufferSurface.vala"
				_tmp23_ = FALSE;
#line 519 "../lib/Drawing/BufferSurface.vala"
				if (!(x < _data2_->width)) {
#line 519 "../lib/Drawing/BufferSurface.vala"
					break;
#line 3177 "BufferSurface.c"
				}
				{
					gint k = 0;
#line 520 "../lib/Drawing/BufferSurface.vala"
					k = 0;
#line 3183 "BufferSurface.c"
					{
						gboolean _tmp25_ = FALSE;
#line 520 "../lib/Drawing/BufferSurface.vala"
						_tmp25_ = TRUE;
#line 520 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 3190 "BufferSurface.c"
							gint shift = 0;
							gboolean _tmp27_ = FALSE;
#line 520 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp25_) {
#line 3195 "BufferSurface.c"
								gint _tmp26_;
#line 520 "../lib/Drawing/BufferSurface.vala"
								_tmp26_ = k;
#line 520 "../lib/Drawing/BufferSurface.vala"
								k = _tmp26_ + 1;
#line 3201 "BufferSurface.c"
							}
#line 520 "../lib/Drawing/BufferSurface.vala"
							_tmp25_ = FALSE;
#line 520 "../lib/Drawing/BufferSurface.vala"
							if (!(k < _data2_->gauss_width)) {
#line 520 "../lib/Drawing/BufferSurface.vala"
								break;
#line 3209 "BufferSurface.c"
							}
#line 521 "../lib/Drawing/BufferSurface.vala"
							shift = k - radius;
#line 522 "../lib/Drawing/BufferSurface.vala"
							if ((x + shift) <= 0) {
#line 522 "../lib/Drawing/BufferSurface.vala"
								_tmp27_ = TRUE;
#line 3217 "BufferSurface.c"
							} else {
#line 522 "../lib/Drawing/BufferSurface.vala"
								_tmp27_ = (x + shift) >= _data2_->width;
#line 3221 "BufferSurface.c"
							}
#line 522 "../lib/Drawing/BufferSurface.vala"
							if (_tmp27_) {
#line 3225 "BufferSurface.c"
								gint* _tmp28_;
								gint _tmp28__length1;
								gint _tmp28__length2;
#line 523 "../lib/Drawing/BufferSurface.vala"
								_tmp28_ = _data2_->shiftar;
#line 523 "../lib/Drawing/BufferSurface.vala"
								_tmp28__length1 = _data2_->shiftar_length1;
#line 523 "../lib/Drawing/BufferSurface.vala"
								_tmp28__length2 = _data2_->shiftar_length2;
#line 523 "../lib/Drawing/BufferSurface.vala"
								_tmp28_[(x * _tmp28__length2) + k] = 0;
#line 3237 "BufferSurface.c"
							} else {
								gint* _tmp29_;
								gint _tmp29__length1;
								gint _tmp29__length2;
#line 525 "../lib/Drawing/BufferSurface.vala"
								_tmp29_ = _data2_->shiftar;
#line 525 "../lib/Drawing/BufferSurface.vala"
								_tmp29__length1 = _data2_->shiftar_length1;
#line 525 "../lib/Drawing/BufferSurface.vala"
								_tmp29__length2 = _data2_->shiftar_length2;
#line 525 "../lib/Drawing/BufferSurface.vala"
								_tmp29_[(x * _tmp29__length2) + k] = shift * 4;
#line 3250 "BufferSurface.c"
							}
						}
					}
				}
			}
		}
	}
	{
		GThread* th = NULL;
		GThread* _tmp30_;
		gdouble* _tmp31_;
		gint _tmp31__length1;
		gdouble* _tmp32_;
		gint _tmp32__length1;
		gdouble* _tmp33_;
		gint _tmp33__length1;
		gint* _tmp34_;
		gint _tmp34__length1;
		gint _tmp34__length2;
		GThread* _tmp35_;
		gdouble* _tmp36_;
		gint _tmp36__length1;
		gint* _tmp37_;
		GThread* th2 = NULL;
		GThread* _tmp45_;
		gdouble* _tmp46_;
		gint _tmp46__length1;
		gdouble* _tmp47_;
		gint _tmp47__length1;
		gdouble* _tmp48_;
		gint _tmp48__length1;
		gint* _tmp49_;
		gint _tmp49__length1;
		gint _tmp49__length2;
		GThread* _tmp50_;
#line 530 "../lib/Drawing/BufferSurface.vala"
		_tmp30_ = g_thread_try_new (NULL, ____lambda6__gthread_func, block2_data_ref (_data2_), &_inner_error0_);
#line 530 "../lib/Drawing/BufferSurface.vala"
		th = _tmp30_;
#line 530 "../lib/Drawing/BufferSurface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3292 "BufferSurface.c"
			goto __catch0_g_error;
		}
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp31_ = _data2_->buffer_a;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp31__length1 = _data2_->buffer_a_length1;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp32_ = _data2_->buffer_b;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp32__length1 = _data2_->buffer_b_length1;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp33_ = _data2_->kernel;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp33__length1 = _data2_->kernel_length1;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp34_ = _data2_->shiftar;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp34__length1 = _data2_->shiftar_length1;
#line 545 "../lib/Drawing/BufferSurface.vala"
		_tmp34__length2 = _data2_->shiftar_length2;
#line 545 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_gaussian_blur_horizontal (self, _tmp31_, _tmp32_, _tmp33_, _data2_->gauss_width, _data2_->width, _data2_->height, _data2_->height / 2, _data2_->height, _tmp34_, (gint) _tmp34__length1, (gint) _tmp34__length2);
#line 556 "../lib/Drawing/BufferSurface.vala"
		_tmp35_ = th;
#line 556 "../lib/Drawing/BufferSurface.vala"
		th = NULL;
#line 556 "../lib/Drawing/BufferSurface.vala"
		g_thread_join (_tmp35_);
#line 559 "../lib/Drawing/BufferSurface.vala"
		_tmp36_ = _data2_->buffer_a;
#line 559 "../lib/Drawing/BufferSurface.vala"
		_tmp36__length1 = _data2_->buffer_a_length1;
#line 559 "../lib/Drawing/BufferSurface.vala"
		memset (_tmp36_, 0, (gsize) (sizeof (gdouble) * size));
#line 562 "../lib/Drawing/BufferSurface.vala"
		_tmp37_ = g_new0 (gint, MAX (_data2_->width, _data2_->height) * _data2_->gauss_width);
#line 562 "../lib/Drawing/BufferSurface.vala"
		_data2_->shiftar = (g_free (_data2_->shiftar), NULL);
#line 562 "../lib/Drawing/BufferSurface.vala"
		_data2_->shiftar = _tmp37_;
#line 562 "../lib/Drawing/BufferSurface.vala"
		_data2_->shiftar_length1 = MAX (_data2_->width, _data2_->height);
#line 562 "../lib/Drawing/BufferSurface.vala"
		_data2_->shiftar_length2 = _data2_->gauss_width;
#line 3337 "BufferSurface.c"
		{
			gint y = 0;
#line 563 "../lib/Drawing/BufferSurface.vala"
			y = 0;
#line 3342 "BufferSurface.c"
			{
				gboolean _tmp38_ = FALSE;
#line 563 "../lib/Drawing/BufferSurface.vala"
				_tmp38_ = TRUE;
#line 563 "../lib/Drawing/BufferSurface.vala"
				while (TRUE) {
#line 563 "../lib/Drawing/BufferSurface.vala"
					if (!_tmp38_) {
#line 3351 "BufferSurface.c"
						gint _tmp39_;
#line 563 "../lib/Drawing/BufferSurface.vala"
						_tmp39_ = y;
#line 563 "../lib/Drawing/BufferSurface.vala"
						y = _tmp39_ + 1;
#line 3357 "BufferSurface.c"
					}
#line 563 "../lib/Drawing/BufferSurface.vala"
					_tmp38_ = FALSE;
#line 563 "../lib/Drawing/BufferSurface.vala"
					if (!(y < _data2_->height)) {
#line 563 "../lib/Drawing/BufferSurface.vala"
						break;
#line 3365 "BufferSurface.c"
					}
					{
						gint k = 0;
#line 564 "../lib/Drawing/BufferSurface.vala"
						k = 0;
#line 3371 "BufferSurface.c"
						{
							gboolean _tmp40_ = FALSE;
#line 564 "../lib/Drawing/BufferSurface.vala"
							_tmp40_ = TRUE;
#line 564 "../lib/Drawing/BufferSurface.vala"
							while (TRUE) {
#line 3378 "BufferSurface.c"
								gint shift = 0;
								gboolean _tmp42_ = FALSE;
#line 564 "../lib/Drawing/BufferSurface.vala"
								if (!_tmp40_) {
#line 3383 "BufferSurface.c"
									gint _tmp41_;
#line 564 "../lib/Drawing/BufferSurface.vala"
									_tmp41_ = k;
#line 564 "../lib/Drawing/BufferSurface.vala"
									k = _tmp41_ + 1;
#line 3389 "BufferSurface.c"
								}
#line 564 "../lib/Drawing/BufferSurface.vala"
								_tmp40_ = FALSE;
#line 564 "../lib/Drawing/BufferSurface.vala"
								if (!(k < _data2_->gauss_width)) {
#line 564 "../lib/Drawing/BufferSurface.vala"
									break;
#line 3397 "BufferSurface.c"
								}
#line 565 "../lib/Drawing/BufferSurface.vala"
								shift = k - radius;
#line 566 "../lib/Drawing/BufferSurface.vala"
								if ((y + shift) <= 0) {
#line 566 "../lib/Drawing/BufferSurface.vala"
									_tmp42_ = TRUE;
#line 3405 "BufferSurface.c"
								} else {
#line 566 "../lib/Drawing/BufferSurface.vala"
									_tmp42_ = (y + shift) >= _data2_->height;
#line 3409 "BufferSurface.c"
								}
#line 566 "../lib/Drawing/BufferSurface.vala"
								if (_tmp42_) {
#line 3413 "BufferSurface.c"
									gint* _tmp43_;
									gint _tmp43__length1;
									gint _tmp43__length2;
#line 567 "../lib/Drawing/BufferSurface.vala"
									_tmp43_ = _data2_->shiftar;
#line 567 "../lib/Drawing/BufferSurface.vala"
									_tmp43__length1 = _data2_->shiftar_length1;
#line 567 "../lib/Drawing/BufferSurface.vala"
									_tmp43__length2 = _data2_->shiftar_length2;
#line 567 "../lib/Drawing/BufferSurface.vala"
									_tmp43_[(y * _tmp43__length2) + k] = 0;
#line 3425 "BufferSurface.c"
								} else {
									gint* _tmp44_;
									gint _tmp44__length1;
									gint _tmp44__length2;
#line 569 "../lib/Drawing/BufferSurface.vala"
									_tmp44_ = _data2_->shiftar;
#line 569 "../lib/Drawing/BufferSurface.vala"
									_tmp44__length1 = _data2_->shiftar_length1;
#line 569 "../lib/Drawing/BufferSurface.vala"
									_tmp44__length2 = _data2_->shiftar_length2;
#line 569 "../lib/Drawing/BufferSurface.vala"
									_tmp44_[(y * _tmp44__length2) + k] = (shift * _data2_->width) * 4;
#line 3438 "BufferSurface.c"
								}
							}
						}
					}
				}
			}
		}
#line 573 "../lib/Drawing/BufferSurface.vala"
		_tmp45_ = g_thread_try_new (NULL, ____lambda7__gthread_func, block2_data_ref (_data2_), &_inner_error0_);
#line 573 "../lib/Drawing/BufferSurface.vala"
		th2 = _tmp45_;
#line 573 "../lib/Drawing/BufferSurface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 573 "../lib/Drawing/BufferSurface.vala"
			_g_thread_unref0 (th);
#line 3454 "BufferSurface.c"
			goto __catch0_g_error;
		}
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp46_ = _data2_->buffer_b;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp46__length1 = _data2_->buffer_b_length1;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp47_ = _data2_->buffer_a;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp47__length1 = _data2_->buffer_a_length1;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp48_ = _data2_->kernel;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp48__length1 = _data2_->kernel_length1;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp49_ = _data2_->shiftar;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp49__length1 = _data2_->shiftar_length1;
#line 588 "../lib/Drawing/BufferSurface.vala"
		_tmp49__length2 = _data2_->shiftar_length2;
#line 588 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_gaussian_blur_vertical (self, _tmp46_, _tmp47_, _tmp48_, _data2_->gauss_width, _data2_->width, _data2_->height, _data2_->width / 2, _data2_->width, _tmp49_, (gint) _tmp49__length1, (gint) _tmp49__length2);
#line 599 "../lib/Drawing/BufferSurface.vala"
		_tmp50_ = th2;
#line 599 "../lib/Drawing/BufferSurface.vala"
		th2 = NULL;
#line 599 "../lib/Drawing/BufferSurface.vala"
		g_thread_join (_tmp50_);
#line 528 "../lib/Drawing/BufferSurface.vala"
		_g_thread_unref0 (th2);
#line 528 "../lib/Drawing/BufferSurface.vala"
		_g_thread_unref0 (th);
#line 3487 "BufferSurface.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 528 "../lib/Drawing/BufferSurface.vala"
		err = _inner_error0_;
#line 528 "../lib/Drawing/BufferSurface.vala"
		_inner_error0_ = NULL;
#line 601 "../lib/Drawing/BufferSurface.vala"
		_tmp51_ = err;
#line 601 "../lib/Drawing/BufferSurface.vala"
		_tmp52_ = _tmp51_->message;
#line 601 "../lib/Drawing/BufferSurface.vala"
		g_message ("BufferSurface.vala:601: %s", _tmp52_);
#line 528 "../lib/Drawing/BufferSurface.vala"
		_g_error_free0 (err);
#line 3507 "BufferSurface.c"
	}
	__finally0:
#line 528 "../lib/Drawing/BufferSurface.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 528 "../lib/Drawing/BufferSurface.vala"
		_cairo_destroy0 (cr);
#line 528 "../lib/Drawing/BufferSurface.vala"
		_cairo_surface_destroy0 (original);
#line 528 "../lib/Drawing/BufferSurface.vala"
		block2_data_unref (_data2_);
#line 528 "../lib/Drawing/BufferSurface.vala"
		_data2_ = NULL;
#line 528 "../lib/Drawing/BufferSurface.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 528 "../lib/Drawing/BufferSurface.vala"
		g_clear_error (&_inner_error0_);
#line 528 "../lib/Drawing/BufferSurface.vala"
		return;
#line 3526 "BufferSurface.c"
	}
	{
		gint i = 0;
#line 605 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 3532 "BufferSurface.c"
		{
			gboolean _tmp53_ = FALSE;
#line 605 "../lib/Drawing/BufferSurface.vala"
			_tmp53_ = TRUE;
#line 605 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 3539 "BufferSurface.c"
				guint8* _tmp55_;
				gdouble* _tmp56_;
				gint _tmp56__length1;
				gdouble _tmp57_;
#line 605 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp53_) {
#line 3546 "BufferSurface.c"
					gint _tmp54_;
#line 605 "../lib/Drawing/BufferSurface.vala"
					_tmp54_ = i;
#line 605 "../lib/Drawing/BufferSurface.vala"
					i = _tmp54_ + 1;
#line 3552 "BufferSurface.c"
				}
#line 605 "../lib/Drawing/BufferSurface.vala"
				_tmp53_ = FALSE;
#line 605 "../lib/Drawing/BufferSurface.vala"
				if (!(i < size)) {
#line 605 "../lib/Drawing/BufferSurface.vala"
					break;
#line 3560 "BufferSurface.c"
				}
#line 606 "../lib/Drawing/BufferSurface.vala"
				_tmp55_ = src;
#line 606 "../lib/Drawing/BufferSurface.vala"
				_tmp56_ = _data2_->buffer_a;
#line 606 "../lib/Drawing/BufferSurface.vala"
				_tmp56__length1 = _data2_->buffer_a_length1;
#line 606 "../lib/Drawing/BufferSurface.vala"
				_tmp57_ = _tmp56_[i];
#line 606 "../lib/Drawing/BufferSurface.vala"
				_tmp55_[i] = (guint8) _tmp57_;
#line 3572 "BufferSurface.c"
			}
		}
	}
#line 609 "../lib/Drawing/BufferSurface.vala"
	_tmp58_ = original;
#line 609 "../lib/Drawing/BufferSurface.vala"
	cairo_surface_mark_dirty (_tmp58_);
#line 611 "../lib/Drawing/BufferSurface.vala"
	_tmp59_ = granite_drawing_buffer_surface_get_context (self);
#line 611 "../lib/Drawing/BufferSurface.vala"
	_tmp60_ = _tmp59_;
#line 611 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp60_, CAIRO_OPERATOR_SOURCE);
#line 612 "../lib/Drawing/BufferSurface.vala"
	_tmp61_ = granite_drawing_buffer_surface_get_context (self);
#line 612 "../lib/Drawing/BufferSurface.vala"
	_tmp62_ = _tmp61_;
#line 612 "../lib/Drawing/BufferSurface.vala"
	_tmp63_ = original;
#line 612 "../lib/Drawing/BufferSurface.vala"
	cairo_set_source_surface (_tmp62_, _tmp63_, (gdouble) 0, (gdouble) 0);
#line 613 "../lib/Drawing/BufferSurface.vala"
	_tmp64_ = granite_drawing_buffer_surface_get_context (self);
#line 613 "../lib/Drawing/BufferSurface.vala"
	_tmp65_ = _tmp64_;
#line 613 "../lib/Drawing/BufferSurface.vala"
	cairo_paint (_tmp65_);
#line 614 "../lib/Drawing/BufferSurface.vala"
	_tmp66_ = granite_drawing_buffer_surface_get_context (self);
#line 614 "../lib/Drawing/BufferSurface.vala"
	_tmp67_ = _tmp66_;
#line 614 "../lib/Drawing/BufferSurface.vala"
	cairo_set_operator (_tmp67_, CAIRO_OPERATOR_OVER);
#line 491 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (cr);
#line 491 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (original);
#line 491 "../lib/Drawing/BufferSurface.vala"
	block2_data_unref (_data2_);
#line 491 "../lib/Drawing/BufferSurface.vala"
	_data2_ = NULL;
#line 3614 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_gaussian_blur_horizontal (GraniteDrawingBufferSurface* self,
                                                         gdouble* src,
                                                         gdouble* dest,
                                                         gdouble* kernel,
                                                         gint gauss_width,
                                                         gint width,
                                                         gint height,
                                                         gint start_row,
                                                         gint end_row,
                                                         gint* shift,
                                                         gint shift_length1,
                                                         gint shift_length2)
{
	guint32 cur_pixel = 0U;
#line 617 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 628 "../lib/Drawing/BufferSurface.vala"
	cur_pixel = (guint32) ((start_row * width) * 4);
#line 3636 "BufferSurface.c"
	{
		gint y = 0;
#line 630 "../lib/Drawing/BufferSurface.vala"
		y = start_row;
#line 3641 "BufferSurface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 630 "../lib/Drawing/BufferSurface.vala"
			_tmp0_ = TRUE;
#line 630 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 630 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp0_) {
#line 3650 "BufferSurface.c"
					gint _tmp1_;
#line 630 "../lib/Drawing/BufferSurface.vala"
					_tmp1_ = y;
#line 630 "../lib/Drawing/BufferSurface.vala"
					y = _tmp1_ + 1;
#line 3656 "BufferSurface.c"
				}
#line 630 "../lib/Drawing/BufferSurface.vala"
				_tmp0_ = FALSE;
#line 630 "../lib/Drawing/BufferSurface.vala"
				if (!(y < end_row)) {
#line 630 "../lib/Drawing/BufferSurface.vala"
					break;
#line 3664 "BufferSurface.c"
				}
				{
					gint x = 0;
#line 631 "../lib/Drawing/BufferSurface.vala"
					x = 0;
#line 3670 "BufferSurface.c"
					{
						gboolean _tmp2_ = FALSE;
#line 631 "../lib/Drawing/BufferSurface.vala"
						_tmp2_ = TRUE;
#line 631 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 631 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp2_) {
#line 3679 "BufferSurface.c"
								gint _tmp3_;
#line 631 "../lib/Drawing/BufferSurface.vala"
								_tmp3_ = x;
#line 631 "../lib/Drawing/BufferSurface.vala"
								x = _tmp3_ + 1;
#line 3685 "BufferSurface.c"
							}
#line 631 "../lib/Drawing/BufferSurface.vala"
							_tmp2_ = FALSE;
#line 631 "../lib/Drawing/BufferSurface.vala"
							if (!(x < width)) {
#line 631 "../lib/Drawing/BufferSurface.vala"
								break;
#line 3693 "BufferSurface.c"
							}
							{
								gint k = 0;
#line 632 "../lib/Drawing/BufferSurface.vala"
								k = 0;
#line 3699 "BufferSurface.c"
								{
									gboolean _tmp4_ = FALSE;
#line 632 "../lib/Drawing/BufferSurface.vala"
									_tmp4_ = TRUE;
#line 632 "../lib/Drawing/BufferSurface.vala"
									while (TRUE) {
#line 3706 "BufferSurface.c"
										guint32 source = 0U;
										gint _tmp6_;
										gdouble _tmp7_;
										gdouble _tmp8_;
										gdouble _tmp9_;
										gdouble _tmp10_;
										gdouble _tmp11_;
										gdouble _tmp12_;
										gdouble _tmp13_;
										gdouble _tmp14_;
#line 632 "../lib/Drawing/BufferSurface.vala"
										if (!_tmp4_) {
#line 3719 "BufferSurface.c"
											gint _tmp5_;
#line 632 "../lib/Drawing/BufferSurface.vala"
											_tmp5_ = k;
#line 632 "../lib/Drawing/BufferSurface.vala"
											k = _tmp5_ + 1;
#line 3725 "BufferSurface.c"
										}
#line 632 "../lib/Drawing/BufferSurface.vala"
										_tmp4_ = FALSE;
#line 632 "../lib/Drawing/BufferSurface.vala"
										if (!(k < gauss_width)) {
#line 632 "../lib/Drawing/BufferSurface.vala"
											break;
#line 3733 "BufferSurface.c"
										}
#line 633 "../lib/Drawing/BufferSurface.vala"
										_tmp6_ = shift[(x * shift_length2) + k];
#line 633 "../lib/Drawing/BufferSurface.vala"
										source = cur_pixel + _tmp6_;
#line 635 "../lib/Drawing/BufferSurface.vala"
										_tmp7_ = src[source + 0];
#line 635 "../lib/Drawing/BufferSurface.vala"
										_tmp8_ = kernel[k];
#line 635 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 0] += _tmp7_ * _tmp8_;
#line 636 "../lib/Drawing/BufferSurface.vala"
										_tmp9_ = src[source + 1];
#line 636 "../lib/Drawing/BufferSurface.vala"
										_tmp10_ = kernel[k];
#line 636 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 1] += _tmp9_ * _tmp10_;
#line 637 "../lib/Drawing/BufferSurface.vala"
										_tmp11_ = src[source + 2];
#line 637 "../lib/Drawing/BufferSurface.vala"
										_tmp12_ = kernel[k];
#line 637 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 2] += _tmp11_ * _tmp12_;
#line 638 "../lib/Drawing/BufferSurface.vala"
										_tmp13_ = src[source + 3];
#line 638 "../lib/Drawing/BufferSurface.vala"
										_tmp14_ = kernel[k];
#line 638 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 3] += _tmp13_ * _tmp14_;
#line 3763 "BufferSurface.c"
									}
								}
							}
#line 641 "../lib/Drawing/BufferSurface.vala"
							cur_pixel += (guint32) 4;
#line 3769 "BufferSurface.c"
						}
					}
				}
			}
		}
	}
}

static void
granite_drawing_buffer_surface_gaussian_blur_vertical (GraniteDrawingBufferSurface* self,
                                                       gdouble* src,
                                                       gdouble* dest,
                                                       gdouble* kernel,
                                                       gint gauss_width,
                                                       gint width,
                                                       gint height,
                                                       gint start_col,
                                                       gint end_col,
                                                       gint* shift,
                                                       gint shift_length1,
                                                       gint shift_length2)
{
	guint32 cur_pixel = 0U;
#line 646 "../lib/Drawing/BufferSurface.vala"
	g_return_if_fail (self != NULL);
#line 657 "../lib/Drawing/BufferSurface.vala"
	cur_pixel = (guint32) (start_col * 4);
#line 3797 "BufferSurface.c"
	{
		gint y = 0;
#line 659 "../lib/Drawing/BufferSurface.vala"
		y = 0;
#line 3802 "BufferSurface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 659 "../lib/Drawing/BufferSurface.vala"
			_tmp0_ = TRUE;
#line 659 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 659 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp0_) {
#line 3811 "BufferSurface.c"
					gint _tmp1_;
#line 659 "../lib/Drawing/BufferSurface.vala"
					_tmp1_ = y;
#line 659 "../lib/Drawing/BufferSurface.vala"
					y = _tmp1_ + 1;
#line 3817 "BufferSurface.c"
				}
#line 659 "../lib/Drawing/BufferSurface.vala"
				_tmp0_ = FALSE;
#line 659 "../lib/Drawing/BufferSurface.vala"
				if (!(y < height)) {
#line 659 "../lib/Drawing/BufferSurface.vala"
					break;
#line 3825 "BufferSurface.c"
				}
				{
					gint x = 0;
#line 660 "../lib/Drawing/BufferSurface.vala"
					x = start_col;
#line 3831 "BufferSurface.c"
					{
						gboolean _tmp2_ = FALSE;
#line 660 "../lib/Drawing/BufferSurface.vala"
						_tmp2_ = TRUE;
#line 660 "../lib/Drawing/BufferSurface.vala"
						while (TRUE) {
#line 660 "../lib/Drawing/BufferSurface.vala"
							if (!_tmp2_) {
#line 3840 "BufferSurface.c"
								gint _tmp3_;
#line 660 "../lib/Drawing/BufferSurface.vala"
								_tmp3_ = x;
#line 660 "../lib/Drawing/BufferSurface.vala"
								x = _tmp3_ + 1;
#line 3846 "BufferSurface.c"
							}
#line 660 "../lib/Drawing/BufferSurface.vala"
							_tmp2_ = FALSE;
#line 660 "../lib/Drawing/BufferSurface.vala"
							if (!(x < end_col)) {
#line 660 "../lib/Drawing/BufferSurface.vala"
								break;
#line 3854 "BufferSurface.c"
							}
							{
								gint k = 0;
#line 661 "../lib/Drawing/BufferSurface.vala"
								k = 0;
#line 3860 "BufferSurface.c"
								{
									gboolean _tmp4_ = FALSE;
#line 661 "../lib/Drawing/BufferSurface.vala"
									_tmp4_ = TRUE;
#line 661 "../lib/Drawing/BufferSurface.vala"
									while (TRUE) {
#line 3867 "BufferSurface.c"
										guint32 source = 0U;
										gint _tmp6_;
										gdouble _tmp7_;
										gdouble _tmp8_;
										gdouble _tmp9_;
										gdouble _tmp10_;
										gdouble _tmp11_;
										gdouble _tmp12_;
										gdouble _tmp13_;
										gdouble _tmp14_;
#line 661 "../lib/Drawing/BufferSurface.vala"
										if (!_tmp4_) {
#line 3880 "BufferSurface.c"
											gint _tmp5_;
#line 661 "../lib/Drawing/BufferSurface.vala"
											_tmp5_ = k;
#line 661 "../lib/Drawing/BufferSurface.vala"
											k = _tmp5_ + 1;
#line 3886 "BufferSurface.c"
										}
#line 661 "../lib/Drawing/BufferSurface.vala"
										_tmp4_ = FALSE;
#line 661 "../lib/Drawing/BufferSurface.vala"
										if (!(k < gauss_width)) {
#line 661 "../lib/Drawing/BufferSurface.vala"
											break;
#line 3894 "BufferSurface.c"
										}
#line 662 "../lib/Drawing/BufferSurface.vala"
										_tmp6_ = shift[(y * shift_length2) + k];
#line 662 "../lib/Drawing/BufferSurface.vala"
										source = cur_pixel + _tmp6_;
#line 664 "../lib/Drawing/BufferSurface.vala"
										_tmp7_ = src[source + 0];
#line 664 "../lib/Drawing/BufferSurface.vala"
										_tmp8_ = kernel[k];
#line 664 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 0] += _tmp7_ * _tmp8_;
#line 665 "../lib/Drawing/BufferSurface.vala"
										_tmp9_ = src[source + 1];
#line 665 "../lib/Drawing/BufferSurface.vala"
										_tmp10_ = kernel[k];
#line 665 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 1] += _tmp9_ * _tmp10_;
#line 666 "../lib/Drawing/BufferSurface.vala"
										_tmp11_ = src[source + 2];
#line 666 "../lib/Drawing/BufferSurface.vala"
										_tmp12_ = kernel[k];
#line 666 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 2] += _tmp11_ * _tmp12_;
#line 667 "../lib/Drawing/BufferSurface.vala"
										_tmp13_ = src[source + 3];
#line 667 "../lib/Drawing/BufferSurface.vala"
										_tmp14_ = kernel[k];
#line 667 "../lib/Drawing/BufferSurface.vala"
										dest[cur_pixel + 3] += _tmp13_ * _tmp14_;
#line 3924 "BufferSurface.c"
									}
								}
							}
#line 670 "../lib/Drawing/BufferSurface.vala"
							cur_pixel += (guint32) 4;
#line 3930 "BufferSurface.c"
						}
					}
				}
#line 672 "../lib/Drawing/BufferSurface.vala"
				cur_pixel += (guint32) (((width - end_col) + start_col) * 4);
#line 3936 "BufferSurface.c"
			}
		}
	}
}

static gdouble*
granite_drawing_buffer_surface_build_gaussian_kernel (gint gauss_width,
                                                      gint* result_length1)
{
	gdouble* kernel = NULL;
	gdouble* _tmp0_;
	gint kernel_length1;
	gint _kernel_size_;
	gdouble sd = 0.0;
	gint range = 0;
	gdouble mean = 0.0;
	gdouble gauss_sum = 0.0;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble* _tmp12_;
	gint _tmp12__length1;
	gdouble* result;
#line 676 "../lib/Drawing/BufferSurface.vala"
	_vala_return_val_if_fail ((gauss_width % 2) == 1, "gauss_width % 2 == 1", NULL);
#line 677 "../lib/Drawing/BufferSurface.vala"
	_tmp0_ = g_new0 (gdouble, gauss_width);
#line 677 "../lib/Drawing/BufferSurface.vala"
	kernel = _tmp0_;
#line 677 "../lib/Drawing/BufferSurface.vala"
	kernel_length1 = gauss_width;
#line 677 "../lib/Drawing/BufferSurface.vala"
	_kernel_size_ = kernel_length1;
#line 680 "../lib/Drawing/BufferSurface.vala"
	sd = 255.0;
#line 683 "../lib/Drawing/BufferSurface.vala"
	range = gauss_width;
#line 686 "../lib/Drawing/BufferSurface.vala"
	mean = range / sd;
#line 3975 "BufferSurface.c"
	{
		gint i = 0;
#line 688 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 3980 "BufferSurface.c"
		{
			gboolean _tmp1_ = FALSE;
#line 688 "../lib/Drawing/BufferSurface.vala"
			_tmp1_ = TRUE;
#line 688 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 3987 "BufferSurface.c"
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble* _tmp4_;
				gint _tmp4__length1;
#line 688 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp1_) {
#line 3994 "BufferSurface.c"
					gint _tmp2_;
#line 688 "../lib/Drawing/BufferSurface.vala"
					_tmp2_ = i;
#line 688 "../lib/Drawing/BufferSurface.vala"
					i = _tmp2_ + 1;
#line 4000 "BufferSurface.c"
				}
#line 688 "../lib/Drawing/BufferSurface.vala"
				_tmp1_ = FALSE;
#line 688 "../lib/Drawing/BufferSurface.vala"
				if (!(i < ((gauss_width / 2) + 1))) {
#line 688 "../lib/Drawing/BufferSurface.vala"
					break;
#line 4008 "BufferSurface.c"
				}
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp3_ = kernel;
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp3__length1 = kernel_length1;
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp4_ = kernel;
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp4__length1 = kernel_length1;
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp4_[i] = pow (sin ((((i + 1) * (G_PI / 2)) - mean) / range), (gdouble) 2) * sd;
#line 689 "../lib/Drawing/BufferSurface.vala"
				_tmp3_[(gauss_width - i) - 1] = _tmp4_[i];
#line 4022 "BufferSurface.c"
			}
		}
	}
#line 695 "../lib/Drawing/BufferSurface.vala"
	gauss_sum = 0.0;
#line 697 "../lib/Drawing/BufferSurface.vala"
	_tmp5_ = kernel;
#line 697 "../lib/Drawing/BufferSurface.vala"
	_tmp5__length1 = kernel_length1;
#line 4032 "BufferSurface.c"
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 697 "../lib/Drawing/BufferSurface.vala"
		d_collection = _tmp5_;
#line 697 "../lib/Drawing/BufferSurface.vala"
		d_collection_length1 = _tmp5__length1;
#line 697 "../lib/Drawing/BufferSurface.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 4044 "BufferSurface.c"
			gdouble d = 0.0;
#line 697 "../lib/Drawing/BufferSurface.vala"
			d = d_collection[d_it];
#line 4048 "BufferSurface.c"
			{
#line 698 "../lib/Drawing/BufferSurface.vala"
				gauss_sum += d;
#line 4052 "BufferSurface.c"
			}
		}
	}
	{
		gint i = 0;
#line 701 "../lib/Drawing/BufferSurface.vala"
		i = 0;
#line 4060 "BufferSurface.c"
		{
			gboolean _tmp6_ = FALSE;
#line 701 "../lib/Drawing/BufferSurface.vala"
			_tmp6_ = TRUE;
#line 701 "../lib/Drawing/BufferSurface.vala"
			while (TRUE) {
#line 4067 "BufferSurface.c"
				gdouble* _tmp8_;
				gint _tmp8__length1;
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gdouble* _tmp10_;
				gint _tmp10__length1;
				gdouble _tmp11_;
#line 701 "../lib/Drawing/BufferSurface.vala"
				if (!_tmp6_) {
#line 4077 "BufferSurface.c"
					gint _tmp7_;
#line 701 "../lib/Drawing/BufferSurface.vala"
					_tmp7_ = i;
#line 701 "../lib/Drawing/BufferSurface.vala"
					i = _tmp7_ + 1;
#line 4083 "BufferSurface.c"
				}
#line 701 "../lib/Drawing/BufferSurface.vala"
				_tmp6_ = FALSE;
#line 701 "../lib/Drawing/BufferSurface.vala"
				_tmp8_ = kernel;
#line 701 "../lib/Drawing/BufferSurface.vala"
				_tmp8__length1 = kernel_length1;
#line 701 "../lib/Drawing/BufferSurface.vala"
				if (!(i < _tmp8__length1)) {
#line 701 "../lib/Drawing/BufferSurface.vala"
					break;
#line 4095 "BufferSurface.c"
				}
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp9_ = kernel;
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp9__length1 = kernel_length1;
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp10_ = kernel;
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp10__length1 = kernel_length1;
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp11_ = _tmp10_[i];
#line 702 "../lib/Drawing/BufferSurface.vala"
				_tmp9_[i] = _tmp11_ / gauss_sum;
#line 4109 "BufferSurface.c"
			}
		}
	}
#line 705 "../lib/Drawing/BufferSurface.vala"
	_tmp12_ = kernel;
#line 705 "../lib/Drawing/BufferSurface.vala"
	_tmp12__length1 = kernel_length1;
#line 705 "../lib/Drawing/BufferSurface.vala"
	if (result_length1) {
#line 705 "../lib/Drawing/BufferSurface.vala"
		*result_length1 = _tmp12__length1;
#line 4121 "BufferSurface.c"
	}
#line 705 "../lib/Drawing/BufferSurface.vala"
	result = _tmp12_;
#line 705 "../lib/Drawing/BufferSurface.vala"
	return result;
#line 4127 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_class_init (GraniteDrawingBufferSurfaceClass * klass,
                                           gpointer klass_data)
{
#line 16 "../lib/Drawing/BufferSurface.vala"
	granite_drawing_buffer_surface_parent_class = g_type_class_peek_parent (klass);
#line 16 "../lib/Drawing/BufferSurface.vala"
	g_type_class_adjust_private_offset (klass, &GraniteDrawingBufferSurface_private_offset);
#line 16 "../lib/Drawing/BufferSurface.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_drawing_buffer_surface_get_property;
#line 16 "../lib/Drawing/BufferSurface.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_drawing_buffer_surface_set_property;
#line 16 "../lib/Drawing/BufferSurface.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_drawing_buffer_surface_finalize;
#line 4144 "BufferSurface.c"
	/**
	         * The {@link Cairo.Surface} which will store the results of all drawing operations
	         * made with {@link Granite.Drawing.BufferSurface.context}.
	         */
#line 16 "../lib/Drawing/BufferSurface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY] = g_param_spec_boxed ("surface", "surface", "surface", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4151 "BufferSurface.c"
	/**
	         * The width of the {@link Granite.Drawing.BufferSurface}, in pixels.
	         */
#line 16 "../lib/Drawing/BufferSurface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4157 "BufferSurface.c"
	/**
	         * The height of the BufferSurface, in pixels.
	         */
#line 16 "../lib/Drawing/BufferSurface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4163 "BufferSurface.c"
	/**
	         * The {@link Cairo.Context} for the internal surface. All drawing operations done on this
	         * {@link Granite.Drawing.BufferSurface} should use this context.
	         */
#line 16 "../lib/Drawing/BufferSurface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_DRAWING_BUFFER_SURFACE_CONTEXT_PROPERTY, granite_drawing_buffer_surface_properties[GRANITE_DRAWING_BUFFER_SURFACE_CONTEXT_PROPERTY] = g_param_spec_boxed ("context", "context", "context", cairo_gobject_context_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4170 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_instance_init (GraniteDrawingBufferSurface * self,
                                              gpointer klass)
{
#line 16 "../lib/Drawing/BufferSurface.vala"
	self->priv = granite_drawing_buffer_surface_get_instance_private (self);
#line 4179 "BufferSurface.c"
}

static void
granite_drawing_buffer_surface_finalize (GObject * obj)
{
	GraniteDrawingBufferSurface * self;
#line 16 "../lib/Drawing/BufferSurface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_DRAWING_TYPE_BUFFER_SURFACE, GraniteDrawingBufferSurface);
#line 17 "../lib/Drawing/BufferSurface.vala"
	_cairo_surface_destroy0 (self->priv->_surface);
#line 42 "../lib/Drawing/BufferSurface.vala"
	_cairo_destroy0 (self->priv->_context);
#line 16 "../lib/Drawing/BufferSurface.vala"
	G_OBJECT_CLASS (granite_drawing_buffer_surface_parent_class)->finalize (obj);
#line 4194 "BufferSurface.c"
}

/**
     * A buffer containing an internal Cairo-usable surface and context, designed
     * for usage with large, rarely updated draw operations.
     */
static GType
granite_drawing_buffer_surface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteDrawingBufferSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_drawing_buffer_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteDrawingBufferSurface), 0, (GInstanceInitFunc) granite_drawing_buffer_surface_instance_init, NULL };
	GType granite_drawing_buffer_surface_type_id;
	granite_drawing_buffer_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteDrawingBufferSurface", &g_define_type_info, 0);
	GraniteDrawingBufferSurface_private_offset = g_type_add_instance_private (granite_drawing_buffer_surface_type_id, sizeof (GraniteDrawingBufferSurfacePrivate));
	return granite_drawing_buffer_surface_type_id;
}

GType
granite_drawing_buffer_surface_get_type (void)
{
	static volatile gsize granite_drawing_buffer_surface_type_id__once = 0;
	if (g_once_init_enter (&granite_drawing_buffer_surface_type_id__once)) {
		GType granite_drawing_buffer_surface_type_id;
		granite_drawing_buffer_surface_type_id = granite_drawing_buffer_surface_get_type_once ();
		g_once_init_leave (&granite_drawing_buffer_surface_type_id__once, granite_drawing_buffer_surface_type_id);
	}
	return granite_drawing_buffer_surface_type_id__once;
}

static void
_vala_granite_drawing_buffer_surface_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GraniteDrawingBufferSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_DRAWING_TYPE_BUFFER_SURFACE, GraniteDrawingBufferSurface);
#line 16 "../lib/Drawing/BufferSurface.vala"
	switch (property_id) {
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		g_value_set_boxed (value, granite_drawing_buffer_surface_get_surface (self));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		g_value_set_int (value, granite_drawing_buffer_surface_get_width (self));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		g_value_set_int (value, granite_drawing_buffer_surface_get_height (self));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_CONTEXT_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		g_value_set_boxed (value, granite_drawing_buffer_surface_get_context (self));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 4257 "BufferSurface.c"
		default:
#line 16 "../lib/Drawing/BufferSurface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 4263 "BufferSurface.c"
	}
}

static void
_vala_granite_drawing_buffer_surface_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GraniteDrawingBufferSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_DRAWING_TYPE_BUFFER_SURFACE, GraniteDrawingBufferSurface);
#line 16 "../lib/Drawing/BufferSurface.vala"
	switch (property_id) {
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_SURFACE_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_set_surface (self, g_value_get_boxed (value));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_WIDTH_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_set_width (self, g_value_get_int (value));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 16 "../lib/Drawing/BufferSurface.vala"
		case GRANITE_DRAWING_BUFFER_SURFACE_HEIGHT_PROPERTY:
#line 16 "../lib/Drawing/BufferSurface.vala"
		granite_drawing_buffer_surface_set_height (self, g_value_get_int (value));
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 4295 "BufferSurface.c"
		default:
#line 16 "../lib/Drawing/BufferSurface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../lib/Drawing/BufferSurface.vala"
		break;
#line 4301 "BufferSurface.c"
	}
}

