/* Utilities.c generated by valac 0.56.13, the Vala compiler
 * generated from Utilities.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 * Copyright 2011-2013 Maxwell Barvian <maxwell@elementaryos.org>
 * Copyright Robert Dyer
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite.h"
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib-object.h>

enum  {
	GRANITE_DRAWING_UTILITIES_0_PROPERTY,
	GRANITE_DRAWING_UTILITIES_NUM_PROPERTIES
};
static GParamSpec* granite_drawing_utilities_properties[GRANITE_DRAWING_UTILITIES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer granite_drawing_utilities_parent_class = NULL;

static GType granite_drawing_utilities_get_type_once (void);

/**
     * Adds a closed sub-path rounded rectangle of the given size and border radius to the current path
     * at position (x, y) in user-space coordinates.
     *
     * @param cr a {@link Cairo.Context}
     * @param x the X coordinate of the top left corner of the rounded rectangle
     * @param y the Y coordinate to the top left corner of the rounded rectangle
     * @param width the width of the rounded rectangle
     * @param height the height of the rounded rectangle
     * @param radius the border radius of the rounded rectangle
     */
void
granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr,
                                                   gdouble x,
                                                   gdouble y,
                                                   gdouble width,
                                                   gdouble height,
                                                   gdouble radius)
{
#line 24 "../lib/Drawing/Utilities.vala"
	g_return_if_fail (cr != NULL);
#line 32 "../lib/Drawing/Utilities.vala"
	cairo_move_to (cr, x + radius, y);
#line 33 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, (x + width) - radius, y + radius, radius, G_PI * 1.5, G_PI * 2);
#line 34 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, (x + width) - radius, (y + height) - radius, radius, (gdouble) 0, G_PI * 0.5);
#line 35 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, x + radius, (y + height) - radius, radius, G_PI * 0.5, G_PI);
#line 36 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, x + radius, y + radius, radius, G_PI, G_PI * 1.5);
#line 37 "../lib/Drawing/Utilities.vala"
	cairo_close_path (cr);
#line 64 "Utilities.c"
}

/**
     * Averages the colors in the {@link Gdk.Pixbuf} and returns it.
     *
     * @param source the {@link Gdk.Pixbuf}
     *
     * @return the {@link Granite.Drawing.Color} containing the averaged color
     */
GraniteDrawingColor*
granite_drawing_utilities_average_color (GdkPixbuf* source)
{
	gdouble r_total = 0.0;
	gdouble g_total = 0.0;
	gdouble b_total = 0.0;
	guint8* data_ptr = NULL;
	guint8* _tmp0_;
	gdouble pixels = 0.0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GraniteDrawingColor* _tmp19_;
	GraniteDrawingColor* _tmp20_;
	GraniteDrawingColor* _tmp21_;
	GraniteDrawingColor* _tmp22_;
	GraniteDrawingColor* _tmp23_;
	GraniteDrawingColor* _tmp24_;
	GraniteDrawingColor* result;
#line 47 "../lib/Drawing/Utilities.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 48 "../lib/Drawing/Utilities.vala"
	r_total = 0.0;
#line 49 "../lib/Drawing/Utilities.vala"
	g_total = 0.0;
#line 50 "../lib/Drawing/Utilities.vala"
	b_total = 0.0;
#line 52 "../lib/Drawing/Utilities.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (source);
#line 52 "../lib/Drawing/Utilities.vala"
	data_ptr = _tmp0_;
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp1_ = gdk_pixbuf_get_height (source);
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp2_ = _tmp1_;
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp3_ = gdk_pixbuf_get_rowstride (source);
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp4_ = _tmp3_;
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (source);
#line 53 "../lib/Drawing/Utilities.vala"
	_tmp6_ = _tmp5_;
#line 53 "../lib/Drawing/Utilities.vala"
	pixels = (gdouble) ((_tmp2_ * _tmp4_) / _tmp6_);
#line 122 "Utilities.c"
	{
		gint i = 0;
#line 55 "../lib/Drawing/Utilities.vala"
		i = 0;
#line 127 "Utilities.c"
		{
			gboolean _tmp7_ = FALSE;
#line 55 "../lib/Drawing/Utilities.vala"
			_tmp7_ = TRUE;
#line 55 "../lib/Drawing/Utilities.vala"
			while (TRUE) {
#line 134 "Utilities.c"
				guint8 r = 0U;
				guint8* _tmp9_;
				guint8 _tmp10_;
				guint8 g = 0U;
				guint8* _tmp11_;
				guint8 _tmp12_;
				guint8 b = 0U;
				guint8* _tmp13_;
				guint8 _tmp14_;
				guint8 max = 0U;
				guint8 min = 0U;
				gdouble delta = 0.0;
				gdouble _tmp15_ = 0.0;
				gdouble sat = 0.0;
				gdouble score = 0.0;
				guint8* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 55 "../lib/Drawing/Utilities.vala"
				if (!_tmp7_) {
#line 155 "Utilities.c"
					gint _tmp8_;
#line 55 "../lib/Drawing/Utilities.vala"
					_tmp8_ = i;
#line 55 "../lib/Drawing/Utilities.vala"
					i = _tmp8_ + 1;
#line 161 "Utilities.c"
				}
#line 55 "../lib/Drawing/Utilities.vala"
				_tmp7_ = FALSE;
#line 55 "../lib/Drawing/Utilities.vala"
				if (!(((gdouble) i) < pixels)) {
#line 55 "../lib/Drawing/Utilities.vala"
					break;
#line 169 "Utilities.c"
				}
#line 56 "../lib/Drawing/Utilities.vala"
				_tmp9_ = data_ptr;
#line 56 "../lib/Drawing/Utilities.vala"
				_tmp10_ = _tmp9_[0];
#line 56 "../lib/Drawing/Utilities.vala"
				r = _tmp10_;
#line 57 "../lib/Drawing/Utilities.vala"
				_tmp11_ = data_ptr;
#line 57 "../lib/Drawing/Utilities.vala"
				_tmp12_ = _tmp11_[1];
#line 57 "../lib/Drawing/Utilities.vala"
				g = _tmp12_;
#line 58 "../lib/Drawing/Utilities.vala"
				_tmp13_ = data_ptr;
#line 58 "../lib/Drawing/Utilities.vala"
				_tmp14_ = _tmp13_[2];
#line 58 "../lib/Drawing/Utilities.vala"
				b = _tmp14_;
#line 60 "../lib/Drawing/Utilities.vala"
				max = (guint8) MAX ((gdouble) r, MAX ((gdouble) g, (gdouble) b));
#line 61 "../lib/Drawing/Utilities.vala"
				min = (guint8) MIN ((gdouble) r, MIN ((gdouble) g, (gdouble) b));
#line 62 "../lib/Drawing/Utilities.vala"
				delta = (gdouble) (max - min);
#line 64 "../lib/Drawing/Utilities.vala"
				if (delta == ((gdouble) 0)) {
#line 64 "../lib/Drawing/Utilities.vala"
					_tmp15_ = 0.0;
#line 199 "Utilities.c"
				} else {
#line 64 "../lib/Drawing/Utilities.vala"
					_tmp15_ = delta / max;
#line 203 "Utilities.c"
				}
#line 64 "../lib/Drawing/Utilities.vala"
				sat = _tmp15_;
#line 65 "../lib/Drawing/Utilities.vala"
				score = 0.2 + (0.8 * sat);
#line 67 "../lib/Drawing/Utilities.vala"
				r_total += r * score;
#line 68 "../lib/Drawing/Utilities.vala"
				g_total += g * score;
#line 69 "../lib/Drawing/Utilities.vala"
				b_total += b * score;
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp16_ = data_ptr;
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp17_ = gdk_pixbuf_get_n_channels (source);
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp18_ = _tmp17_;
#line 71 "../lib/Drawing/Utilities.vala"
				data_ptr = _tmp16_ + _tmp18_;
#line 223 "Utilities.c"
			}
		}
	}
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp19_ = granite_drawing_color_new ((r_total / G_MAXUINT8) / pixels, (g_total / G_MAXUINT8) / pixels, (b_total / G_MAXUINT8) / pixels, (gdouble) 1);
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp20_ = _tmp19_;
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp21_ = granite_drawing_color_set_val (_tmp20_, 0.8);
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp22_ = _tmp21_;
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp23_ = granite_drawing_color_multiply_sat (_tmp22_, 1.15);
#line 74 "../lib/Drawing/Utilities.vala"
	_tmp24_ = _tmp23_;
#line 74 "../lib/Drawing/Utilities.vala"
	_g_object_unref0 (_tmp22_);
#line 74 "../lib/Drawing/Utilities.vala"
	_g_object_unref0 (_tmp20_);
#line 74 "../lib/Drawing/Utilities.vala"
	result = _tmp24_;
#line 74 "../lib/Drawing/Utilities.vala"
	return result;
#line 247 "Utilities.c"
}

GraniteDrawingUtilities*
granite_drawing_utilities_construct (GType object_type)
{
	GraniteDrawingUtilities * self = NULL;
#line 11 "../lib/Drawing/Utilities.vala"
	self = (GraniteDrawingUtilities*) g_object_new (object_type, NULL);
#line 11 "../lib/Drawing/Utilities.vala"
	return self;
#line 258 "Utilities.c"
}

GraniteDrawingUtilities*
granite_drawing_utilities_new (void)
{
#line 11 "../lib/Drawing/Utilities.vala"
	return granite_drawing_utilities_construct (GRANITE_DRAWING_TYPE_UTILITIES);
#line 266 "Utilities.c"
}

static void
granite_drawing_utilities_class_init (GraniteDrawingUtilitiesClass * klass,
                                      gpointer klass_data)
{
#line 11 "../lib/Drawing/Utilities.vala"
	granite_drawing_utilities_parent_class = g_type_class_peek_parent (klass);
#line 275 "Utilities.c"
}

static void
granite_drawing_utilities_instance_init (GraniteDrawingUtilities * self,
                                         gpointer klass)
{
}

/**
 * A utility class for frequently-performed drawing operations.
 */
static GType
granite_drawing_utilities_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteDrawingUtilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_drawing_utilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteDrawingUtilities), 0, (GInstanceInitFunc) granite_drawing_utilities_instance_init, NULL };
	GType granite_drawing_utilities_type_id;
	granite_drawing_utilities_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteDrawingUtilities", &g_define_type_info, 0);
	return granite_drawing_utilities_type_id;
}

GType
granite_drawing_utilities_get_type (void)
{
	static volatile gsize granite_drawing_utilities_type_id__once = 0;
	if (g_once_init_enter (&granite_drawing_utilities_type_id__once)) {
		GType granite_drawing_utilities_type_id;
		granite_drawing_utilities_type_id = granite_drawing_utilities_get_type_once ();
		g_once_init_leave (&granite_drawing_utilities_type_id__once, granite_drawing_utilities_type_id);
	}
	return granite_drawing_utilities_type_id__once;
}

