/* System.c generated by valac 0.56.13, the Vala compiler
 * generated from System.vala, do not modify */

/*
 * Copyright 2011-2013 Robert Dyer
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <glib-object.h>

enum  {
	GRANITE_SERVICES_SYSTEM_0_PROPERTY,
	GRANITE_SERVICES_SYSTEM_NUM_PROPERTIES
};
static GParamSpec* granite_services_system_properties[GRANITE_SERVICES_SYSTEM_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GRANITE_PORTAL_TYPE_SETTINGS (granite_portal_settings_get_type ())
#define GRANITE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettings))
#define GRANITE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_PORTAL_TYPE_SETTINGS))
#define GRANITE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettingsIface))

typedef struct _GranitePortalSettings GranitePortalSettings;
typedef struct _GranitePortalSettingsIface GranitePortalSettingsIface;

#define GRANITE_PORTAL_TYPE_SETTINGS_PROXY (granite_portal_settings_proxy_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _GranitePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (GranitePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (GranitePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

static gpointer granite_services_system_parent_class = NULL;
static GSettingsSchema* granite_services_system_privacy_settings_schema;
static GSettingsSchema* granite_services_system_privacy_settings_schema = NULL;
static GSettings* granite_services_system_privacy_settings;
static GSettings* granite_services_system_privacy_settings = NULL;
static GranitePortalSettings* granite_services_system_portal;
static GranitePortalSettings* granite_services_system_portal = NULL;

static gboolean granite_services_system_path_is_mounted (const gchar* path);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void granite_services_system_internal_launch (GFile* app,
                                              GList* files);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN GType granite_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
 G_GNUC_INTERNAL guint granite_portal_settings_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
 G_GNUC_INTERNAL GType granite_portal_settings_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL GranitePortalSettings* granite_portal_settings_get (GError** error);
 G_GNUC_INTERNAL GHashTable* granite_portal_settings_read_all (GranitePortalSettings* self,
                                              gchar** namespaces,
                                              gint namespaces_length1,
                                              GError** error);
static void granite_services_system_finalize (GObject * obj);
static GType granite_services_system_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
         * Opens the specified URI with the default application.  This can be used for opening websites
         * with the default browser, etc.
         *
         * @param uri the URI to open
         */
void
granite_services_system_open_uri (const gchar* uri)
{
	GError* _inner_error0_ = NULL;
#line 20 "../lib/Services/System.vala"
	g_return_if_fail (uri != NULL);
#line 92 "System.c"
	{
#line 22 "../lib/Services/System.vala"
		g_app_info_launch_default_for_uri (uri, NULL, &_inner_error0_);
#line 22 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "System.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 21 "../lib/Services/System.vala"
		e = _inner_error0_;
#line 21 "../lib/Services/System.vala"
		_inner_error0_ = NULL;
#line 24 "../lib/Services/System.vala"
		_tmp0_ = e;
#line 24 "../lib/Services/System.vala"
		_tmp1_ = _tmp0_->message;
#line 24 "../lib/Services/System.vala"
		g_critical ("System.vala:24: Failed to open uri: %s", _tmp1_);
#line 21 "../lib/Services/System.vala"
		_g_error_free0 (e);
#line 120 "System.c"
	}
	__finally0:
#line 21 "../lib/Services/System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21 "../lib/Services/System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 21 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 21 "../lib/Services/System.vala"
		return;
#line 131 "System.c"
	}
}

/**
         * Opens the specified file with the default application.
         *
         * @param file the {@link GLib.File} to open
         */
void
granite_services_system_open (GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 34 "../lib/Services/System.vala"
	g_return_if_fail (file != NULL);
#line 146 "System.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 36 "../lib/Services/System.vala"
		_tmp0_ = g_file_get_uri (file);
#line 36 "../lib/Services/System.vala"
		_tmp1_ = _tmp0_;
#line 36 "../lib/Services/System.vala"
		g_app_info_launch_default_for_uri (_tmp1_, NULL, &_inner_error0_);
#line 36 "../lib/Services/System.vala"
		_g_free0 (_tmp1_);
#line 36 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "System.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 35 "../lib/Services/System.vala"
		e = _inner_error0_;
#line 35 "../lib/Services/System.vala"
		_inner_error0_ = NULL;
#line 38 "../lib/Services/System.vala"
		_tmp2_ = e;
#line 38 "../lib/Services/System.vala"
		_tmp3_ = _tmp2_->message;
#line 38 "../lib/Services/System.vala"
		g_critical ("System.vala:38: Failed to open file: %s", _tmp3_);
#line 35 "../lib/Services/System.vala"
		_g_error_free0 (e);
#line 182 "System.c"
	}
	__finally0:
#line 35 "../lib/Services/System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../lib/Services/System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 35 "../lib/Services/System.vala"
		return;
#line 193 "System.c"
	}
}

/**
         * Opens the specified files with the default application.
         *
         * @param files an array of {@link GLib.File} to open
         */
void
granite_services_system_open_files (GFile** files,
                                    gint files_length1)
{
	GError* _inner_error0_ = NULL;
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
#line 49 "../lib/Services/System.vala"
		file_collection = files;
#line 49 "../lib/Services/System.vala"
		file_collection_length1 = files_length1;
#line 49 "../lib/Services/System.vala"
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
#line 218 "System.c"
			GFile* file = NULL;
#line 49 "../lib/Services/System.vala"
			file = file_collection[file_it];
#line 222 "System.c"
			{
				{
					GFile* _tmp0_;
					gchar* _tmp1_;
					gchar* _tmp2_;
#line 51 "../lib/Services/System.vala"
					_tmp0_ = file;
#line 51 "../lib/Services/System.vala"
					_tmp1_ = g_file_get_uri (_tmp0_);
#line 51 "../lib/Services/System.vala"
					_tmp2_ = _tmp1_;
#line 51 "../lib/Services/System.vala"
					g_app_info_launch_default_for_uri (_tmp2_, NULL, &_inner_error0_);
#line 51 "../lib/Services/System.vala"
					_g_free0 (_tmp2_);
#line 51 "../lib/Services/System.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "System.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
#line 50 "../lib/Services/System.vala"
					e = _inner_error0_;
#line 50 "../lib/Services/System.vala"
					_inner_error0_ = NULL;
#line 53 "../lib/Services/System.vala"
					_tmp3_ = e;
#line 53 "../lib/Services/System.vala"
					_tmp4_ = _tmp3_->message;
#line 53 "../lib/Services/System.vala"
					g_critical ("System.vala:53: Failed to open file: %s", _tmp4_);
#line 50 "../lib/Services/System.vala"
					_g_error_free0 (e);
#line 262 "System.c"
				}
				__finally0:
#line 50 "../lib/Services/System.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 50 "../lib/Services/System.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../lib/Services/System.vala"
					g_clear_error (&_inner_error0_);
#line 50 "../lib/Services/System.vala"
					return;
#line 273 "System.c"
				}
			}
		}
	}
}

/**
         * Launches the specified application.
         *
         * @param app the {@link GLib.File} representing the application to launch
         */
void
granite_services_system_launch (GFile* app)
{
	GFile** _tmp0_;
	GFile** _tmp1_;
	gint _tmp1__length1;
#line 64 "../lib/Services/System.vala"
	g_return_if_fail (app != NULL);
#line 65 "../lib/Services/System.vala"
	_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 65 "../lib/Services/System.vala"
	_tmp1_ = _tmp0_;
#line 65 "../lib/Services/System.vala"
	_tmp1__length1 = 0;
#line 65 "../lib/Services/System.vala"
	granite_services_system_launch_with_files (app, _tmp1_, (gint) 0);
#line 65 "../lib/Services/System.vala"
	_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_object_unref), NULL);
#line 303 "System.c"
}

/**
         * Executes the specified command.
         *
         * @param command the command to execute
         */
gboolean
granite_services_system_execute_command (const gchar* command)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 74 "../lib/Services/System.vala"
	g_return_val_if_fail (command != NULL, FALSE);
#line 318 "System.c"
	{
		GAppInfo* info = NULL;
		GAppInfo* _tmp0_;
		gboolean _tmp1_ = FALSE;
		GAppInfo* _tmp2_;
#line 76 "../lib/Services/System.vala"
		_tmp0_ = g_app_info_create_from_commandline (command, "", 0, &_inner_error0_);
#line 76 "../lib/Services/System.vala"
		info = _tmp0_;
#line 76 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 330 "System.c"
			goto __catch0_g_error;
		}
#line 77 "../lib/Services/System.vala"
		_tmp2_ = info;
#line 77 "../lib/Services/System.vala"
		_tmp1_ = g_app_info_launch (_tmp2_, NULL, NULL, &_inner_error0_);
#line 77 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 341 "System.c"
			goto __catch0_g_error;
		}
#line 77 "../lib/Services/System.vala"
		if (_tmp1_) {
#line 78 "../lib/Services/System.vala"
			result = TRUE;
#line 78 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 78 "../lib/Services/System.vala"
			return result;
#line 352 "System.c"
		}
#line 75 "../lib/Services/System.vala"
		_g_object_unref0 (info);
#line 356 "System.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 75 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 80 "../lib/Services/System.vala"
		g_warning ("System.vala:80: Failed to execute external '%s' command", command);
#line 365 "System.c"
	}
	__finally0:
#line 75 "../lib/Services/System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "System.c"
		gboolean _tmp3_ = FALSE;
#line 75 "../lib/Services/System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 75 "../lib/Services/System.vala"
		return _tmp3_;
#line 378 "System.c"
	}
#line 83 "../lib/Services/System.vala"
	result = TRUE;
#line 83 "../lib/Services/System.vala"
	return result;
#line 384 "System.c"
}

/**
         * Launches the supplied files with the specified application.
         *
         * @param app the {@link GLib.File} representing the application to launch
         * @param files an array of {@link GLib.File} to open
         */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "../lib/Services/System.vala"
	return self ? g_object_ref (self) : NULL;
#line 398 "System.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 108 "../lib/Services/System.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 406 "System.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 108 "../lib/Services/System.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 414 "System.c"
}

void
granite_services_system_launch_with_files (GFile* app,
                                           GFile** files,
                                           gint files_length1)
{
	gboolean _tmp0_ = FALSE;
	GList* mounted_files = NULL;
	gboolean _tmp26_ = FALSE;
	GList* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 94 "../lib/Services/System.vala"
	if (app != NULL) {
#line 94 "../lib/Services/System.vala"
		_tmp0_ = !g_file_query_exists (app, NULL);
#line 431 "System.c"
	} else {
#line 94 "../lib/Services/System.vala"
		_tmp0_ = FALSE;
#line 435 "System.c"
	}
#line 94 "../lib/Services/System.vala"
	if (_tmp0_) {
#line 439 "System.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 95 "../lib/Services/System.vala"
		_tmp1_ = g_file_get_path (app);
#line 95 "../lib/Services/System.vala"
		_tmp2_ = _tmp1_;
#line 95 "../lib/Services/System.vala"
		g_warning ("System.vala:95: Application '%s' doesn't exist", _tmp2_);
#line 95 "../lib/Services/System.vala"
		_g_free0 (_tmp2_);
#line 96 "../lib/Services/System.vala"
		return;
#line 452 "System.c"
	}
#line 99 "../lib/Services/System.vala"
	mounted_files = NULL;
#line 456 "System.c"
	{
		GFile** f_collection = NULL;
		gint f_collection_length1 = 0;
		gint _f_collection_size_ = 0;
		gint f_it = 0;
#line 102 "../lib/Services/System.vala"
		f_collection = files;
#line 102 "../lib/Services/System.vala"
		f_collection_length1 = files_length1;
#line 102 "../lib/Services/System.vala"
		for (f_it = 0; f_it < f_collection_length1; f_it = f_it + 1) {
#line 468 "System.c"
			GFile* _tmp3_;
			GFile* f = NULL;
#line 102 "../lib/Services/System.vala"
			_tmp3_ = _g_object_ref0 (f_collection[f_it]);
#line 102 "../lib/Services/System.vala"
			f = _tmp3_;
#line 475 "System.c"
			{
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GFile* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gboolean _tmp9_;
#line 103 "../lib/Services/System.vala"
				_tmp6_ = f;
#line 103 "../lib/Services/System.vala"
				_tmp7_ = g_file_get_path (_tmp6_);
#line 103 "../lib/Services/System.vala"
				_tmp8_ = _tmp7_;
#line 103 "../lib/Services/System.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 103 "../lib/Services/System.vala"
				_g_free0 (_tmp8_);
#line 103 "../lib/Services/System.vala"
				if (_tmp9_) {
#line 495 "System.c"
					GFile* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
#line 103 "../lib/Services/System.vala"
					_tmp10_ = f;
#line 103 "../lib/Services/System.vala"
					_tmp11_ = g_file_get_path (_tmp10_);
#line 103 "../lib/Services/System.vala"
					_tmp12_ = _tmp11_;
#line 103 "../lib/Services/System.vala"
					_tmp5_ = g_strcmp0 (_tmp12_, "") != 0;
#line 103 "../lib/Services/System.vala"
					_g_free0 (_tmp12_);
#line 509 "System.c"
				} else {
#line 103 "../lib/Services/System.vala"
					_tmp5_ = FALSE;
#line 513 "System.c"
				}
#line 103 "../lib/Services/System.vala"
				if (_tmp5_) {
#line 517 "System.c"
					gboolean _tmp13_ = FALSE;
					GFile* _tmp14_;
#line 103 "../lib/Services/System.vala"
					_tmp14_ = f;
#line 103 "../lib/Services/System.vala"
					if (g_file_is_native (_tmp14_)) {
#line 103 "../lib/Services/System.vala"
						_tmp13_ = TRUE;
#line 526 "System.c"
					} else {
						GFile* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
#line 103 "../lib/Services/System.vala"
						_tmp15_ = f;
#line 103 "../lib/Services/System.vala"
						_tmp16_ = g_file_get_path (_tmp15_);
#line 103 "../lib/Services/System.vala"
						_tmp17_ = _tmp16_;
#line 103 "../lib/Services/System.vala"
						_tmp13_ = granite_services_system_path_is_mounted (_tmp17_);
#line 103 "../lib/Services/System.vala"
						_g_free0 (_tmp17_);
#line 541 "System.c"
					}
#line 103 "../lib/Services/System.vala"
					_tmp4_ = _tmp13_;
#line 545 "System.c"
				} else {
#line 103 "../lib/Services/System.vala"
					_tmp4_ = FALSE;
#line 549 "System.c"
				}
#line 103 "../lib/Services/System.vala"
				if (_tmp4_) {
#line 553 "System.c"
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 104 "../lib/Services/System.vala"
					_tmp18_ = f;
#line 104 "../lib/Services/System.vala"
					_tmp19_ = _g_object_ref0 (_tmp18_);
#line 104 "../lib/Services/System.vala"
					mounted_files = g_list_append (mounted_files, _tmp19_);
#line 105 "../lib/Services/System.vala"
					_g_object_unref0 (f);
#line 105 "../lib/Services/System.vala"
					continue;
#line 566 "System.c"
				}
				{
					GFile* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 109 "../lib/Services/System.vala"
					_tmp20_ = f;
#line 109 "../lib/Services/System.vala"
					_tmp21_ = g_file_get_uri (_tmp20_);
#line 109 "../lib/Services/System.vala"
					_tmp22_ = _tmp21_;
#line 109 "../lib/Services/System.vala"
					g_app_info_launch_default_for_uri (_tmp22_, NULL, &_inner_error0_);
#line 109 "../lib/Services/System.vala"
					_g_free0 (_tmp22_);
#line 109 "../lib/Services/System.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "System.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GFile* _tmp23_;
					GFile* _tmp24_;
					GFile* _tmp25_;
#line 108 "../lib/Services/System.vala"
					g_clear_error (&_inner_error0_);
#line 111 "../lib/Services/System.vala"
					_tmp23_ = f;
#line 111 "../lib/Services/System.vala"
					g_file_mount_enclosing_volume (_tmp23_, 0, NULL, NULL, NULL, NULL);
#line 112 "../lib/Services/System.vala"
					_tmp24_ = f;
#line 112 "../lib/Services/System.vala"
					_tmp25_ = _g_object_ref0 (_tmp24_);
#line 112 "../lib/Services/System.vala"
					mounted_files = g_list_append (mounted_files, _tmp25_);
#line 606 "System.c"
				}
				__finally0:
#line 108 "../lib/Services/System.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../lib/Services/System.vala"
					_g_object_unref0 (f);
#line 108 "../lib/Services/System.vala"
					(mounted_files == NULL) ? NULL : (mounted_files = (_g_list_free__g_object_unref0_ (mounted_files), NULL));
#line 108 "../lib/Services/System.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../lib/Services/System.vala"
					g_clear_error (&_inner_error0_);
#line 108 "../lib/Services/System.vala"
					return;
#line 621 "System.c"
				}
#line 102 "../lib/Services/System.vala"
				_g_object_unref0 (f);
#line 625 "System.c"
			}
		}
	}
#line 116 "../lib/Services/System.vala"
	_tmp27_ = mounted_files;
#line 116 "../lib/Services/System.vala"
	if (g_list_length (_tmp27_) > ((guint) 0)) {
#line 116 "../lib/Services/System.vala"
		_tmp26_ = TRUE;
#line 635 "System.c"
	} else {
#line 116 "../lib/Services/System.vala"
		_tmp26_ = files_length1 == 0;
#line 639 "System.c"
	}
#line 116 "../lib/Services/System.vala"
	if (_tmp26_) {
#line 643 "System.c"
		GList* _tmp28_;
#line 117 "../lib/Services/System.vala"
		_tmp28_ = mounted_files;
#line 117 "../lib/Services/System.vala"
		granite_services_system_internal_launch (app, _tmp28_);
#line 649 "System.c"
	}
#line 93 "../lib/Services/System.vala"
	(mounted_files == NULL) ? NULL : (mounted_files = (_g_list_free__g_object_unref0_ (mounted_files), NULL));
#line 653 "System.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 672 "System.c"
}

static gboolean
granite_services_system_path_is_mounted (const gchar* path)
{
	GVolumeMonitor* _tmp0_;
	GVolumeMonitor* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	gboolean result;
#line 120 "../lib/Services/System.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 121 "../lib/Services/System.vala"
	_tmp0_ = g_volume_monitor_get ();
#line 121 "../lib/Services/System.vala"
	_tmp1_ = _tmp0_;
#line 121 "../lib/Services/System.vala"
	_tmp2_ = g_volume_monitor_get_mounts (_tmp1_);
#line 121 "../lib/Services/System.vala"
	_tmp3_ = _tmp2_;
#line 121 "../lib/Services/System.vala"
	_g_object_unref0 (_tmp1_);
#line 695 "System.c"
	{
		GList* m_collection = NULL;
		GList* m_it = NULL;
#line 121 "../lib/Services/System.vala"
		m_collection = _tmp3_;
#line 121 "../lib/Services/System.vala"
		for (m_it = m_collection; m_it != NULL; m_it = m_it->next) {
#line 703 "System.c"
			GMount* _tmp4_;
			GMount* m = NULL;
#line 121 "../lib/Services/System.vala"
			_tmp4_ = _g_object_ref0 ((GMount*) m_it->data);
#line 121 "../lib/Services/System.vala"
			m = _tmp4_;
#line 710 "System.c"
			{
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				GMount* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				gboolean _tmp10_;
#line 122 "../lib/Services/System.vala"
				_tmp7_ = m;
#line 122 "../lib/Services/System.vala"
				_tmp8_ = g_mount_get_root (_tmp7_);
#line 122 "../lib/Services/System.vala"
				_tmp9_ = _tmp8_;
#line 122 "../lib/Services/System.vala"
				_tmp10_ = _tmp9_ != NULL;
#line 122 "../lib/Services/System.vala"
				_g_object_unref0 (_tmp9_);
#line 122 "../lib/Services/System.vala"
				if (_tmp10_) {
#line 730 "System.c"
					GMount* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 122 "../lib/Services/System.vala"
					_tmp11_ = m;
#line 122 "../lib/Services/System.vala"
					_tmp12_ = g_mount_get_root (_tmp11_);
#line 122 "../lib/Services/System.vala"
					_tmp13_ = _tmp12_;
#line 122 "../lib/Services/System.vala"
					_tmp14_ = g_file_get_path (_tmp13_);
#line 122 "../lib/Services/System.vala"
					_tmp15_ = _tmp14_;
#line 122 "../lib/Services/System.vala"
					_tmp6_ = _tmp15_ != NULL;
#line 122 "../lib/Services/System.vala"
					_g_free0 (_tmp15_);
#line 122 "../lib/Services/System.vala"
					_g_object_unref0 (_tmp13_);
#line 752 "System.c"
				} else {
#line 122 "../lib/Services/System.vala"
					_tmp6_ = FALSE;
#line 756 "System.c"
				}
#line 122 "../lib/Services/System.vala"
				if (_tmp6_) {
#line 760 "System.c"
					GMount* _tmp16_;
					GFile* _tmp17_;
					GFile* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
#line 122 "../lib/Services/System.vala"
					_tmp16_ = m;
#line 122 "../lib/Services/System.vala"
					_tmp17_ = g_mount_get_root (_tmp16_);
#line 122 "../lib/Services/System.vala"
					_tmp18_ = _tmp17_;
#line 122 "../lib/Services/System.vala"
					_tmp19_ = g_file_get_path (_tmp18_);
#line 122 "../lib/Services/System.vala"
					_tmp20_ = _tmp19_;
#line 122 "../lib/Services/System.vala"
					_tmp5_ = string_contains (path, _tmp20_);
#line 122 "../lib/Services/System.vala"
					_g_free0 (_tmp20_);
#line 122 "../lib/Services/System.vala"
					_g_object_unref0 (_tmp18_);
#line 782 "System.c"
				} else {
#line 122 "../lib/Services/System.vala"
					_tmp5_ = FALSE;
#line 786 "System.c"
				}
#line 122 "../lib/Services/System.vala"
				if (_tmp5_) {
#line 123 "../lib/Services/System.vala"
					result = TRUE;
#line 123 "../lib/Services/System.vala"
					_g_object_unref0 (m);
#line 123 "../lib/Services/System.vala"
					(m_collection == NULL) ? NULL : (m_collection = (_g_list_free__g_object_unref0_ (m_collection), NULL));
#line 123 "../lib/Services/System.vala"
					return result;
#line 798 "System.c"
				}
#line 121 "../lib/Services/System.vala"
				_g_object_unref0 (m);
#line 802 "System.c"
			}
		}
#line 121 "../lib/Services/System.vala"
		(m_collection == NULL) ? NULL : (m_collection = (_g_list_free__g_object_unref0_ (m_collection), NULL));
#line 807 "System.c"
	}
#line 125 "../lib/Services/System.vala"
	result = FALSE;
#line 125 "../lib/Services/System.vala"
	return result;
#line 813 "System.c"
}

static void
_g_free0_ (gpointer var)
{
#line 160 "../lib/Services/System.vala"
	var = (g_free (var), NULL);
#line 821 "System.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 160 "../lib/Services/System.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 829 "System.c"
}

static void
granite_services_system_internal_launch (GFile* app,
                                         GList* files)
{
	gboolean _tmp0_ = FALSE;
	GAppInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 129 "../lib/Services/System.vala"
	if (app == NULL) {
#line 129 "../lib/Services/System.vala"
		_tmp0_ = g_list_length (files) == ((guint) 0);
#line 843 "System.c"
	} else {
#line 129 "../lib/Services/System.vala"
		_tmp0_ = FALSE;
#line 847 "System.c"
	}
#line 129 "../lib/Services/System.vala"
	if (_tmp0_) {
#line 130 "../lib/Services/System.vala"
		return;
#line 853 "System.c"
	}
#line 135 "../lib/Services/System.vala"
	if (app != NULL) {
#line 857 "System.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GDesktopAppInfo* _tmp3_;
#line 136 "../lib/Services/System.vala"
		_tmp1_ = g_file_get_path (app);
#line 136 "../lib/Services/System.vala"
		_tmp2_ = _tmp1_;
#line 136 "../lib/Services/System.vala"
		_tmp3_ = g_desktop_app_info_new_from_filename (_tmp2_);
#line 136 "../lib/Services/System.vala"
		_g_object_unref0 (info);
#line 136 "../lib/Services/System.vala"
		info = (GAppInfo*) _tmp3_;
#line 136 "../lib/Services/System.vala"
		_g_free0 (_tmp2_);
#line 873 "System.c"
	} else {
		{
			GAppInfo* _tmp4_ = NULL;
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GAppInfo* _tmp7_;
			GAppInfo* _tmp8_;
#line 140 "../lib/Services/System.vala"
			_tmp5_ = g_list_first (files);
#line 140 "../lib/Services/System.vala"
			_tmp6_ = _tmp5_->data;
#line 140 "../lib/Services/System.vala"
			_tmp7_ = g_file_query_default_handler ((GFile*) _tmp6_, NULL, &_inner_error0_);
#line 140 "../lib/Services/System.vala"
			_tmp4_ = _tmp7_;
#line 140 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 891 "System.c"
				goto __catch0_g_error;
			}
#line 140 "../lib/Services/System.vala"
			_tmp8_ = _tmp4_;
#line 140 "../lib/Services/System.vala"
			_tmp4_ = NULL;
#line 140 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 140 "../lib/Services/System.vala"
			info = _tmp8_;
#line 139 "../lib/Services/System.vala"
			_g_object_unref0 (_tmp4_);
#line 904 "System.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 139 "../lib/Services/System.vala"
			g_clear_error (&_inner_error0_);
#line 142 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 142 "../lib/Services/System.vala"
			return;
#line 915 "System.c"
		}
		__finally0:
#line 139 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 139 "../lib/Services/System.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../lib/Services/System.vala"
			g_clear_error (&_inner_error0_);
#line 139 "../lib/Services/System.vala"
			return;
#line 928 "System.c"
		}
	}
	{
		GAppInfo* _tmp10_;
		GAppInfo* _tmp12_;
#line 146 "../lib/Services/System.vala"
		if (g_list_length (files) == ((guint) 0)) {
#line 936 "System.c"
			GAppInfo* _tmp9_;
#line 147 "../lib/Services/System.vala"
			_tmp9_ = info;
#line 147 "../lib/Services/System.vala"
			g_app_info_launch (_tmp9_, NULL, NULL, &_inner_error0_);
#line 147 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 944 "System.c"
				goto __catch1_g_error;
			}
#line 148 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 148 "../lib/Services/System.vala"
			return;
#line 951 "System.c"
		}
#line 151 "../lib/Services/System.vala"
		_tmp10_ = info;
#line 151 "../lib/Services/System.vala"
		if (g_app_info_supports_files (_tmp10_)) {
#line 957 "System.c"
			GAppInfo* _tmp11_;
#line 152 "../lib/Services/System.vala"
			_tmp11_ = info;
#line 152 "../lib/Services/System.vala"
			g_app_info_launch (_tmp11_, files, NULL, &_inner_error0_);
#line 152 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 965 "System.c"
				goto __catch1_g_error;
			}
#line 153 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 153 "../lib/Services/System.vala"
			return;
#line 972 "System.c"
		}
#line 156 "../lib/Services/System.vala"
		_tmp12_ = info;
#line 156 "../lib/Services/System.vala"
		if (g_app_info_supports_uris (_tmp12_)) {
#line 978 "System.c"
			GList* uris = NULL;
			GAppInfo* _tmp16_;
			GList* _tmp17_;
			GAppLaunchContext* _tmp18_;
			GAppLaunchContext* _tmp19_;
#line 157 "../lib/Services/System.vala"
			uris = NULL;
#line 986 "System.c"
			{
				GList* f_collection = NULL;
				GList* f_it = NULL;
#line 158 "../lib/Services/System.vala"
				f_collection = files;
#line 158 "../lib/Services/System.vala"
				for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 994 "System.c"
					GFile* _tmp13_;
					GFile* f = NULL;
#line 158 "../lib/Services/System.vala"
					_tmp13_ = _g_object_ref0 ((GFile*) f_it->data);
#line 158 "../lib/Services/System.vala"
					f = _tmp13_;
#line 1001 "System.c"
					{
						GFile* _tmp14_;
						gchar* _tmp15_;
#line 159 "../lib/Services/System.vala"
						_tmp14_ = f;
#line 159 "../lib/Services/System.vala"
						_tmp15_ = g_file_get_uri (_tmp14_);
#line 159 "../lib/Services/System.vala"
						uris = g_list_append (uris, _tmp15_);
#line 158 "../lib/Services/System.vala"
						_g_object_unref0 (f);
#line 1013 "System.c"
					}
				}
			}
#line 160 "../lib/Services/System.vala"
			_tmp16_ = info;
#line 160 "../lib/Services/System.vala"
			_tmp17_ = uris;
#line 160 "../lib/Services/System.vala"
			_tmp18_ = g_app_launch_context_new ();
#line 160 "../lib/Services/System.vala"
			_tmp19_ = _tmp18_;
#line 160 "../lib/Services/System.vala"
			g_app_info_launch_uris (_tmp16_, _tmp17_, _tmp19_, &_inner_error0_);
#line 160 "../lib/Services/System.vala"
			_g_object_unref0 (_tmp19_);
#line 160 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../lib/Services/System.vala"
				(uris == NULL) ? NULL : (uris = (_g_list_free__g_free0_ (uris), NULL));
#line 1033 "System.c"
				goto __catch1_g_error;
			}
#line 161 "../lib/Services/System.vala"
			(uris == NULL) ? NULL : (uris = (_g_list_free__g_free0_ (uris), NULL));
#line 161 "../lib/Services/System.vala"
			_g_object_unref0 (info);
#line 161 "../lib/Services/System.vala"
			return;
#line 1042 "System.c"
		}
#line 164 "../lib/Services/System.vala"
		g_error ("System.vala:164: Error opening files. The application doesn't support " \
"files/URIs or wasn't found.");
#line 1046 "System.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		const gchar* _tmp23_;
#line 145 "../lib/Services/System.vala"
		e = _inner_error0_;
#line 145 "../lib/Services/System.vala"
		_inner_error0_ = NULL;
#line 166 "../lib/Services/System.vala"
		_tmp20_ = g_quark_to_string (e->domain);
#line 166 "../lib/Services/System.vala"
		_tmp21_ = g_strconcat ("Error: ", _tmp20_, NULL);
#line 166 "../lib/Services/System.vala"
		_tmp22_ = _tmp21_;
#line 166 "../lib/Services/System.vala"
		g_debug ("System.vala:166: %s", _tmp22_);
#line 166 "../lib/Services/System.vala"
		_g_free0 (_tmp22_);
#line 167 "../lib/Services/System.vala"
		_tmp23_ = e->message;
#line 167 "../lib/Services/System.vala"
		g_error ("System.vala:167: %s", _tmp23_);
#line 145 "../lib/Services/System.vala"
		_g_error_free0 (e);
#line 1076 "System.c"
	}
	__finally1:
#line 145 "../lib/Services/System.vala"
	_g_object_unref0 (info);
#line 145 "../lib/Services/System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../lib/Services/System.vala"
	g_clear_error (&_inner_error0_);
#line 145 "../lib/Services/System.vala"
	return;
#line 1087 "System.c"
}

/**
         * Returns whether history is enabled within the Security and Privacy system settings or not. A value of true
         * means that you should store information such as the last opened file or a history within the app.
         *
         * Checks the "remember_recent_files" key in "org.gnome.desktop.privacy", returning true if the schema does not exist.
         */
gboolean
granite_services_system_history_is_enabled (void)
{
	GSettingsSchema* _tmp22_;
	gboolean _tmp25_ = FALSE;
	GSettingsSchema* _tmp26_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		GranitePortalSettings* _tmp0_;
		GHashTable* schemes = NULL;
		GranitePortalSettings* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		GHashTable* _tmp8_;
		GHashTable* _tmp9_;
		gboolean _tmp10_ = FALSE;
		GHashTable* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
#line 183 "../lib/Services/System.vala"
		_tmp0_ = granite_services_system_portal;
#line 183 "../lib/Services/System.vala"
		if (_tmp0_ == NULL) {
#line 1122 "System.c"
			GranitePortalSettings* _tmp1_ = NULL;
			GranitePortalSettings* _tmp2_;
			GranitePortalSettings* _tmp3_;
#line 184 "../lib/Services/System.vala"
			_tmp2_ = granite_portal_settings_get (&_inner_error0_);
#line 184 "../lib/Services/System.vala"
			_tmp1_ = _tmp2_;
#line 184 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1132 "System.c"
				goto __catch0_g_error;
			}
#line 184 "../lib/Services/System.vala"
			_tmp3_ = _tmp1_;
#line 184 "../lib/Services/System.vala"
			_tmp1_ = NULL;
#line 184 "../lib/Services/System.vala"
			_g_object_unref0 (granite_services_system_portal);
#line 184 "../lib/Services/System.vala"
			granite_services_system_portal = _tmp3_;
#line 183 "../lib/Services/System.vala"
			_g_object_unref0 (_tmp1_);
#line 1145 "System.c"
		}
#line 187 "../lib/Services/System.vala"
		_tmp4_ = granite_services_system_portal;
#line 187 "../lib/Services/System.vala"
		_tmp5_ = g_strdup ("org.gnome.desktop.privacy");
#line 187 "../lib/Services/System.vala"
		_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 187 "../lib/Services/System.vala"
		_tmp6_[0] = _tmp5_;
#line 187 "../lib/Services/System.vala"
		_tmp7_ = _tmp6_;
#line 187 "../lib/Services/System.vala"
		_tmp7__length1 = 1;
#line 187 "../lib/Services/System.vala"
		_tmp8_ = granite_portal_settings_read_all (_tmp4_, _tmp7_, (gint) 1, &_inner_error0_);
#line 187 "../lib/Services/System.vala"
		_tmp9_ = _tmp8_;
#line 187 "../lib/Services/System.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 187 "../lib/Services/System.vala"
		schemes = _tmp9_;
#line 187 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1169 "System.c"
			goto __catch0_g_error;
		}
#line 188 "../lib/Services/System.vala"
		_tmp11_ = schemes;
#line 188 "../lib/Services/System.vala"
		_tmp12_ = g_hash_table_size (_tmp11_);
#line 188 "../lib/Services/System.vala"
		_tmp13_ = _tmp12_;
#line 188 "../lib/Services/System.vala"
		if (_tmp13_ > ((guint) 0)) {
#line 1180 "System.c"
			GHashTable* _tmp14_;
			gconstpointer _tmp15_;
#line 188 "../lib/Services/System.vala"
			_tmp14_ = schemes;
#line 188 "../lib/Services/System.vala"
			_tmp15_ = g_hash_table_lookup (_tmp14_, "org.gnome.desktop.privacy");
#line 188 "../lib/Services/System.vala"
			_tmp10_ = g_hash_table_contains ((GHashTable*) _tmp15_, "remember-recent-files");
#line 1189 "System.c"
		} else {
#line 188 "../lib/Services/System.vala"
			_tmp10_ = FALSE;
#line 1193 "System.c"
		}
#line 188 "../lib/Services/System.vala"
		if (_tmp10_) {
#line 1197 "System.c"
			GHashTable* _tmp16_;
			gconstpointer _tmp17_;
			gconstpointer _tmp18_;
#line 189 "../lib/Services/System.vala"
			_tmp16_ = schemes;
#line 189 "../lib/Services/System.vala"
			_tmp17_ = g_hash_table_lookup (_tmp16_, "org.gnome.desktop.privacy");
#line 189 "../lib/Services/System.vala"
			_tmp18_ = g_hash_table_lookup ((GHashTable*) _tmp17_, "remember-recent-files");
#line 189 "../lib/Services/System.vala"
			result = g_variant_get_boolean ((GVariant*) _tmp18_);
#line 189 "../lib/Services/System.vala"
			_g_hash_table_unref0 (schemes);
#line 189 "../lib/Services/System.vala"
			return result;
#line 1213 "System.c"
		}
#line 182 "../lib/Services/System.vala"
		_g_hash_table_unref0 (schemes);
#line 1217 "System.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 182 "../lib/Services/System.vala"
		e = _inner_error0_;
#line 182 "../lib/Services/System.vala"
		_inner_error0_ = NULL;
#line 192 "../lib/Services/System.vala"
		_tmp19_ = e;
#line 192 "../lib/Services/System.vala"
		_tmp20_ = _tmp19_->message;
#line 192 "../lib/Services/System.vala"
		g_debug ("System.vala:192: cannot use portal, using GSettings: %s", _tmp20_);
#line 182 "../lib/Services/System.vala"
		_g_error_free0 (e);
#line 1237 "System.c"
	}
	__finally0:
#line 182 "../lib/Services/System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1242 "System.c"
		gboolean _tmp21_ = FALSE;
#line 182 "../lib/Services/System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 182 "../lib/Services/System.vala"
		return _tmp21_;
#line 1250 "System.c"
	}
#line 195 "../lib/Services/System.vala"
	_tmp22_ = granite_services_system_privacy_settings_schema;
#line 195 "../lib/Services/System.vala"
	if (_tmp22_ == NULL) {
#line 1256 "System.c"
		GSettingsSchemaSource* _tmp23_;
		GSettingsSchema* _tmp24_;
#line 196 "../lib/Services/System.vala"
		_tmp23_ = g_settings_schema_source_get_default ();
#line 196 "../lib/Services/System.vala"
		_tmp24_ = g_settings_schema_source_lookup (_tmp23_, "org.gnome.desktop.privacy", TRUE);
#line 196 "../lib/Services/System.vala"
		_g_settings_schema_unref0 (granite_services_system_privacy_settings_schema);
#line 196 "../lib/Services/System.vala"
		granite_services_system_privacy_settings_schema = _tmp24_;
#line 1267 "System.c"
	}
#line 199 "../lib/Services/System.vala"
	_tmp26_ = granite_services_system_privacy_settings_schema;
#line 199 "../lib/Services/System.vala"
	if (_tmp26_ != NULL) {
#line 1273 "System.c"
		GSettingsSchema* _tmp27_;
#line 199 "../lib/Services/System.vala"
		_tmp27_ = granite_services_system_privacy_settings_schema;
#line 199 "../lib/Services/System.vala"
		_tmp25_ = g_settings_schema_has_key (_tmp27_, "remember-recent-files");
#line 1279 "System.c"
	} else {
#line 199 "../lib/Services/System.vala"
		_tmp25_ = FALSE;
#line 1283 "System.c"
	}
#line 199 "../lib/Services/System.vala"
	if (_tmp25_) {
#line 1287 "System.c"
		GSettings* _tmp28_;
		GSettings* _tmp30_;
#line 200 "../lib/Services/System.vala"
		_tmp28_ = granite_services_system_privacy_settings;
#line 200 "../lib/Services/System.vala"
		if (_tmp28_ == NULL) {
#line 1294 "System.c"
			GSettings* _tmp29_;
#line 201 "../lib/Services/System.vala"
			_tmp29_ = g_settings_new ("org.gnome.desktop.privacy");
#line 201 "../lib/Services/System.vala"
			_g_object_unref0 (granite_services_system_privacy_settings);
#line 201 "../lib/Services/System.vala"
			granite_services_system_privacy_settings = _tmp29_;
#line 1302 "System.c"
		}
#line 204 "../lib/Services/System.vala"
		_tmp30_ = granite_services_system_privacy_settings;
#line 204 "../lib/Services/System.vala"
		result = g_settings_get_boolean (_tmp30_, "remember-recent-files");
#line 204 "../lib/Services/System.vala"
		return result;
#line 1310 "System.c"
	}
#line 207 "../lib/Services/System.vala"
	result = TRUE;
#line 207 "../lib/Services/System.vala"
	return result;
#line 1316 "System.c"
}

GraniteServicesSystem*
granite_services_system_construct (GType object_type)
{
	GraniteServicesSystem * self = NULL;
#line 11 "../lib/Services/System.vala"
	self = (GraniteServicesSystem*) g_object_new (object_type, NULL);
#line 11 "../lib/Services/System.vala"
	return self;
#line 1327 "System.c"
}

GraniteServicesSystem*
granite_services_system_new (void)
{
#line 11 "../lib/Services/System.vala"
	return granite_services_system_construct (GRANITE_SERVICES_TYPE_SYSTEM);
#line 1335 "System.c"
}

static void
granite_services_system_class_init (GraniteServicesSystemClass * klass,
                                    gpointer klass_data)
{
#line 11 "../lib/Services/System.vala"
	granite_services_system_parent_class = g_type_class_peek_parent (klass);
#line 11 "../lib/Services/System.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_services_system_finalize;
#line 1346 "System.c"
}

static void
granite_services_system_instance_init (GraniteServicesSystem * self,
                                       gpointer klass)
{
}

static void
granite_services_system_finalize (GObject * obj)
{
	GraniteServicesSystem * self;
#line 11 "../lib/Services/System.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SYSTEM, GraniteServicesSystem);
#line 11 "../lib/Services/System.vala"
	G_OBJECT_CLASS (granite_services_system_parent_class)->finalize (obj);
#line 1363 "System.c"
}

/**
     * Utility class for frequently-used system-related functions, such as opening files, launching
     * applications, or executing terminal commands.
     */
static GType
granite_services_system_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSystemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_system_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesSystem), 0, (GInstanceInitFunc) granite_services_system_instance_init, NULL };
	GType granite_services_system_type_id;
	granite_services_system_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesSystem", &g_define_type_info, 0);
	return granite_services_system_type_id;
}

GType
granite_services_system_get_type (void)
{
	static volatile gsize granite_services_system_type_id__once = 0;
	if (g_once_init_enter (&granite_services_system_type_id__once)) {
		GType granite_services_system_type_id;
		granite_services_system_type_id = granite_services_system_get_type_once ();
		g_once_init_leave (&granite_services_system_type_id__once, granite_services_system_type_id);
	}
	return granite_services_system_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

