/* Utils.c generated by valac 0.56.13, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright 2012–2021 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>

#define GRANITE_WIDGETS_UTILS_WM_SETTINGS_PATH "org.gnome.desktop.wm.preferences"
#define GRANITE_WIDGETS_UTILS_PANTHEON_SETTINGS_PATH "org.pantheon.desktop.gala.appearance"
#define GRANITE_WIDGETS_UTILS_WM_BUTTON_LAYOUT_KEY "button-layout"

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

 G_GNUC_INTERNAL void granite_init (void);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add25 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add26 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
 G_GNUC_INTERNAL gdouble granite_contrast_ratio (GdkRGBA* bg_color,
                                GdkRGBA* fg_color);
 G_GNUC_INTERNAL gdouble granite_get_luminance (GdkRGBA* color);
 G_GNUC_INTERNAL gdouble granite_sanitize_color (gdouble color);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * Converts this to a CSS style string that could be used with e.g: {@link Granite.Widgets.Utils.set_theming}.
     *
     * @param style_class the style class used for this
     *
     * @return CSS of text style
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 162 "Utils.c"
}

gchar*
granite_text_style_get_stylesheet (GraniteTextStyle self,
                                   gchar** style_class)
{
	gchar* _vala_style_class = NULL;
	gchar* result;
#line 36 "../lib/Widgets/Utils.vala"
	switch (self) {
#line 36 "../lib/Widgets/Utils.vala"
		case GRANITE_TEXT_STYLE_TITLE:
#line 175 "Utils.c"
		{
			gchar* _tmp0_;
			const gchar* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 38 "../lib/Widgets/Utils.vala"
			_tmp0_ = g_strdup (GRANITE_STYLE_CLASS_TITLE_TEXT);
#line 38 "../lib/Widgets/Utils.vala"
			_g_free0 (_vala_style_class);
#line 38 "../lib/Widgets/Utils.vala"
			_vala_style_class = _tmp0_;
#line 39 "../lib/Widgets/Utils.vala"
			_tmp1_ = _vala_style_class;
#line 39 "../lib/Widgets/Utils.vala"
			_tmp2_ = string_to_string (_tmp1_);
#line 39 "../lib/Widgets/Utils.vala"
			_tmp3_ = g_strconcat (".", _tmp2_, " { font: raleway 36; }", NULL);
#line 39 "../lib/Widgets/Utils.vala"
			result = _tmp3_;
#line 39 "../lib/Widgets/Utils.vala"
			if (style_class) {
#line 39 "../lib/Widgets/Utils.vala"
				*style_class = _vala_style_class;
#line 199 "Utils.c"
			} else {
#line 39 "../lib/Widgets/Utils.vala"
				_g_free0 (_vala_style_class);
#line 203 "Utils.c"
			}
#line 39 "../lib/Widgets/Utils.vala"
			return result;
#line 207 "Utils.c"
		}
#line 36 "../lib/Widgets/Utils.vala"
		case GRANITE_TEXT_STYLE_H1:
#line 211 "Utils.c"
		{
			gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 41 "../lib/Widgets/Utils.vala"
			_tmp4_ = g_strdup (GRANITE_STYLE_CLASS_H1_TEXT);
#line 41 "../lib/Widgets/Utils.vala"
			_g_free0 (_vala_style_class);
#line 41 "../lib/Widgets/Utils.vala"
			_vala_style_class = _tmp4_;
#line 42 "../lib/Widgets/Utils.vala"
			_tmp5_ = _vala_style_class;
#line 42 "../lib/Widgets/Utils.vala"
			_tmp6_ = string_to_string (_tmp5_);
#line 42 "../lib/Widgets/Utils.vala"
			_tmp7_ = g_strconcat (".", _tmp6_, " { font: open sans bold 24; }", NULL);
#line 42 "../lib/Widgets/Utils.vala"
			result = _tmp7_;
#line 42 "../lib/Widgets/Utils.vala"
			if (style_class) {
#line 42 "../lib/Widgets/Utils.vala"
				*style_class = _vala_style_class;
#line 235 "Utils.c"
			} else {
#line 42 "../lib/Widgets/Utils.vala"
				_g_free0 (_vala_style_class);
#line 239 "Utils.c"
			}
#line 42 "../lib/Widgets/Utils.vala"
			return result;
#line 243 "Utils.c"
		}
#line 36 "../lib/Widgets/Utils.vala"
		case GRANITE_TEXT_STYLE_H2:
#line 247 "Utils.c"
		{
			gchar* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 44 "../lib/Widgets/Utils.vala"
			_tmp8_ = g_strdup (GRANITE_STYLE_CLASS_H2_TEXT);
#line 44 "../lib/Widgets/Utils.vala"
			_g_free0 (_vala_style_class);
#line 44 "../lib/Widgets/Utils.vala"
			_vala_style_class = _tmp8_;
#line 45 "../lib/Widgets/Utils.vala"
			_tmp9_ = _vala_style_class;
#line 45 "../lib/Widgets/Utils.vala"
			_tmp10_ = string_to_string (_tmp9_);
#line 45 "../lib/Widgets/Utils.vala"
			_tmp11_ = g_strconcat (".", _tmp10_, " { font: open sans light 18; }", NULL);
#line 45 "../lib/Widgets/Utils.vala"
			result = _tmp11_;
#line 45 "../lib/Widgets/Utils.vala"
			if (style_class) {
#line 45 "../lib/Widgets/Utils.vala"
				*style_class = _vala_style_class;
#line 271 "Utils.c"
			} else {
#line 45 "../lib/Widgets/Utils.vala"
				_g_free0 (_vala_style_class);
#line 275 "Utils.c"
			}
#line 45 "../lib/Widgets/Utils.vala"
			return result;
#line 279 "Utils.c"
		}
#line 36 "../lib/Widgets/Utils.vala"
		case GRANITE_TEXT_STYLE_H3:
#line 283 "Utils.c"
		{
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 47 "../lib/Widgets/Utils.vala"
			_tmp12_ = g_strdup (GRANITE_STYLE_CLASS_H3_TEXT);
#line 47 "../lib/Widgets/Utils.vala"
			_g_free0 (_vala_style_class);
#line 47 "../lib/Widgets/Utils.vala"
			_vala_style_class = _tmp12_;
#line 48 "../lib/Widgets/Utils.vala"
			_tmp13_ = _vala_style_class;
#line 48 "../lib/Widgets/Utils.vala"
			_tmp14_ = string_to_string (_tmp13_);
#line 48 "../lib/Widgets/Utils.vala"
			_tmp15_ = g_strconcat (".", _tmp14_, " { font: open sans bold 12; }", NULL);
#line 48 "../lib/Widgets/Utils.vala"
			result = _tmp15_;
#line 48 "../lib/Widgets/Utils.vala"
			if (style_class) {
#line 48 "../lib/Widgets/Utils.vala"
				*style_class = _vala_style_class;
#line 307 "Utils.c"
			} else {
#line 48 "../lib/Widgets/Utils.vala"
				_g_free0 (_vala_style_class);
#line 311 "Utils.c"
			}
#line 48 "../lib/Widgets/Utils.vala"
			return result;
#line 315 "Utils.c"
		}
		default:
		{
#line 50 "../lib/Widgets/Utils.vala"
			g_assert_not_reached ();
#line 321 "Utils.c"
		}
	}
}

static GType
granite_text_style_get_type_once (void)
{
	static const GEnumValue values[] = {{GRANITE_TEXT_STYLE_TITLE, "GRANITE_TEXT_STYLE_TITLE", "title"}, {GRANITE_TEXT_STYLE_H1, "GRANITE_TEXT_STYLE_H1", "h1"}, {GRANITE_TEXT_STYLE_H2, "GRANITE_TEXT_STYLE_H2", "h2"}, {GRANITE_TEXT_STYLE_H3, "GRANITE_TEXT_STYLE_H3", "h3"}, {0, NULL, NULL}};
	GType granite_text_style_type_id;
	granite_text_style_type_id = g_enum_register_static ("GraniteTextStyle", values);
	return granite_text_style_type_id;
}

GType
granite_text_style_get_type (void)
{
	static volatile gsize granite_text_style_type_id__once = 0;
	if (g_once_init_enter (&granite_text_style_type_id__once)) {
		GType granite_text_style_type_id;
		granite_text_style_type_id = granite_text_style_get_type_once ();
		g_once_init_leave (&granite_text_style_type_id__once, granite_text_style_type_id);
	}
	return granite_text_style_type_id__once;
}

/**
 * An enum used to derermine where the window manager currently displays its close button on windows.
 * Used with {@link Granite.Widgets.Utils.get_default_close_button_position}.
 */
static GType
granite_close_button_position_get_type_once (void)
{
	static const GEnumValue values[] = {{GRANITE_CLOSE_BUTTON_POSITION_LEFT, "GRANITE_CLOSE_BUTTON_POSITION_LEFT", "left"}, {GRANITE_CLOSE_BUTTON_POSITION_RIGHT, "GRANITE_CLOSE_BUTTON_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType granite_close_button_position_type_id;
	granite_close_button_position_type_id = g_enum_register_static ("GraniteCloseButtonPosition", values);
	return granite_close_button_position_type_id;
}

GType
granite_close_button_position_get_type (void)
{
	static volatile gsize granite_close_button_position_type_id__once = 0;
	if (g_once_init_enter (&granite_close_button_position_type_id__once)) {
		GType granite_close_button_position_type_id;
		granite_close_button_position_type_id = granite_close_button_position_get_type_once ();
		g_once_init_leave (&granite_close_button_position_type_id__once, granite_close_button_position_type_id);
	}
	return granite_close_button_position_type_id__once;
}

/**
 * Converts a {@link Gtk.accelerator_parse} style accel string to a human-readable string.
 *
 * @param accel an accelerator label like “<Control>a” or “<Super>Right”
 *
 * @return a human-readable string like "Ctrl + A" or "⌘ + →"
 */
static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 87 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 87 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 87 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 391 "Utils.c"
	}
#line 87 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 87 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 397 "Utils.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 91 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 91 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 91 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 412 "Utils.c"
	}
#line 91 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 91 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 418 "Utils.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 95 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 95 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 95 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 433 "Utils.c"
	}
#line 95 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 95 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 439 "Utils.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 99 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 99 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 99 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 454 "Utils.c"
	}
#line 99 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 99 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 460 "Utils.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 104 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 104 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 104 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 475 "Utils.c"
	}
#line 104 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 104 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 481 "Utils.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 107 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 107 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 107 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 496 "Utils.c"
	}
#line 107 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 107 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 502 "Utils.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 110 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 110 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 110 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 517 "Utils.c"
	}
#line 110 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 110 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 523 "Utils.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 113 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 113 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 113 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 538 "Utils.c"
	}
#line 113 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 113 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 544 "Utils.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 117 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 117 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 117 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 559 "Utils.c"
	}
#line 117 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 117 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 565 "Utils.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 121 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 121 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 121 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 580 "Utils.c"
	}
#line 121 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 121 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 586 "Utils.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 124 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 124 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 124 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 601 "Utils.c"
	}
#line 124 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 124 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 607 "Utils.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 128 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 128 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 128 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 622 "Utils.c"
	}
#line 128 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 128 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 628 "Utils.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 132 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 132 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 132 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 643 "Utils.c"
	}
#line 132 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 132 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 649 "Utils.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 137 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 137 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 137 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 664 "Utils.c"
	}
#line 137 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 137 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 670 "Utils.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 142 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 142 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 142 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 685 "Utils.c"
	}
#line 142 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 142 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 691 "Utils.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 147 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 147 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 147 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 706 "Utils.c"
	}
#line 147 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 147 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 712 "Utils.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 150 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 150 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 150 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 727 "Utils.c"
	}
#line 150 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 150 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 733 "Utils.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 154 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 154 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 154 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 748 "Utils.c"
	}
#line 154 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 154 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 754 "Utils.c"
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 158 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 158 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 158 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 769 "Utils.c"
	}
#line 158 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 158 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 775 "Utils.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 165 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 165 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 165 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 790 "Utils.c"
	}
#line 165 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 165 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 796 "Utils.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 810 "Utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 814 "Utils.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 820 "Utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 825 "Utils.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 831 "Utils.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 835 "Utils.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 839 "Utils.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 843 "Utils.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 847 "Utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 851 "Utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 866 "Utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 875 "Utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 882 "Utils.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 888 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 896 "Utils.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 900 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 906 "Utils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 911 "Utils.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 917 "Utils.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 921 "Utils.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 925 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 931 "Utils.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 937 "Utils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 949 "Utils.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 953 "Utils.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 957 "Utils.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 962 "Utils.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 970 "Utils.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 988 "Utils.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 994 "Utils.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 998 "Utils.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1006 "Utils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1015 "Utils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1024 "Utils.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1030 "Utils.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1038 "Utils.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1050 "Utils.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1056 "Utils.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1060 "Utils.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1068 "Utils.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1079 "Utils.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1088 "Utils.c"
	}
}

gchar*
granite_accel_to_string (const gchar* accel)
{
	guint accel_key = 0U;
	GdkModifierType accel_mods = 0U;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0U;
	gchar** arr = NULL;
	gchar** _tmp3_;
	gint arr_length1;
	gint _arr_size_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* result;
#line 74 "../lib/Widgets/Utils.vala"
	if (accel == NULL) {
#line 1110 "Utils.c"
		gchar* _tmp0_;
#line 75 "../lib/Widgets/Utils.vala"
		_tmp0_ = g_strdup ("");
#line 75 "../lib/Widgets/Utils.vala"
		result = _tmp0_;
#line 75 "../lib/Widgets/Utils.vala"
		return result;
#line 1118 "Utils.c"
	}
#line 79 "../lib/Widgets/Utils.vala"
	granite_init ();
#line 83 "../lib/Widgets/Utils.vala"
	gtk_accelerator_parse (accel, &_tmp1_, &_tmp2_);
#line 83 "../lib/Widgets/Utils.vala"
	accel_key = _tmp1_;
#line 83 "../lib/Widgets/Utils.vala"
	accel_mods = _tmp2_;
#line 85 "../lib/Widgets/Utils.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 85 "../lib/Widgets/Utils.vala"
	arr = _tmp3_;
#line 85 "../lib/Widgets/Utils.vala"
	arr_length1 = 0;
#line 85 "../lib/Widgets/Utils.vala"
	_arr_size_ = arr_length1;
#line 86 "../lib/Widgets/Utils.vala"
	if ((accel_mods & GDK_SUPER_MASK) == GDK_SUPER_MASK) {
#line 1138 "Utils.c"
		gchar* _tmp4_;
#line 87 "../lib/Widgets/Utils.vala"
		_tmp4_ = g_strdup ("⌘");
#line 87 "../lib/Widgets/Utils.vala"
		_vala_array_add4 (&arr, &arr_length1, &_arr_size_, _tmp4_);
#line 1144 "Utils.c"
	}
#line 90 "../lib/Widgets/Utils.vala"
	if ((accel_mods & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 1148 "Utils.c"
		gchar* _tmp5_;
#line 91 "../lib/Widgets/Utils.vala"
		_tmp5_ = g_strdup (_ ("Shift"));
#line 91 "../lib/Widgets/Utils.vala"
		_vala_array_add5 (&arr, &arr_length1, &_arr_size_, _tmp5_);
#line 1154 "Utils.c"
	}
#line 94 "../lib/Widgets/Utils.vala"
	if ((accel_mods & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 1158 "Utils.c"
		gchar* _tmp6_;
#line 95 "../lib/Widgets/Utils.vala"
		_tmp6_ = g_strdup (_ ("Ctrl"));
#line 95 "../lib/Widgets/Utils.vala"
		_vala_array_add6 (&arr, &arr_length1, &_arr_size_, _tmp6_);
#line 1164 "Utils.c"
	}
#line 98 "../lib/Widgets/Utils.vala"
	if ((accel_mods & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 1168 "Utils.c"
		gchar* _tmp7_;
#line 99 "../lib/Widgets/Utils.vala"
		_tmp7_ = g_strdup (_ ("Alt"));
#line 99 "../lib/Widgets/Utils.vala"
		_vala_array_add7 (&arr, &arr_length1, &_arr_size_, _tmp7_);
#line 1174 "Utils.c"
	}
#line 102 "../lib/Widgets/Utils.vala"
	switch (accel_key) {
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Up:
#line 1180 "Utils.c"
		{
			gchar* _tmp8_;
#line 104 "../lib/Widgets/Utils.vala"
			_tmp8_ = g_strdup ("↑");
#line 104 "../lib/Widgets/Utils.vala"
			_vala_array_add8 (&arr, &arr_length1, &_arr_size_, _tmp8_);
#line 105 "../lib/Widgets/Utils.vala"
			break;
#line 1189 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Down:
#line 1193 "Utils.c"
		{
			gchar* _tmp9_;
#line 107 "../lib/Widgets/Utils.vala"
			_tmp9_ = g_strdup ("↓");
#line 107 "../lib/Widgets/Utils.vala"
			_vala_array_add9 (&arr, &arr_length1, &_arr_size_, _tmp9_);
#line 108 "../lib/Widgets/Utils.vala"
			break;
#line 1202 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Left:
#line 1206 "Utils.c"
		{
			gchar* _tmp10_;
#line 110 "../lib/Widgets/Utils.vala"
			_tmp10_ = g_strdup ("←");
#line 110 "../lib/Widgets/Utils.vala"
			_vala_array_add10 (&arr, &arr_length1, &_arr_size_, _tmp10_);
#line 111 "../lib/Widgets/Utils.vala"
			break;
#line 1215 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Right:
#line 1219 "Utils.c"
		{
			gchar* _tmp11_;
#line 113 "../lib/Widgets/Utils.vala"
			_tmp11_ = g_strdup ("→");
#line 113 "../lib/Widgets/Utils.vala"
			_vala_array_add11 (&arr, &arr_length1, &_arr_size_, _tmp11_);
#line 114 "../lib/Widgets/Utils.vala"
			break;
#line 1228 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Alt_L:
#line 1232 "Utils.c"
		{
			gchar* _tmp12_;
#line 117 "../lib/Widgets/Utils.vala"
			_tmp12_ = g_strdup (_ ("Left Alt"));
#line 117 "../lib/Widgets/Utils.vala"
			_vala_array_add12 (&arr, &arr_length1, &_arr_size_, _tmp12_);
#line 118 "../lib/Widgets/Utils.vala"
			break;
#line 1241 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Alt_R:
#line 1245 "Utils.c"
		{
			gchar* _tmp13_;
#line 121 "../lib/Widgets/Utils.vala"
			_tmp13_ = g_strdup (_ ("Right Alt"));
#line 121 "../lib/Widgets/Utils.vala"
			_vala_array_add13 (&arr, &arr_length1, &_arr_size_, _tmp13_);
#line 122 "../lib/Widgets/Utils.vala"
			break;
#line 1254 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_backslash:
#line 1258 "Utils.c"
		{
			gchar* _tmp14_;
#line 124 "../lib/Widgets/Utils.vala"
			_tmp14_ = g_strdup ("\\");
#line 124 "../lib/Widgets/Utils.vala"
			_vala_array_add14 (&arr, &arr_length1, &_arr_size_, _tmp14_);
#line 125 "../lib/Widgets/Utils.vala"
			break;
#line 1267 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Control_R:
#line 1271 "Utils.c"
		{
			gchar* _tmp15_;
#line 128 "../lib/Widgets/Utils.vala"
			_tmp15_ = g_strdup (_ ("Right Ctrl"));
#line 128 "../lib/Widgets/Utils.vala"
			_vala_array_add15 (&arr, &arr_length1, &_arr_size_, _tmp15_);
#line 129 "../lib/Widgets/Utils.vala"
			break;
#line 1280 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Control_L:
#line 1284 "Utils.c"
		{
			gchar* _tmp16_;
#line 132 "../lib/Widgets/Utils.vala"
			_tmp16_ = g_strdup (_ ("Left Ctrl"));
#line 132 "../lib/Widgets/Utils.vala"
			_vala_array_add16 (&arr, &arr_length1, &_arr_size_, _tmp16_);
#line 133 "../lib/Widgets/Utils.vala"
			break;
#line 1293 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_minus:
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_KP_Subtract:
#line 1299 "Utils.c"
		{
			gchar* _tmp17_;
#line 137 "../lib/Widgets/Utils.vala"
			_tmp17_ = g_strdup (_ ("Minus"));
#line 137 "../lib/Widgets/Utils.vala"
			_vala_array_add17 (&arr, &arr_length1, &_arr_size_, _tmp17_);
#line 138 "../lib/Widgets/Utils.vala"
			break;
#line 1308 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_KP_Add:
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_plus:
#line 1314 "Utils.c"
		{
			gchar* _tmp18_;
#line 142 "../lib/Widgets/Utils.vala"
			_tmp18_ = g_strdup (_ ("Plus"));
#line 142 "../lib/Widgets/Utils.vala"
			_vala_array_add18 (&arr, &arr_length1, &_arr_size_, _tmp18_);
#line 143 "../lib/Widgets/Utils.vala"
			break;
#line 1323 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_KP_Equal:
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_equal:
#line 1329 "Utils.c"
		{
			gchar* _tmp19_;
#line 147 "../lib/Widgets/Utils.vala"
			_tmp19_ = g_strdup (_ ("Equals"));
#line 147 "../lib/Widgets/Utils.vala"
			_vala_array_add19 (&arr, &arr_length1, &_arr_size_, _tmp19_);
#line 148 "../lib/Widgets/Utils.vala"
			break;
#line 1338 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Return:
#line 1342 "Utils.c"
		{
			gchar* _tmp20_;
#line 150 "../lib/Widgets/Utils.vala"
			_tmp20_ = g_strdup (_ ("Enter"));
#line 150 "../lib/Widgets/Utils.vala"
			_vala_array_add20 (&arr, &arr_length1, &_arr_size_, _tmp20_);
#line 151 "../lib/Widgets/Utils.vala"
			break;
#line 1351 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Shift_L:
#line 1355 "Utils.c"
		{
			gchar* _tmp21_;
#line 154 "../lib/Widgets/Utils.vala"
			_tmp21_ = g_strdup (_ ("Left Shift"));
#line 154 "../lib/Widgets/Utils.vala"
			_vala_array_add21 (&arr, &arr_length1, &_arr_size_, _tmp21_);
#line 155 "../lib/Widgets/Utils.vala"
			break;
#line 1364 "Utils.c"
		}
#line 102 "../lib/Widgets/Utils.vala"
		case GDK_KEY_Shift_R:
#line 1368 "Utils.c"
		{
			gchar* _tmp22_;
#line 158 "../lib/Widgets/Utils.vala"
			_tmp22_ = g_strdup (_ ("Right Shift"));
#line 158 "../lib/Widgets/Utils.vala"
			_vala_array_add22 (&arr, &arr_length1, &_arr_size_, _tmp22_);
#line 159 "../lib/Widgets/Utils.vala"
			break;
#line 1377 "Utils.c"
		}
		default:
		{
			gchar* accel_label = NULL;
			gchar* _tmp23_;
			const gchar* _tmp24_;
#line 163 "../lib/Widgets/Utils.vala"
			_tmp23_ = gtk_accelerator_get_label (accel_key, 0);
#line 163 "../lib/Widgets/Utils.vala"
			accel_label = _tmp23_;
#line 164 "../lib/Widgets/Utils.vala"
			_tmp24_ = accel_label;
#line 164 "../lib/Widgets/Utils.vala"
			if (g_strcmp0 (_tmp24_, "") != 0) {
#line 1392 "Utils.c"
				const gchar* _tmp25_;
				gchar* _tmp26_;
#line 165 "../lib/Widgets/Utils.vala"
				_tmp25_ = accel_label;
#line 165 "../lib/Widgets/Utils.vala"
				_tmp26_ = g_strdup (_tmp25_);
#line 165 "../lib/Widgets/Utils.vala"
				_vala_array_add23 (&arr, &arr_length1, &_arr_size_, _tmp26_);
#line 1401 "Utils.c"
			}
#line 167 "../lib/Widgets/Utils.vala"
			_g_free0 (accel_label);
#line 167 "../lib/Widgets/Utils.vala"
			break;
#line 1407 "Utils.c"
		}
	}
#line 170 "../lib/Widgets/Utils.vala"
	if (accel_mods != 0) {
#line 1412 "Utils.c"
		gchar** _tmp27_;
		gint _tmp27__length1;
		gchar* _tmp28_;
#line 171 "../lib/Widgets/Utils.vala"
		_tmp27_ = arr;
#line 171 "../lib/Widgets/Utils.vala"
		_tmp27__length1 = arr_length1;
#line 171 "../lib/Widgets/Utils.vala"
		_tmp28_ = _vala_g_strjoinv (" + ", _tmp27_, (gint) _tmp27__length1);
#line 171 "../lib/Widgets/Utils.vala"
		result = _tmp28_;
#line 171 "../lib/Widgets/Utils.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 171 "../lib/Widgets/Utils.vala"
		return result;
#line 1428 "Utils.c"
	}
#line 174 "../lib/Widgets/Utils.vala"
	_tmp29_ = arr;
#line 174 "../lib/Widgets/Utils.vala"
	_tmp29__length1 = arr_length1;
#line 174 "../lib/Widgets/Utils.vala"
	_tmp30_ = _tmp29_[0];
#line 174 "../lib/Widgets/Utils.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 174 "../lib/Widgets/Utils.vala"
	result = _tmp31_;
#line 174 "../lib/Widgets/Utils.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 174 "../lib/Widgets/Utils.vala"
	return result;
#line 1444 "Utils.c"
}

/**
 * Takes a description and an array of accels and returns {@link Pango} markup for use in a {@link Gtk.Tooltip}. This method uses {@link Granite.accel_to_string}.
 *
 * Example:
 *
 * Description
 * Shortcut 1, Shortcut 2
 *
 * @param a string array of accelerator labels like {"<Control>a", "<Super>Right"}
 *
 * @param description a standard tooltip text string
 *
 * @return {@link Pango} markup with the description label on one line and a list of human-readable accels on a new line
 */
static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 199 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 199 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 199 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1473 "Utils.c"
	}
#line 199 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 199 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 1479 "Utils.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 214 "../lib/Widgets/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 214 "../lib/Widgets/Utils.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 214 "../lib/Widgets/Utils.vala"
			return TRUE;
#line 1494 "Utils.c"
		}
	}
#line 214 "../lib/Widgets/Utils.vala"
	return FALSE;
#line 1499 "Utils.c"
}

static void
_vala_array_add25 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 215 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 215 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 215 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1514 "Utils.c"
	}
#line 215 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 215 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 1520 "Utils.c"
}

static void
_vala_array_add26 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 225 "../lib/Widgets/Utils.vala"
	if ((*length) == (*size)) {
#line 225 "../lib/Widgets/Utils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 225 "../lib/Widgets/Utils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1535 "Utils.c"
	}
#line 225 "../lib/Widgets/Utils.vala"
	(*array)[(*length)++] = value;
#line 225 "../lib/Widgets/Utils.vala"
	(*array)[*length] = NULL;
#line 1541 "Utils.c"
}

gchar*
granite_markup_accel_tooltip (gchar** accels,
                              gint accels_length1,
                              const gchar* description)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gint parts_length1;
	gint _parts_size_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp22_;
	gchar* result;
#line 197 "../lib/Widgets/Utils.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 197 "../lib/Widgets/Utils.vala"
	parts = _tmp0_;
#line 197 "../lib/Widgets/Utils.vala"
	parts_length1 = 0;
#line 197 "../lib/Widgets/Utils.vala"
	_parts_size_ = parts_length1;
#line 198 "../lib/Widgets/Utils.vala"
	if (description != NULL) {
#line 198 "../lib/Widgets/Utils.vala"
		_tmp1_ = g_strcmp0 (description, "") != 0;
#line 1571 "Utils.c"
	} else {
#line 198 "../lib/Widgets/Utils.vala"
		_tmp1_ = FALSE;
#line 1575 "Utils.c"
	}
#line 198 "../lib/Widgets/Utils.vala"
	if (_tmp1_) {
#line 1579 "Utils.c"
		gchar* _tmp2_;
#line 199 "../lib/Widgets/Utils.vala"
		_tmp2_ = g_strdup (description);
#line 199 "../lib/Widgets/Utils.vala"
		_vala_array_add24 (&parts, &parts_length1, &_parts_size_, _tmp2_);
#line 1585 "Utils.c"
	}
#line 202 "../lib/Widgets/Utils.vala"
	if (accels != NULL) {
#line 202 "../lib/Widgets/Utils.vala"
		_tmp3_ = accels_length1 > 0;
#line 1591 "Utils.c"
	} else {
#line 202 "../lib/Widgets/Utils.vala"
		_tmp3_ = FALSE;
#line 1595 "Utils.c"
	}
#line 202 "../lib/Widgets/Utils.vala"
	if (_tmp3_) {
#line 1599 "Utils.c"
		gchar** unique_accels = NULL;
		gchar** _tmp4_;
		gint unique_accels_length1;
		gint _unique_accels_size_;
		gchar** _tmp14_;
		gint _tmp14__length1;
#line 203 "../lib/Widgets/Utils.vala"
		_tmp4_ = g_new0 (gchar*, 0 + 1);
#line 203 "../lib/Widgets/Utils.vala"
		unique_accels = _tmp4_;
#line 203 "../lib/Widgets/Utils.vala"
		unique_accels_length1 = 0;
#line 203 "../lib/Widgets/Utils.vala"
		_unique_accels_size_ = unique_accels_length1;
#line 206 "../lib/Widgets/Utils.vala"
		granite_init ();
#line 1616 "Utils.c"
		{
			gint i = 0;
#line 208 "../lib/Widgets/Utils.vala"
			i = 0;
#line 1621 "Utils.c"
			{
				gboolean _tmp5_ = FALSE;
#line 208 "../lib/Widgets/Utils.vala"
				_tmp5_ = TRUE;
#line 208 "../lib/Widgets/Utils.vala"
				while (TRUE) {
#line 1628 "Utils.c"
					const gchar* _tmp7_;
					gchar* accel_string = NULL;
					const gchar* _tmp8_;
					gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar** _tmp11_;
					gint _tmp11__length1;
#line 208 "../lib/Widgets/Utils.vala"
					if (!_tmp5_) {
#line 1638 "Utils.c"
						gint _tmp6_;
#line 208 "../lib/Widgets/Utils.vala"
						_tmp6_ = i;
#line 208 "../lib/Widgets/Utils.vala"
						i = _tmp6_ + 1;
#line 1644 "Utils.c"
					}
#line 208 "../lib/Widgets/Utils.vala"
					_tmp5_ = FALSE;
#line 208 "../lib/Widgets/Utils.vala"
					if (!(i < accels_length1)) {
#line 208 "../lib/Widgets/Utils.vala"
						break;
#line 1652 "Utils.c"
					}
#line 209 "../lib/Widgets/Utils.vala"
					_tmp7_ = accels[i];
#line 209 "../lib/Widgets/Utils.vala"
					if (g_strcmp0 (_tmp7_, "") == 0) {
#line 210 "../lib/Widgets/Utils.vala"
						continue;
#line 1660 "Utils.c"
					}
#line 213 "../lib/Widgets/Utils.vala"
					_tmp8_ = accels[i];
#line 213 "../lib/Widgets/Utils.vala"
					_tmp9_ = granite_accel_to_string (_tmp8_);
#line 213 "../lib/Widgets/Utils.vala"
					accel_string = _tmp9_;
#line 214 "../lib/Widgets/Utils.vala"
					_tmp10_ = accel_string;
#line 214 "../lib/Widgets/Utils.vala"
					_tmp11_ = unique_accels;
#line 214 "../lib/Widgets/Utils.vala"
					_tmp11__length1 = unique_accels_length1;
#line 214 "../lib/Widgets/Utils.vala"
					if (!_vala_string_array_contains (_tmp11_, _tmp11__length1, _tmp10_)) {
#line 1676 "Utils.c"
						const gchar* _tmp12_;
						gchar* _tmp13_;
#line 215 "../lib/Widgets/Utils.vala"
						_tmp12_ = accel_string;
#line 215 "../lib/Widgets/Utils.vala"
						_tmp13_ = g_strdup (_tmp12_);
#line 215 "../lib/Widgets/Utils.vala"
						_vala_array_add25 (&unique_accels, &unique_accels_length1, &_unique_accels_size_, _tmp13_);
#line 1685 "Utils.c"
					}
#line 208 "../lib/Widgets/Utils.vala"
					_g_free0 (accel_string);
#line 1689 "Utils.c"
				}
			}
		}
#line 219 "../lib/Widgets/Utils.vala"
		_tmp14_ = unique_accels;
#line 219 "../lib/Widgets/Utils.vala"
		_tmp14__length1 = unique_accels_length1;
#line 219 "../lib/Widgets/Utils.vala"
		if (_tmp14__length1 > 0) {
#line 1699 "Utils.c"
			gchar* accel_label = NULL;
			gchar** _tmp15_;
			gint _tmp15__length1;
			gchar* _tmp16_;
			gchar* accel_markup = NULL;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 221 "../lib/Widgets/Utils.vala"
			_tmp15_ = unique_accels;
#line 221 "../lib/Widgets/Utils.vala"
			_tmp15__length1 = unique_accels_length1;
#line 221 "../lib/Widgets/Utils.vala"
			_tmp16_ = _vala_g_strjoinv (_ (", "), _tmp15_, (gint) _tmp15__length1);
#line 221 "../lib/Widgets/Utils.vala"
			accel_label = _tmp16_;
#line 223 "../lib/Widgets/Utils.vala"
			_tmp17_ = accel_label;
#line 223 "../lib/Widgets/Utils.vala"
			_tmp18_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp17_);
#line 223 "../lib/Widgets/Utils.vala"
			accel_markup = _tmp18_;
#line 225 "../lib/Widgets/Utils.vala"
			_tmp19_ = accel_markup;
#line 225 "../lib/Widgets/Utils.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 225 "../lib/Widgets/Utils.vala"
			_vala_array_add26 (&parts, &parts_length1, &_parts_size_, _tmp20_);
#line 219 "../lib/Widgets/Utils.vala"
			_g_free0 (accel_markup);
#line 219 "../lib/Widgets/Utils.vala"
			_g_free0 (accel_label);
#line 1733 "Utils.c"
		}
#line 202 "../lib/Widgets/Utils.vala"
		unique_accels = (_vala_array_free (unique_accels, unique_accels_length1, (GDestroyNotify) g_free), NULL);
#line 1737 "Utils.c"
	}
#line 229 "../lib/Widgets/Utils.vala"
	_tmp21_ = parts;
#line 229 "../lib/Widgets/Utils.vala"
	_tmp21__length1 = parts_length1;
#line 229 "../lib/Widgets/Utils.vala"
	_tmp22_ = _vala_g_strjoinv ("\n", _tmp21_, (gint) _tmp21__length1);
#line 229 "../lib/Widgets/Utils.vala"
	result = _tmp22_;
#line 229 "../lib/Widgets/Utils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 229 "../lib/Widgets/Utils.vala"
	return result;
#line 1751 "Utils.c"
}

 G_GNUC_INTERNAL gdouble
granite_contrast_ratio (GdkRGBA* bg_color,
                        GdkRGBA* fg_color)
{
	gdouble bg_luminance = 0.0;
	GdkRGBA _tmp0_;
	gdouble fg_luminance = 0.0;
	GdkRGBA _tmp1_;
	gdouble result;
#line 232 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (bg_color != NULL, 0.0);
#line 232 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (fg_color != NULL, 0.0);
#line 234 "../lib/Widgets/Utils.vala"
	_tmp0_ = *bg_color;
#line 234 "../lib/Widgets/Utils.vala"
	bg_luminance = granite_get_luminance (&_tmp0_);
#line 235 "../lib/Widgets/Utils.vala"
	_tmp1_ = *fg_color;
#line 235 "../lib/Widgets/Utils.vala"
	fg_luminance = granite_get_luminance (&_tmp1_);
#line 237 "../lib/Widgets/Utils.vala"
	if (bg_luminance > fg_luminance) {
#line 238 "../lib/Widgets/Utils.vala"
		result = (bg_luminance + 0.05) / (fg_luminance + 0.05);
#line 238 "../lib/Widgets/Utils.vala"
		return result;
#line 1781 "Utils.c"
	}
#line 241 "../lib/Widgets/Utils.vala"
	result = (fg_luminance + 0.05) / (bg_luminance + 0.05);
#line 241 "../lib/Widgets/Utils.vala"
	return result;
#line 1787 "Utils.c"
}

 G_GNUC_INTERNAL gdouble
granite_get_luminance (GdkRGBA* color)
{
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	gdouble result;
#line 244 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (color != NULL, 0.0);
#line 246 "../lib/Widgets/Utils.vala"
	_tmp0_ = *color;
#line 246 "../lib/Widgets/Utils.vala"
	red = granite_sanitize_color (_tmp0_.red) * 0.2126;
#line 247 "../lib/Widgets/Utils.vala"
	_tmp1_ = *color;
#line 247 "../lib/Widgets/Utils.vala"
	green = granite_sanitize_color (_tmp1_.green) * 0.7152;
#line 248 "../lib/Widgets/Utils.vala"
	_tmp2_ = *color;
#line 248 "../lib/Widgets/Utils.vala"
	blue = granite_sanitize_color (_tmp2_.blue) * 0.0722;
#line 250 "../lib/Widgets/Utils.vala"
	result = (red + green) + blue;
#line 250 "../lib/Widgets/Utils.vala"
	return result;
#line 1818 "Utils.c"
}

 G_GNUC_INTERNAL gdouble
granite_sanitize_color (gdouble color)
{
	gdouble result;
#line 255 "../lib/Widgets/Utils.vala"
	if (color <= 0.03928) {
#line 256 "../lib/Widgets/Utils.vala"
		result = color / 12.92;
#line 256 "../lib/Widgets/Utils.vala"
		return result;
#line 1831 "Utils.c"
	}
#line 259 "../lib/Widgets/Utils.vala"
	result = pow ((color + 0.055) / 1.055, 2.4);
#line 259 "../lib/Widgets/Utils.vala"
	return result;
#line 1837 "Utils.c"
}

/**
 * Takes a {@link Gdk.RGBA} background color and returns a suitably-contrasting foreground color, i.e. for determining text color on a colored background. There is a slight bias toward returning white, as white generally looks better on a wider range of colored backgrounds than black.
 *
 * @param bg_color any {@link Gdk.RGBA} background color
 *
 * @return a contrasting {@link Gdk.RGBA} foreground color, i.e. white ({ 1.0, 1.0, 1.0, 1.0}) or black ({ 0.0, 0.0, 0.0, 1.0}).
 */
void
granite_contrasting_foreground_color (GdkRGBA* bg_color,
                                      GdkRGBA* result)
{
	GdkRGBA gdk_white = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA gdk_black = {0};
	GdkRGBA _tmp1_ = {0};
	gdouble contrast_with_white = 0.0;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	gdouble contrast_with_black = 0.0;
	GdkRGBA _tmp4_;
	GdkRGBA _tmp5_;
	GdkRGBA fg_color = {0};
	GdkRGBA _tmp6_;
#line 269 "../lib/Widgets/Utils.vala"
	g_return_if_fail (bg_color != NULL);
#line 270 "../lib/Widgets/Utils.vala"
	_tmp0_.red = 1.0;
#line 270 "../lib/Widgets/Utils.vala"
	_tmp0_.green = 1.0;
#line 270 "../lib/Widgets/Utils.vala"
	_tmp0_.blue = 1.0;
#line 270 "../lib/Widgets/Utils.vala"
	_tmp0_.alpha = 1.0;
#line 270 "../lib/Widgets/Utils.vala"
	gdk_white = _tmp0_;
#line 271 "../lib/Widgets/Utils.vala"
	_tmp1_.red = 0.0;
#line 271 "../lib/Widgets/Utils.vala"
	_tmp1_.green = 0.0;
#line 271 "../lib/Widgets/Utils.vala"
	_tmp1_.blue = 0.0;
#line 271 "../lib/Widgets/Utils.vala"
	_tmp1_.alpha = 1.0;
#line 271 "../lib/Widgets/Utils.vala"
	gdk_black = _tmp1_;
#line 273 "../lib/Widgets/Utils.vala"
	_tmp2_ = *bg_color;
#line 273 "../lib/Widgets/Utils.vala"
	_tmp3_ = gdk_white;
#line 273 "../lib/Widgets/Utils.vala"
	contrast_with_white = granite_contrast_ratio (&_tmp2_, &_tmp3_);
#line 277 "../lib/Widgets/Utils.vala"
	_tmp4_ = *bg_color;
#line 277 "../lib/Widgets/Utils.vala"
	_tmp5_ = gdk_black;
#line 277 "../lib/Widgets/Utils.vala"
	contrast_with_black = granite_contrast_ratio (&_tmp4_, &_tmp5_);
#line 283 "../lib/Widgets/Utils.vala"
	_tmp6_ = gdk_white;
#line 283 "../lib/Widgets/Utils.vala"
	fg_color = _tmp6_;
#line 287 "../lib/Widgets/Utils.vala"
	if (contrast_with_black > (contrast_with_white + 3)) {
#line 1903 "Utils.c"
		GdkRGBA _tmp7_;
#line 288 "../lib/Widgets/Utils.vala"
		_tmp7_ = gdk_black;
#line 288 "../lib/Widgets/Utils.vala"
		fg_color = _tmp7_;
#line 1909 "Utils.c"
	}
#line 291 "../lib/Widgets/Utils.vala"
	*result = fg_color;
#line 291 "../lib/Widgets/Utils.vala"
	return;
#line 1915 "Utils.c"
}

/**
     * Applies colorPrimary property to the window. The colorPrimary property currently changes
     * the color of the {@link Gtk.HeaderBar} and it's children so that the application window
     * can have a so-called "brand color".
     *
     * Note that this currently only works with the default stylesheet that elementary OS uses.
     *
     * @param window the widget to apply the color, for most cases the widget will be actually the {@link Gtk.Window} itself
     * @param color the color to apply
     * @param priority priorty of change, by default {@link Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION}
     *
     * @return the added {@link Gtk.CssProvider}, or null in case the parsing of
     *         stylesheet failed.
     */
GtkCssProvider*
granite_widgets_utils_set_color_primary (GtkWidget* window,
                                         GdkRGBA* color,
                                         gint priority)
{
	gchar* hex = NULL;
	gchar* _tmp0_;
	GdkScreen* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkCssProvider* _tmp6_;
	GtkCssProvider* _tmp7_;
	GtkCssProvider* result;
#line 314 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 314 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 319 "../lib/Widgets/Utils.vala"
	_vala_assert (window != NULL, "window != null");
#line 321 "../lib/Widgets/Utils.vala"
	_tmp0_ = gdk_rgba_to_string (color);
#line 321 "../lib/Widgets/Utils.vala"
	hex = _tmp0_;
#line 322 "../lib/Widgets/Utils.vala"
	_tmp1_ = gtk_widget_get_screen (window);
#line 322 "../lib/Widgets/Utils.vala"
	_tmp2_ = string_to_string (hex);
#line 322 "../lib/Widgets/Utils.vala"
	_tmp3_ = string_to_string (hex);
#line 322 "../lib/Widgets/Utils.vala"
	_tmp4_ = g_strconcat ("@define-color color_primary ", _tmp2_, ";@define-color colorPrimary ", _tmp3_, ";", NULL);
#line 322 "../lib/Widgets/Utils.vala"
	_tmp5_ = _tmp4_;
#line 322 "../lib/Widgets/Utils.vala"
	_tmp6_ = granite_widgets_utils_set_theming_for_screen (_tmp1_, _tmp5_, priority);
#line 322 "../lib/Widgets/Utils.vala"
	_tmp7_ = _tmp6_;
#line 322 "../lib/Widgets/Utils.vala"
	_g_free0 (_tmp5_);
#line 322 "../lib/Widgets/Utils.vala"
	result = _tmp7_;
#line 322 "../lib/Widgets/Utils.vala"
	_g_free0 (hex);
#line 322 "../lib/Widgets/Utils.vala"
	return result;
#line 1979 "Utils.c"
}

/**
     * Applies the //stylesheet// to the widget.
     *
     * @param widget widget to apply style to
     * @param stylesheet CSS style to apply to the widget
     * @param class_name class name to add style to, pass null if no class should be applied to the //widget//
     * @param priority priorty of change, for most cases this will be {@link Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION}
     *
     * @return the {@link Gtk.CssProvider} that was applied to the //widget//.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 340 "../lib/Widgets/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 1997 "Utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 2018 "Utils.c"
}

GtkCssProvider*
granite_widgets_utils_set_theming (GtkWidget* widget,
                                   const gchar* stylesheet,
                                   const gchar* class_name,
                                   gint priority)
{
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
	gboolean _tmp6_ = FALSE;
	GtkCssProvider* result;
#line 336 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 336 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (stylesheet != NULL, NULL);
#line 338 "../lib/Widgets/Utils.vala"
	_tmp0_ = granite_widgets_utils_get_css_provider (stylesheet);
#line 338 "../lib/Widgets/Utils.vala"
	css_provider = _tmp0_;
#line 340 "../lib/Widgets/Utils.vala"
	_tmp1_ = gtk_widget_get_style_context (widget);
#line 340 "../lib/Widgets/Utils.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 340 "../lib/Widgets/Utils.vala"
	context = _tmp2_;
#line 342 "../lib/Widgets/Utils.vala"
	_tmp3_ = css_provider;
#line 342 "../lib/Widgets/Utils.vala"
	if (_tmp3_ != NULL) {
#line 2053 "Utils.c"
		GtkStyleContext* _tmp4_;
		GtkCssProvider* _tmp5_;
#line 343 "../lib/Widgets/Utils.vala"
		_tmp4_ = context;
#line 343 "../lib/Widgets/Utils.vala"
		_tmp5_ = css_provider;
#line 343 "../lib/Widgets/Utils.vala"
		gtk_style_context_add_provider (_tmp4_, (GtkStyleProvider*) _tmp5_, (guint) priority);
#line 2062 "Utils.c"
	}
#line 345 "../lib/Widgets/Utils.vala"
	if (class_name != NULL) {
#line 2066 "Utils.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 345 "../lib/Widgets/Utils.vala"
		_tmp7_ = string_strip (class_name);
#line 345 "../lib/Widgets/Utils.vala"
		_tmp8_ = _tmp7_;
#line 345 "../lib/Widgets/Utils.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "") != 0;
#line 345 "../lib/Widgets/Utils.vala"
		_g_free0 (_tmp8_);
#line 2077 "Utils.c"
	} else {
#line 345 "../lib/Widgets/Utils.vala"
		_tmp6_ = FALSE;
#line 2081 "Utils.c"
	}
#line 345 "../lib/Widgets/Utils.vala"
	if (_tmp6_) {
#line 2085 "Utils.c"
		GtkStyleContext* _tmp9_;
#line 346 "../lib/Widgets/Utils.vala"
		_tmp9_ = context;
#line 346 "../lib/Widgets/Utils.vala"
		gtk_style_context_add_class (_tmp9_, class_name);
#line 2091 "Utils.c"
	}
#line 348 "../lib/Widgets/Utils.vala"
	result = css_provider;
#line 348 "../lib/Widgets/Utils.vala"
	_g_object_unref0 (context);
#line 348 "../lib/Widgets/Utils.vala"
	return result;
#line 2099 "Utils.c"
}

/**
     * Applies a stylesheet to the given //screen//. This will affect all the
     * widgets which are part of that screen.
     *
     * @param screen screen to apply style to, use {@link Gtk.Widget.get_screen} in order to get the screen that the widget is on
     * @param stylesheet CSS style to apply to screen
     * @param priority priorty of change, for most cases this will be {@link Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION}
     *
     * @return the {@link Gtk.CssProvider} that was applied to the //screen//.
     */
GtkCssProvider*
granite_widgets_utils_set_theming_for_screen (GdkScreen* screen,
                                              const gchar* stylesheet,
                                              gint priority)
{
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* result;
#line 362 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (screen != NULL, NULL);
#line 362 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (stylesheet != NULL, NULL);
#line 363 "../lib/Widgets/Utils.vala"
	_tmp0_ = granite_widgets_utils_get_css_provider (stylesheet);
#line 363 "../lib/Widgets/Utils.vala"
	css_provider = _tmp0_;
#line 365 "../lib/Widgets/Utils.vala"
	_tmp1_ = css_provider;
#line 365 "../lib/Widgets/Utils.vala"
	if (_tmp1_ != NULL) {
#line 2133 "Utils.c"
		GtkCssProvider* _tmp2_;
#line 366 "../lib/Widgets/Utils.vala"
		_tmp2_ = css_provider;
#line 366 "../lib/Widgets/Utils.vala"
		gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) _tmp2_, (guint) priority);
#line 2139 "Utils.c"
	}
#line 368 "../lib/Widgets/Utils.vala"
	result = css_provider;
#line 368 "../lib/Widgets/Utils.vala"
	return result;
#line 2145 "Utils.c"
}

/**
     * Constructs a new {@link Gtk.CssProvider} that will store the //stylesheet// data.
     * This function uses {@link Gtk.CssProvider.load_from_data} internally so if this method fails
     * then a warning will be thrown and null returned as a result.
     *
     * @param stylesheet CSS style to apply to the returned provider
     *
     * @return a new {@link Gtk.CssProvider}, or null in case the parsing of
     *         //stylesheet// failed.
     */
GtkCssProvider*
granite_widgets_utils_get_css_provider (const gchar* stylesheet)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
	GtkCssProvider* result;
#line 382 "../lib/Widgets/Utils.vala"
	g_return_val_if_fail (stylesheet != NULL, NULL);
#line 383 "../lib/Widgets/Utils.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 383 "../lib/Widgets/Utils.vala"
	provider = _tmp0_;
#line 2171 "Utils.c"
	{
		GtkCssProvider* _tmp1_;
#line 386 "../lib/Widgets/Utils.vala"
		_tmp1_ = provider;
#line 386 "../lib/Widgets/Utils.vala"
		gtk_css_provider_load_from_data (_tmp1_, stylesheet, (gssize) -1, &_inner_error0_);
#line 386 "../lib/Widgets/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2180 "Utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 385 "../lib/Widgets/Utils.vala"
		e = _inner_error0_;
#line 385 "../lib/Widgets/Utils.vala"
		_inner_error0_ = NULL;
#line 389 "../lib/Widgets/Utils.vala"
		_tmp2_ = e;
#line 389 "../lib/Widgets/Utils.vala"
		_tmp3_ = _tmp2_->message;
#line 389 "../lib/Widgets/Utils.vala"
		g_warning ("Utils.vala:389: Could not create CSS Provider: %s\nStylesheet:\n%s", _tmp3_, stylesheet);
#line 391 "../lib/Widgets/Utils.vala"
		result = NULL;
#line 391 "../lib/Widgets/Utils.vala"
		_g_error_free0 (e);
#line 391 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (provider);
#line 391 "../lib/Widgets/Utils.vala"
		return result;
#line 2208 "Utils.c"
	}
	__finally0:
#line 385 "../lib/Widgets/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (provider);
#line 385 "../lib/Widgets/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 385 "../lib/Widgets/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 385 "../lib/Widgets/Utils.vala"
		return NULL;
#line 2221 "Utils.c"
	}
#line 394 "../lib/Widgets/Utils.vala"
	result = provider;
#line 394 "../lib/Widgets/Utils.vala"
	return result;
#line 2227 "Utils.c"
}

/**
     * This method applies given text style to given label
     *
     * @param text_style text style to apply
     * @param label label to apply style to
     */
void
granite_widgets_utils_apply_text_style_to_label (GraniteTextStyle text_style,
                                                 GtkLabel* label)
{
	GtkCssProvider* style_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	gchar* style_class = NULL;
	gchar* stylesheet = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GtkStyleContext* _tmp5_;
	const gchar* _tmp6_;
	GtkStyleContext* _tmp11_;
	GtkCssProvider* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 404 "../lib/Widgets/Utils.vala"
	g_return_if_fail (label != NULL);
#line 405 "../lib/Widgets/Utils.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 405 "../lib/Widgets/Utils.vala"
	style_provider = _tmp0_;
#line 406 "../lib/Widgets/Utils.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) label);
#line 406 "../lib/Widgets/Utils.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 406 "../lib/Widgets/Utils.vala"
	style_context = _tmp2_;
#line 409 "../lib/Widgets/Utils.vala"
	_tmp4_ = granite_text_style_get_stylesheet (text_style, &_tmp3_);
#line 409 "../lib/Widgets/Utils.vala"
	_g_free0 (style_class);
#line 409 "../lib/Widgets/Utils.vala"
	style_class = _tmp3_;
#line 409 "../lib/Widgets/Utils.vala"
	_g_free0 (stylesheet);
#line 409 "../lib/Widgets/Utils.vala"
	stylesheet = _tmp4_;
#line 410 "../lib/Widgets/Utils.vala"
	_tmp5_ = style_context;
#line 410 "../lib/Widgets/Utils.vala"
	_tmp6_ = style_class;
#line 410 "../lib/Widgets/Utils.vala"
	gtk_style_context_add_class (_tmp5_, _tmp6_);
#line 2282 "Utils.c"
	{
		GtkCssProvider* _tmp7_;
		const gchar* _tmp8_;
#line 413 "../lib/Widgets/Utils.vala"
		_tmp7_ = style_provider;
#line 413 "../lib/Widgets/Utils.vala"
		_tmp8_ = stylesheet;
#line 413 "../lib/Widgets/Utils.vala"
		gtk_css_provider_load_from_data (_tmp7_, _tmp8_, (gssize) -1, &_inner_error0_);
#line 413 "../lib/Widgets/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2294 "Utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 412 "../lib/Widgets/Utils.vala"
		err = _inner_error0_;
#line 412 "../lib/Widgets/Utils.vala"
		_inner_error0_ = NULL;
#line 415 "../lib/Widgets/Utils.vala"
		_tmp9_ = err;
#line 415 "../lib/Widgets/Utils.vala"
		_tmp10_ = _tmp9_->message;
#line 415 "../lib/Widgets/Utils.vala"
		g_warning ("Utils.vala:415: Couldn't apply style to label: %s", _tmp10_);
#line 416 "../lib/Widgets/Utils.vala"
		_g_error_free0 (err);
#line 416 "../lib/Widgets/Utils.vala"
		_g_free0 (stylesheet);
#line 416 "../lib/Widgets/Utils.vala"
		_g_free0 (style_class);
#line 416 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (style_context);
#line 416 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (style_provider);
#line 416 "../lib/Widgets/Utils.vala"
		return;
#line 2326 "Utils.c"
	}
	__finally0:
#line 412 "../lib/Widgets/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "../lib/Widgets/Utils.vala"
		_g_free0 (stylesheet);
#line 412 "../lib/Widgets/Utils.vala"
		_g_free0 (style_class);
#line 412 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (style_context);
#line 412 "../lib/Widgets/Utils.vala"
		_g_object_unref0 (style_provider);
#line 412 "../lib/Widgets/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 412 "../lib/Widgets/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 412 "../lib/Widgets/Utils.vala"
		return;
#line 2345 "Utils.c"
	}
#line 419 "../lib/Widgets/Utils.vala"
	_tmp11_ = style_context;
#line 419 "../lib/Widgets/Utils.vala"
	_tmp12_ = style_provider;
#line 419 "../lib/Widgets/Utils.vala"
	gtk_style_context_add_provider (_tmp11_, (GtkStyleProvider*) _tmp12_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 404 "../lib/Widgets/Utils.vala"
	_g_free0 (stylesheet);
#line 404 "../lib/Widgets/Utils.vala"
	_g_free0 (style_class);
#line 404 "../lib/Widgets/Utils.vala"
	_g_object_unref0 (style_context);
#line 404 "../lib/Widgets/Utils.vala"
	_g_object_unref0 (style_provider);
#line 2361 "Utils.c"
}

/**
     * This method detects the close button position as configured for the window manager. If you
     * need to know when this key changed, it's best to listen on the schema returned by
     * {@link Granite.Widgets.Utils.get_button_layout_schema} for changes and then call this method again.
     *
     * @param position a {@link Granite.CloseButtonPosition} indicating where to best put the close button
     * @return if no schema was detected by {@link Granite.Widgets.Utils.get_button_layout_schema}
     *         or there was no close value in the button-layout string, false will be returned. The position
     *         will be LEFT in that case.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 2390 "Utils.c"
}

gboolean
granite_widgets_utils_get_default_close_button_position (GraniteCloseButtonPosition* position)
{
	GraniteCloseButtonPosition _vala_position = 0;
	gchar* schema = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* layout = NULL;
	const gchar* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** parts = NULL;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gboolean result;
#line 439 "../lib/Widgets/Utils.vala"
	_vala_position = GRANITE_CLOSE_BUTTON_POSITION_LEFT;
#line 441 "../lib/Widgets/Utils.vala"
	_tmp0_ = granite_widgets_utils_get_button_layout_schema ();
#line 441 "../lib/Widgets/Utils.vala"
	schema = _tmp0_;
#line 442 "../lib/Widgets/Utils.vala"
	_tmp1_ = schema;
#line 442 "../lib/Widgets/Utils.vala"
	if (_tmp1_ == NULL) {
#line 443 "../lib/Widgets/Utils.vala"
		result = FALSE;
#line 443 "../lib/Widgets/Utils.vala"
		_g_free0 (schema);
#line 443 "../lib/Widgets/Utils.vala"
		if (position) {
#line 443 "../lib/Widgets/Utils.vala"
			*position = _vala_position;
#line 2436 "Utils.c"
		}
#line 443 "../lib/Widgets/Utils.vala"
		return result;
#line 2440 "Utils.c"
	}
#line 446 "../lib/Widgets/Utils.vala"
	_tmp2_ = schema;
#line 446 "../lib/Widgets/Utils.vala"
	_tmp3_ = g_settings_new (_tmp2_);
#line 446 "../lib/Widgets/Utils.vala"
	_tmp4_ = _tmp3_;
#line 446 "../lib/Widgets/Utils.vala"
	_tmp5_ = g_settings_get_string (_tmp4_, GRANITE_WIDGETS_UTILS_WM_BUTTON_LAYOUT_KEY);
#line 446 "../lib/Widgets/Utils.vala"
	_tmp6_ = _tmp5_;
#line 446 "../lib/Widgets/Utils.vala"
	_g_object_unref0 (_tmp4_);
#line 446 "../lib/Widgets/Utils.vala"
	layout = _tmp6_;
#line 447 "../lib/Widgets/Utils.vala"
	_tmp7_ = layout;
#line 447 "../lib/Widgets/Utils.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ":", 0);
#line 447 "../lib/Widgets/Utils.vala"
	parts = _tmp9_;
#line 447 "../lib/Widgets/Utils.vala"
	parts_length1 = _vala_array_length (_tmp8_);
#line 447 "../lib/Widgets/Utils.vala"
	_parts_size_ = parts_length1;
#line 449 "../lib/Widgets/Utils.vala"
	_tmp10_ = parts;
#line 449 "../lib/Widgets/Utils.vala"
	_tmp10__length1 = parts_length1;
#line 449 "../lib/Widgets/Utils.vala"
	if (_tmp10__length1 < 2) {
#line 450 "../lib/Widgets/Utils.vala"
		result = FALSE;
#line 450 "../lib/Widgets/Utils.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 450 "../lib/Widgets/Utils.vala"
		_g_free0 (layout);
#line 450 "../lib/Widgets/Utils.vala"
		_g_free0 (schema);
#line 450 "../lib/Widgets/Utils.vala"
		if (position) {
#line 450 "../lib/Widgets/Utils.vala"
			*position = _vala_position;
#line 2484 "Utils.c"
		}
#line 450 "../lib/Widgets/Utils.vala"
		return result;
#line 2488 "Utils.c"
	}
#line 453 "../lib/Widgets/Utils.vala"
	_tmp11_ = parts;
#line 453 "../lib/Widgets/Utils.vala"
	_tmp11__length1 = parts_length1;
#line 453 "../lib/Widgets/Utils.vala"
	_tmp12_ = _tmp11_[0];
#line 453 "../lib/Widgets/Utils.vala"
	if (string_contains (_tmp12_, "close")) {
#line 454 "../lib/Widgets/Utils.vala"
		_vala_position = GRANITE_CLOSE_BUTTON_POSITION_LEFT;
#line 455 "../lib/Widgets/Utils.vala"
		result = TRUE;
#line 455 "../lib/Widgets/Utils.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 455 "../lib/Widgets/Utils.vala"
		_g_free0 (layout);
#line 455 "../lib/Widgets/Utils.vala"
		_g_free0 (schema);
#line 455 "../lib/Widgets/Utils.vala"
		if (position) {
#line 455 "../lib/Widgets/Utils.vala"
			*position = _vala_position;
#line 2512 "Utils.c"
		}
#line 455 "../lib/Widgets/Utils.vala"
		return result;
#line 2516 "Utils.c"
	} else {
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
#line 456 "../lib/Widgets/Utils.vala"
		_tmp13_ = parts;
#line 456 "../lib/Widgets/Utils.vala"
		_tmp13__length1 = parts_length1;
#line 456 "../lib/Widgets/Utils.vala"
		_tmp14_ = _tmp13_[1];
#line 456 "../lib/Widgets/Utils.vala"
		if (string_contains (_tmp14_, "close")) {
#line 457 "../lib/Widgets/Utils.vala"
			_vala_position = GRANITE_CLOSE_BUTTON_POSITION_RIGHT;
#line 458 "../lib/Widgets/Utils.vala"
			result = TRUE;
#line 458 "../lib/Widgets/Utils.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 458 "../lib/Widgets/Utils.vala"
			_g_free0 (layout);
#line 458 "../lib/Widgets/Utils.vala"
			_g_free0 (schema);
#line 458 "../lib/Widgets/Utils.vala"
			if (position) {
#line 458 "../lib/Widgets/Utils.vala"
				*position = _vala_position;
#line 2543 "Utils.c"
			}
#line 458 "../lib/Widgets/Utils.vala"
			return result;
#line 2547 "Utils.c"
		}
	}
#line 461 "../lib/Widgets/Utils.vala"
	result = FALSE;
#line 461 "../lib/Widgets/Utils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 461 "../lib/Widgets/Utils.vala"
	_g_free0 (layout);
#line 461 "../lib/Widgets/Utils.vala"
	_g_free0 (schema);
#line 461 "../lib/Widgets/Utils.vala"
	if (position) {
#line 461 "../lib/Widgets/Utils.vala"
		*position = _vala_position;
#line 2562 "Utils.c"
	}
#line 461 "../lib/Widgets/Utils.vala"
	return result;
#line 2566 "Utils.c"
}

/**
     * This methods returns the schema used by {@link Granite.Widgets.Utils.get_default_close_button_position}
     * to determine the close button placement. It will first check for the pantheon/gala schema and then fallback
     * to the default gnome one. If neither is available, null is returned. Make sure to check for this case,
     * as otherwise your program may crash on startup.
     *
     * @return the schema name. If the layout could not be determined, a warning will be thrown and null will be returned
     */
static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 474 "../lib/Widgets/Utils.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 2582 "Utils.c"
}

gchar*
granite_widgets_utils_get_button_layout_schema (void)
{
	GSettingsSchemaSource* sss = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchemaSource* _tmp1_;
	GSettingsSchemaSource* _tmp2_;
	gchar* result;
#line 474 "../lib/Widgets/Utils.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 474 "../lib/Widgets/Utils.vala"
	_tmp1_ = _g_settings_schema_source_ref0 (_tmp0_);
#line 474 "../lib/Widgets/Utils.vala"
	sss = _tmp1_;
#line 476 "../lib/Widgets/Utils.vala"
	_tmp2_ = sss;
#line 476 "../lib/Widgets/Utils.vala"
	if (_tmp2_ != NULL) {
#line 2603 "Utils.c"
		GSettingsSchemaSource* _tmp3_;
		GSettingsSchema* _tmp4_;
		GSettingsSchema* _tmp5_;
		gboolean _tmp6_;
#line 477 "../lib/Widgets/Utils.vala"
		_tmp3_ = sss;
#line 477 "../lib/Widgets/Utils.vala"
		_tmp4_ = g_settings_schema_source_lookup (_tmp3_, GRANITE_WIDGETS_UTILS_PANTHEON_SETTINGS_PATH, TRUE);
#line 477 "../lib/Widgets/Utils.vala"
		_tmp5_ = _tmp4_;
#line 477 "../lib/Widgets/Utils.vala"
		_tmp6_ = _tmp5_ != NULL;
#line 477 "../lib/Widgets/Utils.vala"
		_g_settings_schema_unref0 (_tmp5_);
#line 477 "../lib/Widgets/Utils.vala"
		if (_tmp6_) {
#line 2620 "Utils.c"
			gchar* _tmp7_;
#line 478 "../lib/Widgets/Utils.vala"
			_tmp7_ = g_strdup (GRANITE_WIDGETS_UTILS_PANTHEON_SETTINGS_PATH);
#line 478 "../lib/Widgets/Utils.vala"
			result = _tmp7_;
#line 478 "../lib/Widgets/Utils.vala"
			_g_settings_schema_source_unref0 (sss);
#line 478 "../lib/Widgets/Utils.vala"
			return result;
#line 2630 "Utils.c"
		} else {
			GSettingsSchemaSource* _tmp8_;
			GSettingsSchema* _tmp9_;
			GSettingsSchema* _tmp10_;
			gboolean _tmp11_;
#line 479 "../lib/Widgets/Utils.vala"
			_tmp8_ = sss;
#line 479 "../lib/Widgets/Utils.vala"
			_tmp9_ = g_settings_schema_source_lookup (_tmp8_, GRANITE_WIDGETS_UTILS_WM_SETTINGS_PATH, TRUE);
#line 479 "../lib/Widgets/Utils.vala"
			_tmp10_ = _tmp9_;
#line 479 "../lib/Widgets/Utils.vala"
			_tmp11_ = _tmp10_ != NULL;
#line 479 "../lib/Widgets/Utils.vala"
			_g_settings_schema_unref0 (_tmp10_);
#line 479 "../lib/Widgets/Utils.vala"
			if (_tmp11_) {
#line 2648 "Utils.c"
				gchar* _tmp12_;
#line 480 "../lib/Widgets/Utils.vala"
				_tmp12_ = g_strdup (GRANITE_WIDGETS_UTILS_WM_SETTINGS_PATH);
#line 480 "../lib/Widgets/Utils.vala"
				result = _tmp12_;
#line 480 "../lib/Widgets/Utils.vala"
				_g_settings_schema_source_unref0 (sss);
#line 480 "../lib/Widgets/Utils.vala"
				return result;
#line 2658 "Utils.c"
			}
		}
	}
#line 484 "../lib/Widgets/Utils.vala"
	g_warning ("Utils.vala:484: No schema indicating the button-layout is installed.");
#line 485 "../lib/Widgets/Utils.vala"
	result = NULL;
#line 485 "../lib/Widgets/Utils.vala"
	_g_settings_schema_source_unref0 (sss);
#line 485 "../lib/Widgets/Utils.vala"
	return result;
#line 2670 "Utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

